!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Allocates and initializes global arrays.

subroutine al00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero

  use numerical, only : sqrtmachprec, vsmall

  use fileunits, only : ounit, aunit

  use inputlist

  use cputiming

  use allglobal

  use pjhamilto, only : Itor, Gpol, spmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  LOGICAL   :: exist
  INTEGER   :: ix, ij, ik, ip, iq, jk, io, imn, jmn, kmn, lmn, llc, imnc, ipq, mnpq, mm, nn, ifail, ii, iofe, nc, imp, lvol, pp, qq
  INTEGER   :: jj, kk
  INTEGER   :: lMpol, lNtor, lNofe, lNi
  INTEGER   :: madd, nadd, msub, nsub, lNZ
  REAL      :: teta, zeta, arg
  INTEGER   :: totalradialresolution
  INTEGER   :: llmodnp

  BEGIN(al00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set / allocate internal variables that depend on namelist/physicslist/

  pi2nfp = pi2 / Nfp ; pi2pi2nfpquarter = pi2 * pi2nfp * quarter ! numerical constants;

! local  number of degrees of freedom in geometry; ignoring      imask;
  
  if( Lgeometry.le.3 ) nlocaldof = mn       
  if( Lgeometry.ge.4 ) nlocaldof = mn + mn-1
  
! global number of degrees of freedom in geometry; incorporating imask;

  mlocaldof = 0

  do imn = 1, mn

!  if( imask(imn).le.0 ) then ! zero all un-selected modes;
!  !if( myid.eq.0 ) write(ounit,'("al00aa : " 10x " : the (m,n)=("i3" ,"i3" ) will be ignored in Beltrami fields / geometry / force-balance ;")')im(imn),in(imn)
!   iRbc(0:Nvol,imn) = zero ; iZbs(0:Nvol,imn) = zero
!  endif

                                                             mlocaldof = mlocaldof + 1 ! count the relevant Rbc modes;
!  if( imask(imn).gt.0                                     ) mlocaldof = mlocaldof + 1 ! count the relevant Rbc modes;
   if(                       Lgeometry.ge.4 .and. imn.gt.1 ) mlocaldof = mlocaldof + 1 ! count the relevant Zbs modes;
!  if( imask(imn).gt.0 .and. Lgeometry.ge.4 .and. imn.gt.1 ) mlocaldof = mlocaldof + 1 ! count the relevant Zbs modes;

  enddo

  Ngdof = ( Nvol-1 ) * mlocaldof ! degrees of freedom in geometry;
  
! rotational transform on interfaces;
  
  do lvol = 0, Nvol
   if( ql(lvol).eq.0 .and. qr(lvol).eq.0 ) then ; iota(lvol) = iota(lvol) 
   else                                         ; iota(lvol) = ( pl(lvol) + goldmean * pr(lvol) ) / ( ql(lvol) + goldmean * qr(lvol) )
   endif
  enddo
  
! enclosed fluxes in each volume;

  RALLOCATE(dtflux,(1:Nvol))                       ! \delta \psi_{toroidal} in each annulus;
  RALLOCATE(dpflux,(1:Nvol))                       ! \delta \psi_{poloidal} in each annulus;

  dtflux(1:Nvol) = tflux(1:Nvol) - tflux(0:Nvol-1) ! it is the differential toroidal flux that controls the transform;
  dpflux(1:Nvol) = pflux(1:Nvol) - pflux(0:Nvol-1) ! it is the differential poloidal flux that controls the transform;

! error flag indicating successful construction of Beltrami fields in each volume;

  LALLOCATE(Lmp00ac,(1:Nvol))

  Lhessianallocated = .false.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set / allocate internal variables that depend on namelist/numericlist/

  if( Nquad.gt.0 ) then ; Iquad = Nquad
  else                  ; Iquad = 2 * Nofe + 3 - Nquad
  endif

 !if( iextrap.gt.0 .and. iextrap.le.Nvol ) then ; lextrap = iextrap
 !else                                          ; lextrap = Nvol
 !endif

  LCondenseSpectrum      = .false.

  if( Iswmin.eq.1 .or. Iswmin.eq.3 ) LCondenseSpectrum       = .true. ! initially convert interfaces to spectrally condensed angle;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set / allocate internal variables that depend on namelist/linearlist/

  LbeltramiLinear = .false.
  LbeltramiNewton = .false.
  LbeltramiSeQuad = .false.

  if( Lbeltrami.eq.1 .or. Lbeltrami.eq.3 .or. Lbeltrami.eq.5 .or. Lbeltrami.eq.7 ) LbeltramiLinear = .true.
  if( Lbeltrami.eq.2 .or. Lbeltrami.eq.3 .or. Lbeltrami.eq.6 .or. Lbeltrami.eq.7 ) LbeltramiNewton = .true.
  if( Lbeltrami.eq.4 .or. Lbeltrami.eq.5 .or. Lbeltrami.eq.6 .or. Lbeltrami.eq.7 ) LbeltramiSeQuad = .true.

  if( Ldense.eq.0 .or. Ldense.eq.2 ) Lsparsematrix = .true. ! will solve Beltrami linear system using sparse algorithms;
  if( Ldense.eq.1 .or. Ldense.eq.2 ) Ldensematrix  = .true.

  if( myid.eq.0 ) then
   cput = MPI_WTIME()
   write(ounit,'("al00aa : "f10.2" : LbeltramiLinear ="L2" , LbeltramiNewton ="L2" , LbeltramiSeQuad ="L2" ;")')cput-cpus, LbeltramiLinear, LbeltramiNewton, LbeltramiSeQuad
  endif

  Liotasparse   = .false. ! relates to construction of straight-field-line angle on interfaces;
  Liotastandard = .false. ! relates to construction of straight-field-line angle on interfaces;
  LiotaSVD      = .false. ! relates to construction of straight-field-line angle on interfaces;

  if( Liotasolv.eq.1 .or. Liotasolv.eq.3 .or. Liotasolv.eq.5 .or. Liotasolv.eq.7 ) Liotasparse   = .true.
  if( Liotasolv.eq.2 .or. Liotasolv.eq.3 .or. Liotasolv.eq.6 .or. Liotasolv.eq.7 ) Liotastandard = .true.
  if( Liotasolv.eq.4 .or. Liotasolv.eq.5 .or. Liotasolv.eq.6 .or. Liotasolv.eq.7 ) LiotaSVD      = .true.

  if( myid.eq.0 ) then
   cput = MPI_WTIME()
   write(ounit,'("al00aa : " 10x " : Liotasparse     ="L2" , Liotastandard   ="L2" , LiotaSVD        ="L2" ;")')           Liotasparse, Liotastandard, LiotaSVD
   write(ounit,'("al00aa : " 10x " : ")')
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal variables that depend on namelist/nonlinearlist/

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal variables that depend on namelist/diagnosticslist/

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal variables that depend on namelist/screenlist/

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Radial interpolation, radial-sub-grid;

  ALLOCATE(ss,(1:Nvol)) ! type subgrid;

  RALLOCATE(interfacelabel,(0:Nvol)) ! an array of this format is required for NAG routine E01BEF;

  RALLOCATE(dss,(1:Nvol,-2:Nofe+Nofe)) ! radial sub-grid grid size in each volume, and powers;

  interfacelabel(0) = zero

  do lvol = 1, Nvol
   
   RALLOCATE(ss(lvol)%s,(0:Ni(lvol))) ! radial sub-grid resolution in each annulus;
   
   ss(lvol)%s(0:Ni(lvol)) = ( (lvol-1) + (/ ( ii,ii=0,Ni(lvol) ) /) * one/Ni(lvol) ) / Nvol
   
   interfacelabel(lvol) = ss(lvol)%s(Ni(lvol))

   ;                         dss(lvol,  1 ) = ( interfacelabel(lvol) - interfacelabel(lvol-1) ) / Ni(lvol) ! for equally spaced radial sub-grid;
   do iofe = -2, Nofe+Nofe ; dss(lvol,iofe) = dss(lvol,1)**iofe
   enddo

  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  IALLOCATE(mpnq,(1:mn)) ! recall that this allocates and defaults to 0; see macros;

  do imn = 1, mn ; mm= im(imn) ; nn = in(imn)/Nfp
   if( mm.eq.0 .and. nn.eq.0 ) mpnq(imn) = 0
   if( mm.eq.0 .and. nn.ne.0 ) mpnq(imn) =              abs(nn)**qwidth
   if( mm.ne.0 .and. nn.eq.0 ) mpnq(imn) = mm**pwidth
   if( mm.ne.0 .and. nn.ne.0 ) mpnq(imn) = mm**pwidth + abs(nn)**qwidth
  enddo
  
  cput = MPI_WTIME()
  if( Lgeometry.ge.4 .and. myid.eq.0 ) then
                 write(ounit,'("al00aa : "f10.2" : max mpnq = "i9" ;                ")')  cput-cpus, maxval(mpnq)
   if( Wal00aa ) write(ounit,'("al00aa : "f10.2" : (m,n)=("i3" ,"i4" ) ; mpnq="i9" ;")')( cput-cpus, im(imn), in(imn), mpnq(imn), imn =1,mn ) 
                 write(ounit,'("al00aa : " 10x " :                                  ")')
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ALLOCATE(doAt,(-1:2,1:Nvol,1:mn,0:Nofe)) ! type subgrid; additional storage;
  ALLOCATE(doAz,(-1:2,1:Nvol,1:mn,0:Nofe)) ! type subgrid;

  IALLOCATE(NBdof,(1:Nvol)) ! Beltrami degrees of freedom in each annulus;
  
  do lvol = 1, Nvol
   
   NBdof(lvol) = 2 * mn * ( Nofe+1 ) * ( Ni(lvol)+1 )  -  2 * mn + (mn-1) ! total degrees of freedom, including outer boundary constraints;

   if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ; NBdof(lvol) = NBdof(lvol) - 2*mn                 ! annular region;
   else                                                         ; Lcoordinatesingularity = .true.  ; NBdof(lvol) = NBdof(lvol) - 2*mn + ( mn - Ntor ) ! simple torus;
   endif
  
   if( Lvacuum.ne.0 .and. lvol.eq.Nvol                   ) then ; Louterboundarynormal   = .true.
   else                                                         ; Louterboundarynormal   = .false.
   endif

   if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! the construction of the vector potential is distributed over cpus;
   
   do ij = 1, mn ! loop over Fourier harmonics;
    do ip = 0, Nofe ! loop over derivatives;
     
     do imp = -1, 2

      RALLOCATE(doAt(imp,lvol,ij,ip)%s,(0:Ni(lvol))) ! covariant coefficients of vector potential;
      RALLOCATE(doAz(imp,lvol,ij,ip)%s,(0:Ni(lvol)))

      ifail = 0
      call G05FAF(-sqrtmachprec, sqrtmachprec, Ni(lvol)+1, doAt(imp,lvol,ij,ip)%s(0:Ni(lvol)), ifail) ! initialize vector potential with small random;

      ifail = 0
      call G05FAF(-sqrtmachprec, sqrtmachprec, Ni(lvol)+1, doAz(imp,lvol,ij,ip)%s(0:Ni(lvol)), ifail)

     enddo ! end of do imp = -1, Ldmupf;

     IALLOCATE(doAt(0,lvol,ij,ip)%i,(-1:Ni(lvol)+1)) ! degree of freedom index;
     IALLOCATE(doAz(0,lvol,ij,ip)%i,(-1:Ni(lvol)+1)) ! include padding for simple loop logic in ma01aa;
     
    enddo ! end of do ip;
   enddo ! end of do ij;
     
!latex \item The vector potential is initialized using an integrable approximation:
!latex \be {\bf A} = A_\t(s) \nabla \t + A_\z(s) \nabla \z,\ee
!latex with toroidal flux $\psi_t \equiv \oint {\bf A}\cdot d{\bf l}=A_\t$.
!latex A sufficiently good initial guess is perhaps to assume that 
!latex \be \psi_t = \psi_{t,\l-1} + \Delta \psi_t (s-s_{l-1}) / \Delta s,\ee
!latex where $\Delta \psi_t \equiv \psi_{t,l}-\psi_{t,l-1}$ and $\Delta s \equiv s_{l}-s_{l-1}$.
!latex A similar initialization is provided for $A_\z \equiv \psi_p$.
   
   if( Linitgues.gt.0 ) then 
    
    if( Nofe.ge.0 ) then !
     doAt(0,lvol,1,0)%s(0:Ni(lvol)) = ( tflux(lvol) - tflux(lvol-1) ) * ( ss(lvol)%s(0:Ni(lvol)) - interfacelabel(lvol-1) ) / ( interfacelabel(lvol) - interfacelabel(lvol-1) )
     doAz(0,lvol,1,0)%s(0:Ni(lvol)) = ( pflux(lvol) - pflux(lvol-1) ) * ( ss(lvol)%s(0:Ni(lvol)) - interfacelabel(lvol-1) ) / ( interfacelabel(lvol) - interfacelabel(lvol-1) )
    endif
    
    if( Nofe.ge.1 ) then ! derivatives;
     doAt(0,lvol,1,1)%s(0:Ni(lvol)) = ( tflux(lvol) - tflux(lvol-1) ) * ( one                                             ) / ( interfacelabel(lvol) - interfacelabel(lvol-1) )
     doAz(0,lvol,1,1)%s(0:Ni(lvol)) = ( pflux(lvol) - pflux(lvol-1) ) * ( one                                             ) / ( interfacelabel(lvol) - interfacelabel(lvol-1) )
    endif
    
   endif ! end of if( Linitgues.gt.0 ) then;
   
   if( Linitgues.eq.2 ) then ! read initial guess for vector potential from file;
    WCALL(al00aa,ra00aa,(lvol,'R')) ! this reads doAt,doAz from file;
   endif ! end of if( Linitgues.eq.2 ) then;
   
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 

  !if( Lgeometry.ne.1 .and. Lgeometry.ne.4 .and. lvol.eq.1 ) then ! this is the simple torus; need to consider regularity at axis;
   if( Lcoordinatesingularity ) then ! this is the simple torus; need to consider regularity at axis;
    
    ix = 0 ! degree of freedom index; reset to 0 in each annulus;

    do ij = 1, mn
     
!    if( imask(ij).le.0 ) cycle

     do ip = 0, Nofe
      do ii = 0, Ni(lvol)
       
       if( ii.eq.0 .and. ip.eq.0 ) then
        
!       ix = ix+1 ; doAt(0,lvol,ij,ip)%i(ii) = ix
        
        if( ij.eq.1 .or. im(ij).ne.0 ) then ! what happens to preconditioning sfactor at origin when ip=0 and either (m,n)=(0,0) or m>0 ;
         ix = ix+1 ; doAz(0,lvol,ij,ip)%i(ii) = ix
        endif

       endif ! end of if( ii.eq.0 .and. ip.eq.0 )
       
       if( ii.eq.0 .and. ip.gt.0 ) then ! what happens to preconditioning sfactor at origin when ip>0;
        ix = ix+1 ; doAt(0,lvol,ij,ip)%i(ii) = ix
        ix = ix+1 ; doAz(0,lvol,ij,ip)%i(ii) = ix
       endif
       
       if( ii.gt.0 .and. ii.lt.Ni(lvol) ) then
        ix = ix+1 ; doAt(0,lvol,ij,ip)%i(ii) = ix
        ix = ix+1 ; doAz(0,lvol,ij,ip)%i(ii) = ix
       endif
       
       if( ii.eq.Ni(lvol) ) then ! At & Az harmonics are related; At = d_\t f, Az = d_\z f;
        
        if( ip.eq.0 .and. ij.gt.1 ) then
         ix = ix + 1
         if    ( im(ij).ne.0 .and. in(ij).ne.0 ) then ; doAt(0,lvol,ij,ip)%i(ii) = ix ; doAz(0,lvol,ij,ip)%i(ii) = ix
         elseif( im(ij).eq.0 .and. in(ij).ne.0 ) then ;                                 doAz(0,lvol,ij,ip)%i(ii) = ix
         elseif( im(ij).ne.0 .and. in(ij).eq.0 ) then ; doAt(0,lvol,ij,ip)%i(ii) = ix                                
         endif
        endif ! end of if( ip.eq.0 .and. ij.gt.1 );
        
        if( ip.gt.0 ) then 
         ix = ix+1 ; doAt(0,lvol,ij,ip)%i(ii) = ix
         ix = ix+1 ; doAz(0,lvol,ij,ip)%i(ii) = ix
        endif ! end of if( ip.gt.0 );
        
       endif ! end of  if( ii.eq.Ni(lvol) );
       
      enddo ! end of do ii;
      
     enddo ! end of do ip;
     
    enddo ! end of do ij;
    
!   FATALMESS(global,ix.ne.NBdof(lvol),check simple torus degree-of-freedom logic)
    
    NBdof(lvol) = ix

   else ! this is either Cartesian or an annulus; note that the preconditioning matrix is not allocated/constructed;
    
    ix = 0 ! degree of freedom index; reset to 0 in each annulus;
    
    do ij = 1, mn

!    if( imask(ij).le.0 ) cycle

     do ip = 0, Nofe
      do ii = 0, Ni(lvol)
       
       if    ( ii.eq. 0     .and. ip.eq.0  ) then ! no freedom; inner interface constraints;
        
       elseif( ii.eq.Ni(lvol) .and. ip.eq.0  ) then ! reduced freedom due to interface constraints;
        
        if( ij.gt.1 ) then 
         
         ix = ix + 1
         
         if    ( im(ij).ne.0 .and. in(ij).ne.0 ) then ; doAt(0,lvol,ij,ip)%i(ii) = ix ; doAz(0,lvol,ij,ip)%i(ii) = ix ! these are not independent degrees of freedom; 
         elseif( im(ij).eq.0 .and. in(ij).ne.0 ) then ;                                 doAz(0,lvol,ij,ip)%i(ii) = ix
         elseif( im(ij).ne.0 .and. in(ij).eq.0 ) then ; doAt(0,lvol,ij,ip)%i(ii) = ix
         endif
         
        endif ! end of if( ij.gt.1 ) ;
        
       else ! this is an independent degree of freedom;
        
        ix = ix+1 ; doAt(0,lvol,ij,ip)%i(ii) = ix
        ix = ix+1 ; doAz(0,lvol,ij,ip)%i(ii) = ix
        
       endif ! end of if; elseif;
      enddo ! end of do ii;
     enddo ! end of do ip;
    enddo ! end of do ij;

!   FATALMESS(global,ix.ne.NBdof(lvol),check annular degree-of-freedom logic)
    
    NBdof(lvol) = ix
    
   endif ! end of if( Lgeometry.gt.0 .and. lvol.eq.1 )
    
  enddo ! end of do lvol = 1,Nvol loop;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do lvol = 1, Nvol
   llmodnp = modulo(lvol-1,ncpu) ! identify which node contains data; this must be consistent with above looping / parallelization;
   IlBCAST(NBdof(lvol),1,llmodnp)
  enddo
  
  if( Wal00aa .and. myid.eq.0 ) then ! 17 Oct 12;
   cput = MPI_WTIME()
   write(ounit,'("al00aa : "f10.2" : iquad="i3" ; mn="i4" ; Ngdof="i6" ; NBdof="99(i6" ,"))')cput-cpus,iquad,mn,Ngdof,NBdof(1:Nvol) ! NBdof is now local to each cpu;
   write(ounit,'("al00aa : " 10x " : ")')         
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RALLOCATE(doAtmn,(-1:2,0:2,0:mn)) ! workspace interpolation array; need to check why 0:mn is required, and not 1:mn;
  RALLOCATE(doAzmn,(-1:2,0:2,0:mn)) 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Interface geometry;

  totalradialresolution = 0
  do lvol = 1, Nvol ; totalradialresolution = totalradialresolution + ( Ni(lvol) + 1 ) * ( Nofe + 1 ) ! radial resolution * order of finite elements;
  enddo

  if( myid.eq.0 ) then
   cput = MPI_WTIME()
   write(ounit,'("al00aa : "f10.2" : total radial resolution = "i5" ;")')cput-cpus,totalradialresolution
   write(ounit,'("al00aa : " 10x " : ")')
  endif

  SumNi = sum(Ni(1:Nvol)) ! this needs to be reviewed; under construction;

  RALLOCATE(Rmn,(0:SumNi,0:2,1:mn)) ! workspace interpolation array;
  RALLOCATE(Zmn,(0:SumNi,0:2,1:mn))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LALLOCATE(AngleLogical,(1:mns,1:mns)) ! gives sparse structure of straight-field-line transformation;
  
  do kmn = 1,mns                                                                                      ! this logic, loops etc. need to be identical to tr00ab;
   do imn = 1,mn                                                                                      ! this logic, loops etc. need to be identical to tr00ab;
    if( im(imn).eq.ims(kmn) .and. in(imn).eq.ins(kmn) ) AngleLogical(kmn,1) = .true.                  ! this logic, loops etc. need to be identical to tr00ab;
   enddo                                                                                              ! this logic, loops etc. need to be identical to tr00ab;
   do jmn = 1,mns                                                                                     ! this logic, loops etc. need to be identical to tr00ab;
    do imn = 1,mn                                                                                     ! this logic, loops etc. need to be identical to tr00ab;
     madd = im(imn)+ims(jmn) ; nadd = in(imn) + ins(jmn)                                              ! this logic, loops etc. need to be identical to tr00ab;
     msub = im(imn)-ims(jmn) ; nsub = in(imn) - ins(jmn)                                              ! this logic, loops etc. need to be identical to tr00ab;
     if(                 madd .eq. ims(kmn) .and. nadd .eq. ins(kmn) ) AngleLogical(kmn,jmn) = .true. ! this logic, loops etc. need to be identical to tr00ab;
     if(                 msub .eq. ims(kmn) .and. nsub .eq. ins(kmn) ) AngleLogical(kmn,jmn) = .true. ! this logic, loops etc. need to be identical to tr00ab;
     if( msub.lt.0 .and. msub .eq.-ims(kmn) .and. nsub .eq.-ins(kmn) ) AngleLogical(kmn,jmn) = .true. ! this logic, loops etc. need to be identical to tr00ab;
    enddo                                                                                             ! this logic, loops etc. need to be identical to tr00ab;
   enddo                                                                                              ! this logic, loops etc. need to be identical to tr00ab;
  enddo                                                                                               ! this logic, loops etc. need to be identical to tr00ab;
  
  AngleNZ = 0
  do kmn = 1, mns
   do jmn = 1, mns
    if( AngleLogical(kmn,jmn) ) then ; AngleNZ = AngleNZ + 1
    endif
   enddo
  enddo
  FATALMESS(al00aa,AngleNZ.le.0,it seems that the straight field line angle transformation matrix has no non-zero entries)
  
  AngleLIRN = 12 * AngleNZ ; AngleLICN = 12 * AngleNZ ! these are set much higher than that recommended by NAG documentation;
  
  RALLOCATE(AngleSparseMatrix,(1:AngleLICN))
  
  IALLOCATE(AngleIRN,(1:AngleLIRN))
  IALLOCATE(AngleICN,(1:AngleLICN))  
  IALLOCATE(AngleIKEEP,(1:5*mns))
  IALLOCATE(AngleIVECT,(1:AngleNZ))
  IALLOCATE(AngleJVECT,(1:AngleNZ))
  
  LNZ = 0
  do kmn = 1, mns
   do jmn = 1, mns
    if( AngleLogical(kmn,jmn) ) then ; LNZ = LNZ + 1 ; AngleIRN(LNZ) = kmn ; AngleICN(LNZ) = jmn
    endif
   enddo
  enddo
  FATALMESS(al00aa,LNZ.ne.AngleNZ,need to check sparsity pattern more closely)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Fourier transforms;

  Nt = max(Ndiscrete*4*Mpol,1) ; Nz = max(Ndiscrete*4*Ntor,1) ; Ntz = Nt*Nz ; soNtz = one/sqrt(one*Ntz) ! discrete resolution; exaggerated discrete resolution;

  RALLOCATE(Rij,(0:9,1:Ntz)) ! these are used for inverse fft to reconstruct real space geometry from interpolated Fourier harmonics;
  RALLOCATE(Zij,(0:9,1:Ntz))
  RALLOCATE(sg,(0:3,1:Ntz))
  RALLOCATE(gij,(1:6,0:3,1:Ntz)) ! need this on higher resolution grid for accurate Fourier decomposition;

  RALLOCATE(glmn,(1:6,0:mne)) ! workspace for Fourier decomposition of metric terms; see me00ab; WASTEFUL MEMORY;

  RALLOCATE(sgmn,(1:mne)) ! harmonics of inverse jacobian; NOWHERE USED;

  RALLOCATE(trigm,(1:2*Nt)) ! trignometric factors required for fast Fourier transform;
  RALLOCATE(trign,(1:2*Nz))
  RALLOCATE(trigwk,(1:2*Ntz))

  RALLOCATE(ijreal,(1:Ntz)) ! real space grid;
  RALLOCATE(ijimag,(1:Ntz))
  RALLOCATE(jireal,(1:Ntz))
  RALLOCATE(jiimag,(1:Ntz))

  isr='I' ; ifail=0 ; CALL(C06FUF,( Nt, Nz, ijreal, ijimag, isr, trigm, trign, trigwk, ifail ) ) ; isr='S' ! should be quicker; coefficients dont need to be re-computed;

  FATALMESS(al00aa,ifail.ne.0,error constructing Fourier transform)

  RALLOCATE(ofmn,(1:mne)) ! Fourier harmonics; workspace;
  RALLOCATE(efmn,(1:mne))
  RALLOCATE(sfmn,(1:mne))
  RALLOCATE(cfmn,(1:mne))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(Bsupumn,(1:Nvol,0:1,1:mn)) ! Fourier components of {\bf B}\cdot\nabla \theta on boundary; required for virtual casing;
  RALLOCATE(Bsupvmn,(1:Nvol,0:1,1:mn)) ! Fourier components of {\bf B}\cdot\nabla \zeta  on boundary;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Metric information;

  RALLOCATE(agss,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agst,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agsz,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agtt,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agtz,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agzz,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  RALLOCATE(agoo,(1:mn*mn)) ! angle averaged metric elements; function of s; computed from FFT of jacobian and triple angle formulae;
  
  do ij = 1,mn
   do ik = 1,mn ; jk = ik + (ij-1) * mn
    
    if( im(ij)-im(ik).eq.0 .and. in(ij)-in(ik).eq.0 ) agoo(jk) = agoo(jk) + pi2 * pi2nfp * half ! this is geometry independent;
    if( im(ij)+im(ik).eq.0 .and. in(ij)+in(ik).eq.0 ) agoo(jk) = agoo(jk) + pi2 * pi2nfp * half
    
   enddo
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  ALLOCATE(igss,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igst,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igsz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igtt,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igtz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igzz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igoo,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RALLOCATE(dxagss,(1:mn*mn)) ! these are not always required; could save memory perhaps;
  RALLOCATE(dxagst,(1:mn*mn))
  RALLOCATE(dxagsz,(1:mn*mn))
  RALLOCATE(dxagtt,(1:mn*mn))
  RALLOCATE(dxagtz,(1:mn*mn))
  RALLOCATE(dxagzz,(1:mn*mn))
  RALLOCATE(dxagoo,(1:mn*mn)) ! this is identically zero;
  
  ALLOCATE(dxigss,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! these are not always required; could save memory perhaps;
  ALLOCATE(dxigst,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn))
  ALLOCATE(dxigsz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn))
  ALLOCATE(dxigtt,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn))
  ALLOCATE(dxigtz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn))
  ALLOCATE(dxigzz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn))
  ALLOCATE(dxigoo,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! this is identically zero;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(felr,(0:1,0:Nofe,0:1,1:Iquad)) ! "left" and "right" finite-element functions;
  RALLOCATE(lelr,(0:1,0:Nofe,0:1,1:Iquad)) ! "left" and "right" finite-element functions; local to lvol-th volume;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Transformation to straight field line angle;

  RALLOCATE(dsflangle,(0:2,1:Nvol,0:1,1:mns)) ! transformation to straight field line coordinates on interfaces;
  
  RALLOCATE(diota,(1:Nvol,0:2,0:1)) ! measured rotational transform on inner/outer interfaces in each annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Construction of `force';

  RALLOCATE( Bomn,(1:Nvol,0:1,1:mn))
  RALLOCATE(mBomn,(1:Nvol         ))
  
  if( Lgeometry.ge.4 ) then ! the geometry is overdetermined (there is a free function for both R and Z); additional angle constraints are required;
   RALLOCATE( Iomn,(1:Nvol,1:mn))
   RALLOCATE(mIomn,(1:Nvol     ))
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! Parallel construction of derivative matrix;
  
  RALLOCATE(   DenergyDrz,( 1:Nvol, 0:1, 1:nlocaldof                   )) ! derivatives of BB                   wrt geometry;

  RALLOCATE( DanalyticDrz,( 1:Nvol, 0:1, 1:nlocaldof                   )) ! derivatives of BB                   wrt geometry;
  RALLOCATE( DanalyDrzDrz,( 1:Nvol, 0:1, 1:nlocaldof, 0:1, 1:nlocaldof )) ! derivatives of BB                   wrt geometry; wrt geometry;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! Trigonometric factors;
   
  FATALMESS(al00aa,Ntz.le.0,have not yet computed Ntz)

  if( Lgeometry.eq.3 ) then ! only required for cylindrical geometry;
   
!  RALLOCATE(coszeta,(1:Ntz))
!  RALLOCATE(sinzeta,(1:Ntz))
   RALLOCATE(costeta,(1:Ntz))
!  RALLOCATE(sinteta,(1:Ntz))
   
   do kk = 0, Nz-1 ; zeta = kk * pi2nfp / Nz
    do jj = 0, Nt-1 ; teta = jj * pi2 / Nt ; jk = 1 + jj + kk*Nt
!    coszeta(jk) = cos(zeta) ; sinzeta(jk) = sin(zeta)
     costeta(jk) = cos(teta) ! sinteta(jk) = sin(teta)
    enddo
   enddo
  
  endif ! end of if( Lgeometry.eq.3 );


  RALLOCATE(cosj,(1:mn,1:Ntz))
  RALLOCATE(sinj,(1:mn,1:Ntz))
  
  do imn = 1, mn ! loop over Fourier harmonics;

   do kk = 0, Nz-1 ; zeta = kk * pi2nfp / Nz ! loop over real space grid; toroidal;
    do jj = 0, Nt-1 ; teta = jj * pi2    / Nt ! loop over real space grid; poloidal;

    jk = 1 + jj + kk*Nt ; arg = im(imn) * teta - in(imn) * zeta ! shorthand;

     cosj(imn,jk) = cos(arg)
     sinj(imn,jk) = sin(arg)

    enddo
   enddo

  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(dxsg,(1:Ntz))
  RALLOCATE(dxgij,(1:6,1:Ntz))

  RALLOCATE(dxglmn,(1:6,0:mne)) ! WASTEFUL MEMORY; not required to have glmn or dxglmn as global;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  IALLOCATE(ijk,(1:mn,1:mn))

  jk = 0

  do ij = 1, mn
   do ik = 1, mn ; jk = jk + 1 ! count;

    ijk(ij,ik) = jk

    FATAL(al00aa,jk.ne.ik + (ij-1) * mn)

   enddo
  enddo

  FATAL(al00aa,jk.ne.mn*mn)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LALLOCATE(doubleex,(1:mns,1:mns)) ! these are used in tr00ab;
  IALLOCATE(doubleie,(1:mns,1:mns)) ! these are used in tr00ab;
  IALLOCATE(doubleip,(1:mns,1:mns)) ! these are used in tr00ab;
  IALLOCATE(doubleim,(1:mns,1:mns)) ! these are used in tr00ab;
  IALLOCATE(doublein,(1:mns,1:mns)) ! these are used in tr00ab;
  
  do kmn = 1, mns
   
   do imn = 1, mn
    if( im(imn).eq.ims(kmn) .and. in(imn).eq.ins(kmn) ) then ; doubleex(kmn,1) = .true. ; doubleie(kmn,1) = imn
    endif
   enddo
   
   do jmn = 2, mns
    
    do imn = 1, mn
     
     if( im(imn)+ims(jmn) .eq.  ims(kmn) .and. in(imn)+ins(jmn) .eq.  ins(kmn)                             ) then ; doubleex(kmn,jmn) = .true. ; doubleip(kmn,jmn) = imn
     endif
     if( im(imn)-ims(jmn) .eq.  ims(kmn) .and. in(imn)-ins(jmn) .eq.  ins(kmn)                             ) then ; doubleex(kmn,jmn) = .true. ; doubleim(kmn,jmn) = imn
     endif
     if( im(imn)-ims(jmn) .eq. -ims(kmn) .and. in(imn)-ins(jmn) .eq. -ins(kmn) .and. im(imn)-ims(jmn).lt.0 ) then ; doubleex(kmn,jmn) = .true. ; doublein(kmn,jmn) = imn
     endif
     
    enddo
    
   enddo
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{triple angle summations}

!latex \item Consider
!latex \be \left[\sum_{i=1}^{M} \sum_{j=1}^{N}\sum_{k=1}^{N} \exp(i\alpha)\exp(j\alpha)\exp(k\alpha)\right]_l 
!latex \ee

  IALLOCATE(tripleipp,(1:mn,1:mn)) ! triple angle shorthand;
  IALLOCATE(tripleipm,(1:mn,1:mn)) ! triple angle shorthand;
  IALLOCATE(tripleimp,(1:mn,1:mn)) ! triple angle shorthand;
  IALLOCATE(tripleimm,(1:mn,1:mn)) ! triple angle shorthand;
  
  do imn = 1, mne
   
   do ij = 1, mn
    do ik = 1, mn
     
     if( ime(imn)+im(ij)+im(ik) .eq. 0 .and. ine(imn)+in(ij)+in(ik) .eq. 0 ) tripleipp(ij,ik) = imn
     if( ime(imn)+im(ij)-im(ik) .eq. 0 .and. ine(imn)+in(ij)-in(ik) .eq. 0 ) tripleipm(ij,ik) = imn
     if( ime(imn)-im(ij)+im(ik) .eq. 0 .and. ine(imn)-in(ij)+in(ik) .eq. 0 ) tripleimp(ij,ik) = imn
     if( ime(imn)-im(ij)-im(ik) .eq. 0 .and. ine(imn)-in(ij)-in(ik) .eq. 0 ) tripleimm(ij,ik) = imn
     
    enddo
   enddo
   
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  IALLOCATE(aijk,(1:mn,1:mn,1:mn))
  IALLOCATE(bijk,(1:mn,1:mn,1:mn))
  
  do imn = 1, mn
   do jmn = 1, mn
    do kmn = 1, mn
     
     if( im(imn)+im(jmn)+im(kmn).eq.0 .and. in(imn)+in(jmn)+in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
      ;                                                                           bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) - im(jmn)
     endif
     
     if( im(imn)+im(jmn)-im(kmn).eq.0 .and. in(imn)+in(jmn)-in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
      ;                                                                           bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) + im(jmn)
     endif
     
     if( im(imn)-im(jmn)+im(kmn).eq.0 .and. in(imn)-in(jmn)+in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
      ;                                                                           bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) + im(jmn)
     endif
     
     if( im(imn)-im(jmn)-im(kmn).eq.0 .and. in(imn)-in(jmn)-in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
      ;                                                                           bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) - im(jmn)
     endif
     
    enddo
   enddo
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! Volume integrals;
  
  RALLOCATE(lvolume    ,(1:Nvol)) ! volume integral of \sqrt g;
  RALLOCATE(lBBintegral,(1:Nvol)) ! volume integral of B.B    ;
  RALLOCATE(lABintegral,(1:Nvol)) ! volume integral of A.B    ;

  RALLOCATE(oBBintegral,(1:Nvol)) ! volume integral of B.B    ; original; used to normalize;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Periodic orbits;
  
  Dzeta = pi / Npl ! 10 Oct 12; ! DEBUGGING; why is there a minus sign; under construction; Lagrangian integration;
  
  ALLOCATE(pqorbit,(1:Nvol,1:maxval(npq))) ! periodic orbits;
  
  pqorbit(1:Nvol,1:maxval(npq))%ok = 0     ! set flag that indicates if periodic orbit has been constructed;
  
  do lvol = 1, Nvol ! prepare workspace for constructing periodic orbits;
   
!  if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! 10 Oct 12; this cycle statement can probably be reinserted -- periodic orbits are no longer broadcast; 
   
   FATALMESS(al00aa,npq(lvol).gt.0.and.q1(lvol).eq.0,denominator q1 cannot be 0)
   
   if( npq(lvol).ge.1 ) then ; pqorbit(lvol,1)%pq(1:2) = (/ p1(lvol), q1(lvol) * Nfp /) ! this is given on input; 27 Nov 12;
   endif
   
   FATALMESS(al00aa,npq(lvol).gt.1.and.q2(lvol).eq.0,denominator q2 cannot be 0)
   
   if( npq(lvol).ge.2 ) then ; pqorbit(lvol,2)%pq(1:2) = (/ p2(lvol), q2(lvol) * Nfp /) ! this is given on input; 27 Nov 12;
   endif
   
   FATALMESS(al00aa,npq(lvol).gt.2.and.abs( p1(lvol)*q2(lvol) - q1(lvol)*p2(lvol) ).ne.1,not neighboring : cannot construct noble irrational)
   
   do nc = 3, npq(lvol) ; pqorbit(lvol,nc)%pq(1:2) = pqorbit(lvol,nc-2)%pq(1:2) + pqorbit(lvol,nc-1)%pq(1:2) ! noble convergents;
   enddo
   
   if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! computation is distributed; 14 Nov 12;
   
   do nc = 1, npq(lvol) ; pp = pqorbit(lvol,nc)%pq(1) ; qq = pqorbit(lvol,nc)%pq(2)
    
    ;                        pqorbit(lvol,nc)%to = zero                                                     ! default initial guess;
    ;                        pqorbit(lvol,nc)%so = half * ( interfacelabel(lvol-1) + interfacelabel(lvol) ) ! default initial guess; ! updated elsewhere; 14 Nov 12;
    
    if( nc.eq.1 ) then
     ;                       pqorbit(lvol,nc)%to = pqt(lvol)                                                ! initial guess provided by user;
     if( pqs(lvol).gt.zero ) pqorbit(lvol,nc)%so = pqs(lvol)                                                ! initial guess provided by user;
    endif
    
    RALLOCATE(pqorbit(lvol,nc)%s,(0:qq)) ! periodic orbit constructed from field line following, pq00aa;
    RALLOCATE(pqorbit(lvol,nc)%t,(0:qq)) ! periodic orbit constructed from field line following, pq00aa;
    RALLOCATE(pqorbit(lvol,nc)%a,(0:qq)) ! periodic orbit constructed from field line following, pq00aa;
    
    RALLOCATE(pqorbit(lvol,nc)%tt,(0:2*qq*Npl)) ! periodic orbit constructed from Lagrangian integration;
    RALLOCATE(pqorbit(lvol,nc)%ss,(1:2*qq*Npl)) ! periodic orbit constructed from Lagrangian integration;
    RALLOCATE(pqorbit(lvol,nc)%dt,(1:2*qq*Npl)) ! periodic orbit constructed from Lagrangian integration;
    
    pqorbit(lvol,nc)%tt(0:2*qq*Npl) = (/ ( ii, ii = 0, 2*qq*Npl ) /) * pp * pi2 / ( 2*qq*Npl )
    pqorbit(lvol,nc)%ss(1:2*qq*Npl) = pqorbit(lvol,nc)%so
    
    FATALMESS(al00aa,abs(pqorbit(lvol,nc)%tt(2*qq*Npl)-pqorbit(lvol,nc)%tt(0)-pi2*pp).gt.vsmall,incorrectly enforcing periodicity constraint)
    
    if( Wal00aa ) then
     cput = MPI_WTIME()
     write(ounit,1002)cput-cpus,myid,lvol,nc,pqorbit(lvol,nc)%pq(1:2),pqorbit(lvol,nc)%to,pqorbit(lvol,nc)%so
    endif
    
1002 format("al00aa : "f10.2" : myid="i3" : lvol="i3" ; nc="i3" ; periodic orbit : ("i5" ,"i6" ) ; to="f15.10" ; so="f15.10" ;")

   enddo ! end of do nc = 1, npq(lvol) ;
   
  enddo ! end of do lvol = 1, Nvol
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Quadratic-flux minimizing surfaces;  

  mnpq = max(1,maxval(npq)) ! perhaps this should be maxval(npq(1:Nvol)) ?;

  ALLOCATE(qfms,(1:Nvol,1:mnpq))

  do lvol = 1, Nvol
   do ipq = 1, mnpq
    qfms(lvol,ipq)%i = 0 ; qfms(lvol,ipq)%pq(1:2) = (/ 0, 0 /) ! intialize; these are given values in pq02aa;
   enddo
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Irrational surfaces;

  if( Mirrits.gt.0 ) then ! prepare workspace for construction of irrational surfaces;

   irrsurf%Npts = ( 2*irrMpol + 1 ) + 1 ! +1 is to keep Npts even; easier to avoid prime factor problem appearing below;
   
   RALLOCATE(irrsurf%ti,(0:irrsurf%Npts  )) ! note that this includes end=periodicity point;
   RALLOCATE(irrsurf%si,(0:irrsurf%Npts  )) ! note that this includes end=periodicity point;
   RALLOCATE(irrsurf%di,(0:irrsurf%Npts  )) ! note that this includes end=periodicity point;

   irrmn = irrNtor+1 + irrMpol * (2*irrNtor+1) ! set total number of Fourier harmonics for irrational surfaces;

   IALLOCATE(irrim,(1:irrmn)) ! poloidal modes for irrational surfaces;
   IALLOCATE(irrin,(1:irrmn)) ! toroidal modes for irrational surfaces;

   CALL(gi00ab,(irrMpol,irrNtor,Nfp,irrmn,irrim,irrin))

   RALLOCATE(irrsurf%tm,(0:irrMpol)) ! these are given values in pq01aa;
   RALLOCATE(irrsurf%sm,(0:irrMpol)) ! these are given values in pq01aa;
   RALLOCATE(irrsurf%Rbc,(1:irrmn)) ! these are given values in ir00aa;
   RALLOCATE(irrsurf%Zbs,(1:irrmn)) ! these are given values in ir00aa;
   RALLOCATE(irrsurf%fmn,(1:irrmn)) ! these are given values in ir00aa;

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Lwrpj ) then ! allocate array used to hold surface potentials on inner/outer of each interface;
   RALLOCATE(Itor,(1:Nvol,0:1))
   RALLOCATE(Gpol,(1:Nvol,0:1))
   RALLOCATE(spmn,(1:Nvol,0:1,1:mn))
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( LbeltramiLinear .and. Lsparsematrix ) then 
  !if( Ldense.eq.0 .or. Ldense.eq.2 ) then ! sparse method will be used to solve Beltrami linear system; ! 10 Oct 12; to be deleted;
    IALLOCATE(NNZ,(1:Nvol))
  !endif ! 10 Oct 12; to be deleted;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Lvacuum.gt.0 ) then ; iexvol = 1 ! 10 Oct 12; this selects which tangential field is written to file: either just inside          last interface,
  else                    ; iexvol = 0 ! 10 Oct 12;                                                         or     just outside next-to-last interface;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(al00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine al00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
