!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Computes normal field, and loop integrals to determine enclosed currents, on computational boundary.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{construction of normal field} ! 13 Oct 12;

!latex The normal field depends on geometry:

!latex \begin{enumerate}

!latex \item \verb+Lgeometry.eq.1+ Cartesian geometry: 

!latex       \be {\bf x} = \t \; \hat {\bf i} + \z \; \hat {\bf j}+ R \; \hat {\bf k}
!latex       \ee
!latex       \be {\bf e}_\theta \times {\bf e}_\zeta = \hat {\bf i} \times \hat {\bf j} + R_\z \; \hat {\bf i} \times \hat {\bf k} + R_\t \; \hat {\bf k} \times \hat {\bf j}
!latex       \ee
    
!latex \item \verb+Lgeometry.eq.2+ cylindrical:

!latex       \be {\bf x} = R \cos\t \, {\bf \hat i} + R \sin\t \, {\bf \hat j} + \z \, {\bf \hat k}
!latex       \ee
!latex       \be {\bf e}_\theta \times {\bf e}_\zeta = - R Z_\theta \hat R + (Z_\theta R_\zeta - R_\theta Z_\zeta) \hat \phi + R R_\theta \hat z
!latex       \ee
    
!latex \item \verb+Lgeometry.eq.5+ cylindrical:

!latex       \be {\bf x} = R \, {\bf \hat i} + Z \, {\bf \hat j} + \zeta \, {\bf \hat k}
!latex       \ee
!latex       \be {\bf e}_\theta \times {\bf e}_\zeta = Z_\theta {\bf \hat i} - R_\theta {\bf \hat j}
!latex       \ee

!latex \item \verb+Lgeometry.eq.6+ toroidal geometry:

!latex       \be R    & \equiv & R(\z,\t,\z)\\
!latex           \phi & \equiv & \lambda \, \z \\
!latex           Z    & \equiv & Z(\z,\t,\z),
!latex       \ee
!latex       \be {\bf x} = R \, {\bf \hat R} + Z \, {\bf \hat k} = R \cos \z \, {\bf \hat i} + R \sin \z \, {\bf \hat j} + Z         \, {\bf \hat k}.
!latex       \ee
!latex       \be {\bf e}_\theta \times {\bf e}_\zeta
!latex           & = & - R Z_\theta \hat R + (Z_\theta R_\zeta - R_\theta Z_\zeta) \hat \phi + R R_\theta \hat \\
!latex           & = &   (R_\t Z_\z \sin \z - Z_\t R_\z \sin \z - Z_\t R \cos \z ) \, {\bf \hat i}
!latex                 + (Z_\t R_\z \cos \z - Z_\z R_\t \cos \z - Z_\t R \sin \z ) \, {\bf \hat j}
!latex                 +  R R_\t  \, {\bf \hat k}
!latex       \ee
!latex       \be {\bf B} \cdot {\bf e}_\t \times {\bf e}_\z = Z_\t \, R \, B_R + ( Z_\t \, R_\z - R_\t \, Z_\z ) \, B_\phi \, R^{-1} - R_\t \, R \, B_Z.
!latex       \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine bn00aa( mn, Ntz )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2
  
  use numerical, only : small
  
  use fileunits, only : ounit
  
  use inputlist, only : Wbn00aa, Nvol, Ntor, Itoroidal, norblend, Ni, phiedge, &
                        normalerr, maxfbits, Lvacuum, mu ! 23 Oct 12;
  
  use cputiming, only : Tbn00aa
  
  use allglobal, only : ncpu, myid, cpus, pi2nfp, Nt, Nz, interfacelabel,          &
                        Rij, Zij, gij, sg,                                         &
                        im, in,                                                    &
                        doAtmn, doAzmn,                                            &
                        trigwk, trigm, trign, isr, Nt, Nz, efmn, ofmn, cfmn, sfmn, &
                        ijreal, jireal, ijimag, jiimag,                            & ! 11 Oct 12; perhaps these can be declared locally;
                        iBns, iVns, Ltangent, Bnserror,                            &
                        Lcoordinatesingularity,                                    & ! 21 Oct 12;
                        looperr,                                                   &
                        nFreeIterations, Lcontinueiterations,                      & ! 18 Oct 12;
                        Rmin, Zmin, Rmax, Zmax,                                    & ! 11 Oct 12; to compare computational boundary to mgrid domain;
                        dtflux
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER, intent(in) :: mn, Ntz
  
  INTEGER             :: imn, Lcurv, jj, kk, jk, imgridfail, ivirtualfail, ifail, kkmodnp, jkmodnp, llmodnp, Lparallel, Ldo
  
  REAL                :: lss, teta, zeta
  
  REAL                :: dBu(1:3,0:3,1:Ntz) ! contra-variant components of total magnetic field, and their derivatives; derivatives are probably not required; 15 Oct 12;
  REAL                :: dBl(1:3,0:3,1:Ntz) ! co    -variant components of total magnetic field, and their derivatives; derivatives are probably not required; 15 Oct 12;
  
  REAL                :: Bsqd(1:Ntz)
  
  REAL                :: DRmin, DRmax, DZmin, DZmax ! 11 Oct 12; computational domain; shall compare to mgrid domain;
  
  REAL                :: realij(1:Ntz), imagij(1:Ntz) ! 11 Oct 12; workspace similar to ijreal, etc.
  REAL                :: realji(1:Ntz), imagji(1:Ntz) ! workspace similar to ijreal etc. for computing B^2; 15 Oct 12;
  
  REAL                :: BsubumnC(1:mn), BsubumnP(1:mn), BsubumnT(1:mn) ! 11 Oct 12; covariant poloidal field harmonics: coil, plasma, total;
  REAL                :: BsubvmnC(1:mn), BsubvmnP(1:mn), BsubvmnT(1:mn) ! 11 Oct 12; covariant toroidal field harmonics: coil, plasma, total;
  
  REAL                :: totBBmn(1:mn) ! B^2 at boundary; total             field; 15 Oct 12;
  REAL                :: capBBmn(1:mn) ! B^2 at boundary; coil  plus plasma field; 15 Oct 12;
  
  REAL                :: rzp(1:3) ! cylindrical coordinates; 12 Oct 12;
  REAL                :: xyz(1:3) ! Cartesian   coordinates; 12 Oct 12;
  
  REAL                :: Brzp(1:3), Bxyz(1:3), dBxyzdxyz(1:3,1:3), dBrzpdrzp(1:3,1:3), cosphi, sinphi
  
  REAL                :: vacBrzp(1:3) ! vacuum field as computed by interpolation of mgrid; 12 Oct 12;
  REAL                :: virBrzp(1:3) ! plasma field as computed by virtual casing        ; 12 Oct 12;
  
  REAL                :: toroidalcurrent

  BEGIN(bn00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Lparallel = 1 ! controls choice of parallelization; see below;
  
  Ltangent = 0 ! used in virtual field calculation; the derivatives of the field wrt position are not computed if Ltangent=0;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  lss = interfacelabel(Nvol) ; Lcurv = 1 ; Lcoordinatesingularity = .false.
    
  WCALL(bn00aa,co01aa,( Nvol, lss, Lcurv, Ntz )) ! will need Rij(0:3,:) & Zij(0:3), sg(0,:) and gij(1:6,0,:);
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 .and. nFreeIterations.eq.0 ) then ! 11 Oct 12; just for convenience; to show computational boundary;
   
   DRmin = minval(Rij(0,:)) ; DRmax = maxval(Rij(0,:)) ! 11 Oct 12; 
   DZmin = minval(Zij(0,:)) ; DZmax = maxval(Zij(0,:)) ! 11 Oct 12; 
   
   cput = MPI_WTIME()
   write(ounit,'("bn00aa : " 10x " : ")') ! 11 Oct 12; 
   write(ounit,'("bn00aa : " 10x " : myid="i3" ; [ Rmin, Rmax]=["es13.5" ,"es13.5" ] ; [ Zmin, Zmax]=["es13.5" ,"es13.5" ] ;")') myid,  Rmin,  Rmax,  Zmin,  Zmax ! 23 Oct 12;
   write(ounit,'("bn00aa : " 10x " : myid="i3" ; [DRmin,DRmax]=["es13.5" ,"es13.5" ] ; [DZmin,DZmax]=["es13.5" ,"es13.5" ] ;")') myid, DRmin, DRmax, DZmin, DZmax
   
   if( DRmin.lt.Rmin .or. DRmax.gt.Rmax .or. DZmin.lt.Zmin .or. DZmax.gt.Zmax ) then ! 11 Oct 12; 
    write(ounit,'("bn00aa : " 10x " : ")') ! 23 Oct 12;
    write(ounit,'("bn00aa : " 10x " : myid="i3" ; computational boundary exceeds mgrid domain ; this will certainly cause an error below ;")') myid ! 11 Oct 12; 
   endif
   
  endif ! 11 Oct 12; end of if( myid.eq.0 .and. nFreeIterations.eq.0 ) then
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  ijreal(1:Ntz) = zero ! normal virtual field; 15 Oct 12;
  jireal(1:Ntz) = zero ! normal vacuum  field; 15 Oct 12;
  ijimag(1:Ntz) = zero ! vacuum  covariant poloidal field; 15 Oct 12;
  jiimag(1:Ntz) = zero ! virtual covariant poloidal field; 15 Oct 12;
  
  realij(1:Ntz) = zero ! vacuum  covariant toroidal field; 15 Oct 12;
  imagij(1:Ntz) = zero ! virtual covariant toroidal field; 15 Oct 12;
  realji(1:Ntz) = zero ! B^2; vacuum + virtual field; 15 Oct 12;
  imagji(1:Ntz) = zero ! nothing; 15 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do kk = 0, Nz-1 ; zeta = kk * pi2nfp / Nz ! loop over real space grid; toroidal;
   
   do jj = 0, Nt-1 ; teta = jj * pi2    / Nt ! loop over real space grid; poloidal; note that this is sequential in jj;
    
    jk = 1 + jj + kk*Nt
    
    
    select case( Lparallel ) ! perform in parallel;
    case( 0 )
     if( myid.ne.modulo(kk,ncpu) ) cycle
    case( 1 ) 
     if( myid.ne.modulo(jk-1,ncpu) ) cycle ! 11 Oct 12; this is a weird parallelization, but perhaps better exploits all available cpus;
    case default
     FATALMESS(bn00aa,.true.,invalid Lparallel in parallelization loop)
    end select
    
    
    rzp(1:3) = (/ Rij(0,jk), Zij(0,jk), Itoroidal*zeta /) ! 11 Oct 12; transformation from toroidal to cylindrical coordinates;
    
    FATALMESS(bn00aa, rzp(1).lt.small, divide by zero in coordinate transformation )
    
    
    call mgridfield( rzp(1:3), vacBrzp(1:3), dBrzpdrzp(1:3,1:3), imgridfail ) ! returns coil field in cylindrical coordinates;
    
    FATALMESS(bn00aa,imgridfail.eq.1,outside mgrid domain      ) ! 11 Oct 12; 
    FATALMESS(bn00aa,imgridfail.eq.2,mgrid has not been splined) ! 11 Oct 12; 
    
    
    cosphi = cos( rzp(3) ) ; sinphi = sin( rzp(3) ) ! 11 Oct 12; 
    
    xyz(1:3) = (/ rzp(1)*cosphi, rzp(1)*sinphi, rzp(2) /) ! cylindrical to Cartesian coordinate transformation;
    
    call vc00aa( xyz(1:3), Bxyz(1:3), dBxyzdxyz(1:3,1:3), ivirtualfail ) ! virtual casing: given tangential field on surface, compute field; returns field in Cartesian;
    
    FATALMESS(bn00aa,ivirtualfail.ne.0,an error has occurred in vc00aa)
    
    virBrzp(1) = (   cosphi*Bxyz(1) + sinphi*Bxyz(2) )          ! 10 Oct 12; Cartesian to cylindrical vector;
    virBrzp(2) =            Bxyz(3)                             ! 10 Oct 12; Cartesian to cylindrical vector;
    virBrzp(3) = ( - sinphi*Bxyz(1) + cosphi*Bxyz(2) ) / rzp(1) ! 10 Oct 12; Cartesian to cylindrical vector;
    
!latex \end{enumerate} \subsubsection{free boundary constraints} \begin{enumerate}
    
!latex \item The total normal field at the boundary should be equal to $\left({\bf B}_P + {\bf B}_C\right)\cdot {\bf n}$,
!latex where ${\bf B}_P$ is the plasma field and is computed using virtual casing, 
!latex and ${\bf B}_C$ is the magnetic field produced by the coils, which is computed using Biot-Savart (using the mgrid interpolation).
    
    ijreal(jk) = Zij(2,jk)*Rij(0,jk)*virBrzp(1) + ( Zij(2,jk)*Rij(3,jk)-Rij(2,jk)*Zij(3,jk) )*virBrzp(3) / Rij(0,jk) - Rij(2,jk)*Rij(0,jk)*virBrzp(2) ! normal virtual field;
    jireal(jk) = Zij(2,jk)*Rij(0,jk)*vacBrzp(1) + ( Zij(2,jk)*Rij(3,jk)-Rij(2,jk)*Zij(3,jk) )*vacBrzp(3) / Rij(0,jk) - Rij(2,jk)*Rij(0,jk)*vacBrzp(2) ! normal vacuum  field;
    
    realji(jk) = (vacBrzp(1)+virBrzp(1))**2 + (vacBrzp(2)+virBrzp(2))**2 + (vacBrzp(3)+virBrzp(3))**2 * rzp(1)**2 ! (B_C+B_P)^2; computed in cylindrical; 15 Oct 12;
    
!latex \item The enclosed toroidal current is given by
!latex \be \int_{{\cal S}} {\bf j} \cdot d{\bf S}  =  \int_{\partial {\cal S}} {\bf B} \cdot d{\bf l}   
!latex                                             =  \int_{0}^{2\pi} \!\!\! B_\t \; d\t
!latex                                             =  \int_{0}^{2\pi} \!\!\! (B^\s g_{\s\t}+B^\t g_{\t\t}+B^\z g_{\t\z}) \; d\t
!latex \ee
!latex \be {\bf B} = B^R {\bf e}_R + B^Z {\bf e}_Z + B^\phi {\bf e}_\phi
!latex \ee
!latex \be {\bf e}_\t &=& R_\t \hat {\bf R} + Z_\t \hat {\bf Z},\\
!latex     {\bf e}_\z &=& R_\z \hat {\bf R} + Z_\z \hat {\bf Z} + R \, \hat {\bf \phi},
!latex \ee
!latex \be {\bf B} \cdot {\bf e}_\t &=& B^R R_\t + B^Z Z_\t \\
!latex     {\bf B} \cdot {\bf e}_\z &=& B^R R_\z + B^Z Z_\z + B^\phi R^2
!latex \ee
     
    ijimag(jk) = vacBrzp(1) * Rij(2,jk) + vacBrzp(2) * Zij(2,jk)                                      ! 11 Oct 12; B \cdot e_\t from coils ;
    jiimag(jk) = virBrzp(1) * Rij(2,jk) + virBrzp(2) * Zij(2,jk)                                      ! 11 Oct 12; B \cdot e_\t from plasma;
    
!     realij(jk) = vacBrzp(1) * Rij(3,jk) + vacBrzp(2) * Zij(3,jk) + vacBrzp(3) * rzp(1)    * Itoroidal ! B \cdot e_\z from coils ; 13 Oct 12;
!     imagij(jk) = virBrzp(1) * Rij(3,jk) + virBrzp(2) * Zij(3,jk) + virBrzp(3) * rzp(1)    * Itoroidal ! B \cdot e_\z from plasma; 13 Oct 12;
    
    realij(jk) = vacBrzp(1) * Rij(3,jk) + vacBrzp(2) * Zij(3,jk) + vacBrzp(3) * rzp(1)**2 * Itoroidal ! B \cdot e_\z from coils ; 15 Oct 12;
    imagij(jk) = virBrzp(1) * Rij(3,jk) + virBrzp(2) * Zij(3,jk) + virBrzp(3) * rzp(1)**2 * Itoroidal ! B \cdot e_\z from plasma; 15 Oct 12;
    
   enddo ! end of do jj;
   
  enddo ! end of do kk;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do kk = 0, Nz-1
   
   kkmodnp = modulo(kk,ncpu)
   
   select case( Lparallel )
    
   case( 0 )
    
    RlBCAST(ijreal(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(jireal(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(ijimag(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(jiimag(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(realij(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(imagij(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp)
    RlBCAST(realji(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp) ! 15 Oct 12;
    RlBCAST(imagji(1+kk*Nt:Nt+kk*Nt),Nt,kkmodnp) ! 15 Oct 12;
    
   case( 1 )
    
    do jj = 0, Nt-1
     
     jk = 1 + jj + kk*Nt
     
     jkmodnp = modulo(jk-1,ncpu)
     
     RlBCAST(ijreal(jk),1,jkmodnp)
     RlBCAST(jireal(jk),1,jkmodnp)
     RlBCAST(ijimag(jk),1,jkmodnp)
     RlBCAST(jiimag(jk),1,jkmodnp)
     RlBCAST(realij(jk),1,jkmodnp)
     RlBCAST(imagij(jk),1,jkmodnp)
     RlBCAST(realji(jk),1,jkmodnp) ! 15 Oct 12;
     RlBCAST(imagji(jk),1,jkmodnp) ! 15 Oct 12;
     
    enddo
    
   case default 
    
    FATALMESS(bn00aa,.true.,invalid Lparallel for broadcasting)
    
   end select
   
  enddo ! 11 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  call tfft( Nt, Nz, ijreal, jireal, isr, trigm, trign, trigwk, mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail ) ! Fourier decompose normal field;
  
  iVns(1:mn) = sfmn(1:mn) ! normal harmonics of coil field;     stellarator symmetry; 13 Oct 12;
! iVnc(1:mn) = cfmn(1:mn) ! normal harmonics of coil field; non stellarator symmetry; 13 Oct 12;
  
  ofmn(1:mn) = ( ofmn(1:mn) + iVns(1:mn) ) * pi2 / phiedge ! add virtual field and vacuum field to get total field; ! 17 Oct 12;
  Bnserror = sum( abs( iBns(1:mn) - ofmn(1:mn) ) ) / mn    ! quantify error in assumed normal field at computational boundary; ! 17 Oct 12;
  
  if( myid.eq.0 ) then
   cput = MPI_WTIME()
   write(ounit,'("bn00aa : " 10x " : ")')
   write(ounit,'("bn00aa : "f10.2" : "i3" |dBns|="es10.2" ; dBns="99es7.0)')cput-cpus, nFreeIterations, Bnserror, ofmn(2:mn)-iBns(2:mn) ! 18 Oct 12;
  endif
  
  iBns(1:mn) = norblend * iBns(1:mn) + (one-norblend) * ofmn(1:mn) ! this will `update' assumed normal field at computational boundary; 16 Oct 12;
  
  call tfft( Nt, Nz, realji, imagji, isr, trigm, trign, trigwk, mn, im, in, capBBmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail ) ! B^2; Fourier; 15 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
  if( Lvacuum.ge.3 .and. Bnserror.gt.normalerr .and. nFreeIterations.lt.maxfbits ) then ; Lcontinueiterations = .true.
  else                                                                                  ; Lcontinueiterations = .false.
  endif

  if( Lcontinueiterations ) goto 9999 ! will only show additional diagnostics on final iteration; 18 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  hereafter, ijreal, jireal, realji, imagji may be used as workspace; 15 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  call tfft( Nt, Nz, ijimag, jiimag, isr, trigm, trign, trigwk, mn, im, in, BsubumnC(1:mn), ofmn(1:mn), BsubumnP(1:mn), sfmn(1:mn), ifail ) ! Fourier decompose covariant field;
  call tfft( Nt, Nz, realij, imagij, isr, trigm, trign, trigwk, mn, im, in, BsubvmnC(1:mn), ofmn(1:mn), BsubvmnP(1:mn), sfmn(1:mn), ifail ) ! Fourier decompose covariant field;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  hereafter, ijimag, jiimag, realij, imagij may be used was workspace; 15 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.modulo(Nvol-1,ncpu) ) then ! 11 Oct 12; examine enclosed toroidal current; only this node knows about the vector potential in the outermost volume;
   
   Ldo = 0 ! 11 Oct 12; please remind me what Ldo controls; I believe it is the derivative of the vector potential with (1) helicity multiplier, and (2) enclosed poloidal flux;
   WCALL(bn00aa,sa00aa,( Nvol, lss, Ldo )) ! returns interpolated doAtmn(0,0:2,1:mn), doAzmn(0,0:2,1:mn);
   
   
   ofmn(1:mn) = -          im(1:mn)*doAzmn(0,0,1:mn) -          in(1:mn)*doAtmn(0,0,1:mn) ! harmonics of \sqrt g B^s;
   sfmn(1:mn) = zero
   
   efmn(1:mn)=zero ; cfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(1,0,:), dBu(1,1,:), isr, trigm, trign, trigwk )
   
   efmn(1:mn) =                                      -                   doAzmn(0,1,1:mn) ! harmonics of \sqrt g B^t;
   cfmn(1:mn) = zero
   
   ofmn(1:mn)=zero ; sfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(2,0,:), dBu(2,1,:), isr, trigm, trign, trigwk )
   
   efmn(1:mn) = +                   doAtmn(0,1,1:mn)                                      ! harmonics of \sqrt g B^z; 
   cfmn(1:mn) = zero
   
   ofmn(1:mn)=zero ; sfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(3,0,:), dBu(3,1,:), isr, trigm, trign, trigwk )
   
   dBl(1,0,1:Ntz) = ( dBu(1,0,1:Ntz)*gij(1,0,1:Ntz) + dBu(2,0,1:Ntz)*gij(2,0,1:Ntz) + dBu(3,0,1:Ntz)*gij(3,0,1:Ntz) ) / sg(0,1:Ntz) ! covariant radial  ; 15 Oct 12;
   dBl(2,0,1:Ntz) = ( dBu(1,0,1:Ntz)*gij(2,0,1:Ntz) + dBu(2,0,1:Ntz)*gij(4,0,1:Ntz) + dBu(3,0,1:Ntz)*gij(5,0,1:Ntz) ) / sg(0,1:Ntz) ! covariant poloidal; 15 Oct 12;
   dBl(3,0,1:Ntz) = ( dBu(1,0,1:Ntz)*gij(3,0,1:Ntz) + dBu(2,0,1:Ntz)*gij(5,0,1:Ntz) + dBu(3,0,1:Ntz)*gij(6,0,1:Ntz) ) / sg(0,1:Ntz) ! covariant toroidal; 15 Oct 12;
   
   Bsqd(1:Ntz) = ( dBu(1,0,1:Ntz)*dBl(1,0,1:Ntz) + dBu(2,0,1:Ntz)*dBl(2,0,1:Ntz) + dBu(3,0,1:Ntz)*dBl(3,0,1:Ntz) ) / sg(0,1:Ntz) ! B^2; total field; real space; 15 Oct 12;
   
   
   call tfft( Nt, Nz, dBl(2,0,1:Ntz), dBl(3,0,1:Ntz), isr, trigm, trign, trigwk, mn, im, in, BsubumnT(1:mn), ofmn(1:mn), BsubvmnT(1:mn), sfmn(1:mn), ifail )
   
   call tfft( Nt, Nz, Bsqd(1:Ntz), dBl(3,0,1:Ntz), isr, trigm, trign, trigwk, mn, im, in, totBBmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail ) ! B^2; Fourier; 15 Oct 12;
   
  endif ! end of if( myid.eq.modulo(Nvol,ncpu) );
  
  
  llmodnp = modulo(Nvol-1,ncpu) ! 15 Oct 12;
  
  RlBCAST(BsubumnT(1:mn),mn,llmodnp)
  
  RlBCAST(BsubvmnT(1:mn),mn,llmodnp)
  
  RlBCAST(totBBmn(1:mn),mn,llmodnp)
  
  looperr = BsubvmnT(1)*phiedge+BsubvmnC(1)*pi2 ! 21 Oct 12;
  
  if( myid.eq.0 ) then ! screen diagnostics; 15 Oct 12;
   
!latex \item Realizing that ${\bf j} \equiv \nabla \times {\bf B}$, and that $\nabla \times {\bf B} = \mu {\bf B}$, the total toroidal current may be expressed
!latex \be \int_{{\cal S}} {\bf j}\cdot d{\bf s} = \sum_l \mu_l \int_{{\cal S}_l}{\bf B}\cdot d{\bf s} = \sum_l \mu_l \; \Delta \psi_{t,l}
!latex \ee

   toroidalcurrent = sum( mu(1:Nvol) * dtflux(1:Nvol) ) 
   
   write(ounit,1000) cput-cpus, myid, BsubumnC(1)*pi2, BsubumnP(1)*pi2, BsubumnT(1)*phiedge, toroidalcurrent ! 23 Oct 12;
   write(ounit,1001) cput-cpus, myid, BsubvmnC(1)*pi2, BsubvmnP(1)*pi2, BsubvmnT(1)*phiedge, looperr         ! 21 Oct 12;
   
   write(ounit,1002) ( im(imn), in(imn), BsubvmnC(imn)*pi2,  BsubvmnP(imn)*pi2,  BsubvmnT(imn)*phiedge, totBBmn(imn)*phiedge**2, capBBmn(imn)*pi2**2, imn = 1, mn ) ! 15 Oct 12;
   
1000 format("bn00aa : "f10.2" : myid="i3" : enclosed toroidal current: coils="es23.15" & plasma="es23.15" & total=["es23.15" ,"es23.15" ] ;")
1001 format("bn00aa : "f10.2" : myid="i3" : enclosed poloidal current: coils="es23.15" & plasma="es23.15" & total=["es23.15" ] ; looperr ="es23.15" ;") ! 15 Oct 12;
   
1002 format("bn00aa : " 10x " ("i4" ,"i3" ) : Bsubvmn : C="es13.5" & P="es13.5" & T="es13.5" & totBBmn="es13.5" & capBBmn="es13.5" ;") ! 15 Oct 12;
   
  endif ! end of if( myid.eq.0 ); 15 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(bn00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine bn00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{enclosed current constraints} \begin{enumerate}

!latex \item The enclosed (poloidal) current through a surface bounded by a `toroidal loop', $d{\bf l}\equiv {\bf e}_\z d\z$, is given by
!latex \be \int_{\cal S} {\bf j}\cdot d{\bf s} & = & \int_{\partial {\cal S}} {\bf B}\cdot d{\bf l}       \\
!latex & = & \int_0^{2\pi} \!\!\!\! d\z \; B_\z \\
!latex & = & \int_0^{2\pi} \!\!\!\! d\z \; {\sqrt g}^{-1}
!latex \left[ (\partial_\t A_\z - \partial_\z A_\t)\; g_{\s\z}-\partial_\s A_\z \; g_{\t\z}+\partial_\s A_\t \; g_{\z\z}\right] \\
!latex & = & \sum_j \left[ - A_{\z,j}          \; m_j \int \!\! s_j \; \frac{g_{\s\z}}{\sqrt g} \; d\z - A_{\t,j}          \; n_j \int \!\! s_j \; \frac{g_{\s\z}}{\sqrt g} \; d\z
!latex                     - A_{\z,j}^{\prime}        \int \!\! c_j \; \frac{g_{\t\z}}{\sqrt g} \; d\z + A_{\t,j}^{\prime}        \int \!\! c_j \; \frac{g_{\z\z}}{\sqrt g} \; d\z
!latex              \right] \label{eq:constraints}
!latex \ee

!latex \item The coefficients may be calculated as follows:
!latex \be \int_0^{2\pi} \!\! s_j \; \frac{g_{\s\z}}{\sqrt g} \; d\z & = & \int_0^{2\pi} \! \sum_j f_j \cos(m_j\t-n_j\z)\; d\z \\
!latex & = & \sum_j f_j \int_0^{2\pi} \! \left[\cos(m_j\t)\cos(n_j\z)+\sin(m_j\t)\sin(n_j\z)\right]\; d\z \\
!latex & = & \sum_{j^\prime} f_j \cos(m_j\t) 2\pi,
!latex \ee
!latex where the summation is over $j^\prime$ where $n_j=0$.

!latex \item With $I \equiv \int_{\cal S} {\bf j}\cdot d{\bf s}$, \Eqn{constraints} gives \verb+mn+ constraints between the \verb+4 mn - 2+ degrees of freedom,
!latex namely the $A_{\t,j}$ and $A_{\z,j}$ for $j=2,\dots$\verb+mn+, and the $A_{\t,j}^\prime$ and $A_{\t,j}^\prime$ for $j=1,\dots$\verb+mn+.
!latex Note that the `enclosed toroidal flux' in the vacuum region, $2\pi\psi_t \equiv A_{\t,1}$ does not appear.
