!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs field magnitude on interfaces and writes surface potential to file. Planned redundancy;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine cb02aa( lvol, Ntz, mn, Bdmn, Idmn )
  
  use constants, only : zero, half, one, pi, pi2, goldmean

  use numerical, only : vsmall

  use fileunits, only : ounit, wunit

  use inputlist, only : Wcb02aa, gamma, Ni, mu, Mpol, Ntor, iota, pl, pr, ql, qr, Nfp, ext, Nvol, adiabatic, pscale, Lgeometry, Le04dgf

  use cputiming, only : Tcb02aa

  use allglobal, only : myid, cpus, pi2nfp,                                                                &
                        interfacelabel, Nt, Nz,                                                            &
                        im, in, mpnq,                                                                      &
                        efmn, ofmn, cfmn, sfmn, isr, trigm, trign, trigwk, ijreal, ijimag, jireal, jiimag, &
                        sg, gij, Rij, Zij,                                                                 &
                        doAtmn, doAzmn,                                                                    &
                        iRbc, iZbs, NGdof,                                                                   &
                        lvolume,                                                                           &
                        Iwrpj
                              
  use pjhamilto, only : Itor, Gpol, spmn
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER, intent(in)  :: lvol, Ntz, mn
  REAL   , intent(out) :: Bdmn(0:1,1:mn), Idmn(1:mn)
  
  INTEGER              :: iocons, imn, jmn, kmn, mmi, mmj, mmk, nni, nnj, nnk, nn, ifail, lli, Lcurv, Ldo
  REAL                 :: lss, swI(1:Ntz)
  CHARACTER            :: pjsuf*6 ! this suffix labels the .pj files that will be written;
  
  BEGIN(cb02aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Bdmn(0,1:mn) = zero ; Bdmn(1,1:mn) = one ; Idmn(1:mn) = one ! initialize "intent out";
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(cb02aa,.true.,argument list of sw02aa has changed)
  
  if( Lgeometry.le.3 ) then ;                               swI(1:Ntz)      = zero !            angle constraints are not required;
  else                      ; WCALL(cb02aa,sw02aa,(Ntz,lvol,swI(1:Ntz),mn))        ! calculates angle constraints                 ;
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do iocons = 0, 1 ! loop over inner/outer interfaces;
   
   if( lvol.eq.1    .and. iocons.eq.0 ) cycle ! dont require field magnitude on coordinate axis;
   if( lvol.eq.Nvol .and. iocons.eq.1 ) cycle ! dont require field magnitude on outer boundary;
   
   FATALMESS(cb02aa,lvol-1+iocons.lt.0 .or. lvol-1+iocons.gt.Nvol,invalid volume)

   lss = interfacelabel(lvol-1+iocons) ! radial coordinate;
   
   Lcurv = 1 ; WCALL(cb02aa,co01aa,(lvol, lss, Lcurv, Ntz)) ! will need sg(0,:) and gij(1:6,0,:); note that sg(1:3,:) and gij(1:6,1:3,:) are available as workspace arrays;

   Ldo = 0
   WCALL(cb02aa,sa00aa,(lvol, lss, Ldo)) ! returns radially interpolated Fourier harmonics of vector potential through global doAtmn(0,1,1:mn) & doAzmn(0,1,1:mn);
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \end{enumerate} \subsection{field magnitude} \begin{enumerate}
   
!latex \item The contravariant components of \mbox{${\bf B}$} are obtained from \mbox{${\bf B}=\nabla\times(A_\theta\nabla\theta+A_\zeta\nabla\zeta)$}, giving
!latex \be \begin{array}{ccccccccccccc} B^\s & = & ( & \partial_\t A_\z & - & \partial_\z  A_\t & ) & / & \sqrt g, \\
!latex                                  B^\t & = &   &                  & - & \partial_\s  A_\z &   & / & \sqrt g, \\
!latex                                  B^\z & = &   & \partial_\s A_\t &   &                   &   & / & \sqrt g.
!latex \end{array} \ee

!latex \item On the interfaces, $B^\s=0$ by constraint.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   efmn(1:mn) = - doAzmn(0,1,1:mn) ! doAzmn(1,1:mn) = \partial_s A_z;
   cfmn(1:mn) =   doAtmn(0,1,1:mn) ! doAtmn(1,1:mn) = \partial_s A_z;
   
   ofmn(1:mn) = zero ; sfmn(1:mn) = zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, gij(2,1,:), gij(3,1,:), isr, trigm, trign, trigwk )
   
   gij(2,1,:) = gij(2,1,:) / sg(0,:) ! B^\t;
   gij(3,1,:) = gij(3,1,:) / sg(0,:) ! B^\z;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item The covariant components of ${\bf B}=B_\s \nabla \s + B_\t \nabla \t + B_\z \nabla \z$ are determined using the lowering metrics, $g_{ij}$,
!latex \be B_\s &=& B^\s g_{\s\s} + B^\t g_{\s\t} + B^\z g_{\s\z}, \\
!latex     B_\t &=& B^\s g_{\s\t} + B^\t g_{\t\t} + B^\z g_{\t\z}, \\
!latex     B_\z &=& B^\s g_{\s\z} + B^\t g_{\t\z} + B^\z g_{\z\z}.
!latex \ee
   
   gij(2,2,:) = gij(2,1,:) * gij(4,0,:) + gij(3,1,:) * gij(5,0,:) ! B_\t ; gij(4,0,:) = g_{\theta,\theta} & gij(5,0,:) = g_{\theta,\zeta} ;
   gij(3,2,:) = gij(2,1,:) * gij(5,0,:) + gij(3,1,:) * gij(6,0,:) ! B_\z ;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \end{enumerate} \subsection{interface force balance} \begin{enumerate}
   
!latex \item The force balance condition depends on the quantity $[[p+B^2/2]]$,
!latex where the pressure is given $p = P/V^\gamma$ where $P$ is an adiabatic constant,
!latex and the field magnitude is given $B^2 = B^\t B_\t + B^\z B_\z$.
   
!latex \item A fast Fourier transform of $[[p+B^2/2]]$ provides a discrete set of constraints.
   
  !FATALMESS(cb02aa,lvolume(lvol).lt.vsmall,zero denominator)
   
   ijreal(1:Ntz) = adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) )  ! p + B^2/2 on interface;
   
   ijimag(1:Ntz) = swI(1:Ntz) ! swI calculated in above call to sw02aa;
   
   call tfft( Nt,Nz,ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),Bdmn(iocons,1:mn),ofmn(1:mn),cfmn(1:mn),Idmn(1:mn),ifail )
   
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \item If angle constraints are also required, a fast Fourier transform of the spectral width extremizing condition, $I\equiv R_\t X + Z_\t Y$, is constructed.

!latex If \verb+Wcb02aa.eq.T+, then the FFT of $I$ is compared to the ``analytic'' construction of the $I_j$ as computed by double angle formulae.

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
   
   if( Wcb02aa .and. iocons.eq.1 ) then ! shall compare fast Fourier transform of swI with direct construction;
    
    ofmn(1:mn) = zero ! initialize summation variable; all harmonics;
    
    do jmn = 2, mn ; mmj = im(jmn) ; nnj = in(jmn) ! odd symmetry guarantees that I_i=0 for m_i=0, n_i=0, so probably not required to consider i=1;
     
     do imn = 1, mn ; mmi = im(imn) ; nni = in(imn) ! with some effort, if required, could eliminate loops for efficiency;
      do kmn = 2, mn ; mmk = im(kmn) ; nnk = in(kmn)
       
       if( mmi+mmk.eq.mmj .and. nni+nnk.eq.nnj ) ofmn(jmn) = ofmn(jmn) + mmi * mpnq(kmn) * ( iZbs(lvol,imn)*iZbs(lvol,kmn) - iRbc(lvol,imn)*iRbc(lvol,kmn) )
       if( mmi-mmk.eq.mmj .and. nni-nnk.eq.nnj ) ofmn(jmn) = ofmn(jmn) - mmi * mpnq(kmn) * ( iZbs(lvol,imn)*iZbs(lvol,kmn) + iRbc(lvol,imn)*iRbc(lvol,kmn) )
       if( mmk-mmi.eq.mmj .and. nnk-nni.eq.nnj ) ofmn(jmn) = ofmn(jmn) + mmi * mpnq(kmn) * ( iZbs(lvol,imn)*iZbs(lvol,kmn) + iRbc(lvol,imn)*iRbc(lvol,kmn) )
       
      enddo ! end of do kmn;
     enddo ! end of do imn;

     ofmn(jmn) = half * ofmn(jmn)

     cput = MPI_WTIME()
     write(ounit,'("cb02aa : "f10.2" : myid="i3" ; lvol="i3" ; (m,n)=("i3" ,"i4" ) ; Idmn="es13.5" ; err="es9.1" ;")')cput-cpus,myid,lvol,mmi,nni,Idmn(jmn),Idmn(jmn)-ofmn(jmn)
     
    enddo
    
   endif ! end of if( Wcb02aa ) ;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
   
#ifdef PRELIMINARY

   if( Le04dgf ) then ! require gradient of energy functional;
        
!latex \end{enumerate} \subsection{energy functional gradient} \begin{enumerate}
!latex \item Consider 
!latex \be \delta F = - \int_{\cal I} [[p+B^2/2]] \; \boldxi \cdot {\bf dS} = - \int \!\!\!\!\! \int [[p+B^2/2]] \; \boldxi \cdot {\bf e}_\t \times {\bf e}_\z \; d\t d\z.
!latex \ee
   
   select case( Lgeometry ) !latex \begin{enumerate}
    
!latex \item \verb+Lgeometry.eq.1+ Cartesian geometry: 
!latex \be {\bf x} = \t \; \hat {\bf i} + \z \; \hat {\bf j}+ R \; \hat {\bf k}\ee
!latex \be {\bf e}_\theta \times {\bf e}_\zeta = \hat {\bf i} \times \hat {\bf j} + R_\z \; \hat {\bf i} \times \hat {\bf k} + R_\t \; \hat {\bf k} \times \hat {\bf j}\ee
!latex \be \delta {\bf x} \cdot {\bf e}_\theta \times {\bf e}_\zeta = \delta R\ee
!latex \be \frac{\partial F}{\partial R_j} = [[p+B^2/2]]_j\ee
    
   case( 1 ) 
    
    lthEnergy(lvol,iocons,1   ) = Bdmn(iocons,1   ) * pi2 * pi2nfp ! I am not sure why the pi2 * pi2nfp factor is required; need to check construction of \int A.B dv;
    lthEnergy(lvol,iocons,2:mn) = Bdmn(iocons,2:mn) * pi  * pi2nfp
    
!latex \item \verb+Lgeometry.eq.2+ cylindrical:
!latex \be{\bf x} = R \cos\t \, {\bf \hat i} + R \sin\t \, {\bf \hat j} + \z \, {\bf \hat k}\ee
!latex \be {\bf e}_\theta \times {\bf e}_\zeta = - R Z_\theta \hat R + (Z_\theta R_\zeta - R_\theta Z_\zeta) \hat \phi + R R_\theta \hat z\ee
!latex \be \delta {\bf x}\cdot {\bf e}_\theta \times {\bf e}_\zeta =  \delta R \; R \ee
!latex \be \frac{\partial F}{\partial R_j} &=& - \left( [[ p + B^2/2 ]] \; R \right)_j
!latex \ee
    
   case( 2 ) ! THIS NEEDS CHECKING;
    
    ijreal(1:Ntz) = - ( adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * Rij(0,:)
    ijimag(1:Ntz) =   zero
    
    call tfft( Nt,Nz,ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),efmn(1:mn),ofmn(1:mn),cfmn(1:mn),sfmn(1:mn),ifail )
    
    lthEnergy(lvol,iocons,   1        ) = efmn(1   ) * pi2 * pi2nfp ! I am not sure why the pi2 * pi2nfp factor is required; need to check construction of \int A.B dv;
    lthEnergy(lvol,iocons,   2:mn     ) = efmn(2:mn) * pi  * pi2nfp
    
!latex \item \verb+Lgeometry.eq.5+ cylindrical:
!latex \be{\bf x} = R \, {\bf \hat i} + Z \, {\bf \hat j} + \zeta \, {\bf \hat k}\ee
!latex \be {\bf e}_\theta \times {\bf e}_\zeta = Z_\theta {\bf \hat i} - R_\theta {\bf \hat j} \ee
!latex \be \delta {\bf x}\cdot {\bf e}_\theta \times {\bf e}_\zeta = +\delta R\; Z_\t - \delta Z\; R_\t\ee
!latex \be \frac{\partial F}{\partial R_j} &=& + \left( [[ p + B^2/2 ]] \; Z_\t \right)_j\\
!latex     \frac{\partial F}{\partial Z_j} &=& - \left( [[ p + B^2/2 ]] \; R_\t \right)_j.
!latex \ee
    
   case (5)
    
    ijreal(1:Ntz) = + ( adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * Zij(2,:)
    ijimag(1:Ntz) = - ( adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * Rij(2,:)
    
    call tfft( Nt,Nz,ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),efmn(1:mn),ofmn(1:mn),cfmn(1:mn),sfmn(1:mn),ifail )
    
    lthEnergy(lvol,iocons,   1        ) = efmn(1   ) * pi2 * pi2nfp ! I am not sure why the pi2 * pi2nfp factor is required; need to check construction of \int A.B dv;
    lthEnergy(lvol,iocons,   2:mn     ) = efmn(2:mn) * pi  * pi2nfp
    lthEnergy(lvol,iocons,mn+1:mn+mn-1) = sfmn(2:mn) * pi  * pi2nfp
    
!latex \item \verb+Lgeometry.eq.6+ toroidal geometry:
!latex \be{\bf x} = R \, {\bf \hat R} + Z \, {\bf \hat k}\ee
!latex \be {\bf e}_\theta \times {\bf e}_\zeta = - R Z_\theta \hat R + (Z_\theta R_\zeta - R_\theta Z_\zeta) \hat \phi + R R_\theta \hat z\ee
!latex \be \delta {\bf x}\cdot {\bf e}_\theta \times {\bf e}_\zeta = - \delta R \; R \; Z_\t + \delta Z \; R \; R_\t\ee
!latex \be \frac{\partial F}{\partial R_j} &=& - \left( [[ p + B^2/2 ]] \; R \; Z_\t \right)_j\\
!latex     \frac{\partial F}{\partial Z_j} &=& + \left( [[ p + B^2/2 ]] \; R \; R_\t \right)_j.
!latex \ee
    
   case( 6 )
    
    ijreal(1:Ntz) = - ( adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * Rij(0,:) * Zij(2,:)
    ijimag(1:Ntz) =   ( adiabatic(lvol) * pscale / lvolume(lvol)**gamma + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * Rij(0,:) * Rij(2,:)
    
    call tfft( Nt,Nz,ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),efmn(1:mn),ofmn(1:mn),cfmn(1:mn),sfmn(1:mn),ifail )
    
    lthEnergy(lvol,iocons,   1        ) = efmn(1   ) * pi2 * pi2nfp ! I am not sure why the pi2 * pi2nfp factor is required; need to check construction of \int A.B dv;
    lthEnergy(lvol,iocons,   2:mn     ) = efmn(2:mn) * pi  * pi2nfp
    lthEnergy(lvol,iocons,mn+1:mn+mn-1) = sfmn(2:mn) * pi  * pi2nfp
    
   case default
    
    FATALMESS(cb02aa,.true.,invalid Lgeometry)
    
   end select !latex \end{enumerate}
   
  endif ! end of if( Le04dgf )

#endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \end{enumerate}\subsection{construction of surface potential} \begin{enumerate}
   
!latex \item From \mbox{$\nabla\times{\bf B}=\mu {\bf B}$}, and \mbox{$B^s\equiv{\bf B}\cdot\nabla s=0$} on the interfaces,
!latex we obtain \mbox{$B_\theta=\partial_\theta f$} and \mbox{$B_\zeta = \partial_\zeta f$} where
!latex \be f = I \t + G \z + \sum_j f_j \sin(m_j \t - n \z). \label{eq:surfacepotential}
!latex \ee
   
!latex \item The $I$, $G$ and $f_j$ are constructed from a fast Fourier transform of $B_\t$ and $B_\z$.
   
   if( Iwrpj ) then ! only in this case is (mu,dpflux) adjusted to match prescribed transform;
    
!compute harmonics of B_\theta, B_\zeta; be careful not to corrupt jireal and jiimag;
    call tfft( Nt, Nz, gij(2,2,:), gij(3,2,:), isr, trigm, trign, trigwk, mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail )
    
    Itor(lvol,iocons) = efmn(1) ; Gpol(lvol,iocons) = cfmn(1) ! secular terms;
    do imn = 1, mn
     if( im(imn).eq.0 .and. in(imn).eq.0 ) spmn(lvol,iocons,imn) = zero                                            
     if( im(imn).eq.0 .and. in(imn).ne.0 ) spmn(lvol,iocons,imn) =                              - cfmn(imn) / in(imn)
     if( im(imn).ne.0 .and. in(imn).eq.0 ) spmn(lvol,iocons,imn) =          efmn(imn) / im(imn)                        
     if( im(imn).ne.0 .and. in(imn).ne.0 ) spmn(lvol,iocons,imn) = half * ( efmn(imn) / im(imn) - cfmn(imn) / in(imn) )
    enddo
    
!latex \item The information required for the pressure-jump Hamiltonian analysis of interface force balance is written to file, named
!latex \verb+ext.pjh:xxxx:i+, where the \verb+xxxx+ labels volume and \verb+i+ selects the inner, \verb+i=0+, or outer, \verb+i=1+, adjacent interface of that volume.
!latex With the convention that volume ${\cal V}_{l}$ is bounded by the ${\cal I}_{l-1}$ and ${\cal I}_{l}$ interfaces, we have, for example,
!latex \begin{itemize}
!latex \item \verb+ext.pjh:0001:1+ contains the surface potential on the inner side of the $l=1$ interface \\ (which is computed using the field in ${\cal V}_{1}$), and
!latex \item \verb+ext.pjh:0002:0+ contains the surface potential on the outer side of the $l=1$ interface \\ (which is computed using the field in ${\cal V}_{2}$).
!latex \end{itemize}
!latex \item This \verb+ext.pjh:xxxx:i+ file has the following form:
!latex
!latex \hrule
!latex
!latex \verb+Lgeometry                  ! integer+
!latex
!latex \verb+I  G  pl  ql  pr  qr  iota ! real real integer integer integer integer real+
!latex
!latex \verb+mn                         ! integer+ 
!latex
!latex \verb+m_1  n_1  f_1  R_1  Z_1    !+ 
!latex
!latex \verb+m_2  n_2  f_2  R_2  Z_2    !+
!latex
!latex \verb+ .    .    .    .    .     !+
!latex
!latex \verb+m_j  n_j  f_j  R_j  Z_j    ! integer integer real real real+
!latex
!latex \hrule
!latex 
!latex \item The $I$, $G$, $m_j$, $n_j$ and $f_j$ for $j=1,$\verb+mn+ match \Eqn{surfacepotential}, is the total number of Fourier harmonics.
!latex \item The rotational transform of the interface is given by
!latex $\iotabar = (p_l + \gamma p_r)/(q_l + \gamma q_r)$, where $\gamma=(1+\sqrt 5)/2=1.6180339 \dots$ is the golden mean.
!latex \item The geometry of the interface is described by the $R=\sum_j R_j \cos(m_j\t-n_j\z)$ and $Z=\sum_j Z_j \sin(m_j\t-n_j\z)$ according to
!latex \begin{itemize}
!latex \item if \verb+Lgeometry.eq.1+, Cartesian: ${\bf x} = \t \; \hat {\bf i} + \z \; \hat {\bf j}+ R(\s,\t,\z) \; \hat {\bf k}$,
!latex \item if \verb+Lgeometry.eq.6+, toroidal: ${\bf x}=R(\s,\t,\z)\hat {\bf R} + Z(\s,\t,\z) \hat {\bf k}$,
!latex where $\hat {\bf R}\equiv \cos\z \; \hat{\bf i} + \sin \z \; \hat{\bf j}$.
!latex \end{itemize}
    
    lli = lvol-1 + iocons ! shorthand; 
    write(pjsuf,'(i4.4":"i1)')lvol,iocons    
    open(wunit+myid,file=trim(ext)//".pjh:"//pjsuf,status="unknown")
    write(wunit+myid,'(i2)')Lgeometry
    write(wunit+myid,'(2es23.15,4i6,es23.15)')Itor(lvol,iocons),Gpol(lvol,iocons),pl(lli),ql(lli),pr(lli),qr(lli),iota(lli)
    write(wunit+myid,'(i6)')mn
    write(wunit+myid,'(2i6,3es23.15)')(im(imn),in(imn),spmn(lvol,iocons,imn),iRbc(lli,imn),iZbs(lli,imn),imn=1,mn)
    close(wunit+myid)
    
   endif ! end of if( Iwrpj ) then 
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!l!tex \end{enumerate}\subsubsection{comments} \begin{enumerate}
!l!tex \item The remaining covariant component is given \mbox{$B_s=(B^s-g^{s,\theta}B_\theta-g^{s,\zeta}B_\zeta)/g^{ss}$}.
!l!tex This allows the expression
!l!tex \be B^2 = \frac{ g_{\zeta\zeta} B_\theta B_\theta + 2 g_{\theta\zeta} B_\theta B_\zeta + g_{\theta\theta} B_\zeta B_\zeta}
!l!tex                {\sqrt g \, \sqrt g \, g^{ss}}.\ee
!l!tex NOTE: this should be checked!!!!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  enddo ! end of do iocons=0,Ni(lvol),Ni(lvol) loop over inner and outer interfaces
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(cb02aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine cb02aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

