!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Calculates coordinates, and metrics, at arbitrary position using a slow Fourier transform.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine co00aa( lvol , stz , RpZ , dR , dZ , jacobian )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one, half
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wco00aa, Itoroidal, Nvol, Lgeometry
  use cputiming, only : Tco00aa
  use allglobal, only : myid, cpus, mn, im, in, iRbc, iZbs, interfacelabel, Lcoordinatesingularity

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS   

  INTEGER, intent(in) :: lvol

  REAL, intent(in)  :: stz(1:3)
  REAL, intent(out) :: RpZ(1:3), dR(0:3), dZ(0:3), jacobian ! coordinates R,\phi,Z;

  INTEGER           :: imn
  REAL              :: lRmn(0:1), lZmn(0:1), lss, arg, carg, sarg, hmm, isshm

  BEGIN(co00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(co00aa,lvol-1.lt.0.or.lvol.gt.Nvol,invalid interface label)

  lss = min( max(stz(1),interfacelabel(lvol-1)) , interfacelabel(lvol) ) ! ensure that radial coordinate is within local domain;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RpZ(1:3) = zero ; jacobian = zero ! initialize intent(out) quantities;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  dR(0:3) = zero ; dZ(0:3) = zero ! initialize summation quantities to zero;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{interpolation of Fourier harmonics} \begin{enumerate}

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do imn = 1 , mn ! loop over Fourier modes;
   
!  if( imask(imn).le.0 ) cycle
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   lRmn(0:1) = zero ; lZmn(0:1) = zero ; arg = im(imn)*stz(2) - in(imn)*stz(3) ; carg = cos(arg) ; sarg = sin(arg)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   lRmn(0) = iRbc(lvol-1,imn) + ( iRbc(lvol,imn) - iRbc(lvol-1,imn) ) * ( lss - interfacelabel(lvol-1) ) / ( interfacelabel(lvol)-interfacelabel(lvol-1) ) 
   lRmn(1) =                    ( iRbc(lvol,imn) - iRbc(lvol-1,imn) )                                    / ( interfacelabel(lvol)-interfacelabel(lvol-1) ) 
   
   lZmn(0) = iZbs(lvol-1,imn) + ( iZbs(lvol,imn) - iZbs(lvol-1,imn) ) * ( lss - interfacelabel(lvol-1) ) / ( interfacelabel(lvol)-interfacelabel(lvol-1) ) 
   lZmn(1) =                    ( iZbs(lvol,imn) - iZbs(lvol-1,imn) )                                    / ( interfacelabel(lvol)-interfacelabel(lvol-1) ) 
   
!  if( lvol.eq.1 .and. ( Lgeometry.eq.2 .or. Lgeometry.eq.3 .or. Lgeometry.eq.5 .or. Lgeometry.eq.6 ) ) then ! 10 Oct 12;
   if( Lcoordinatesingularity ) then ! 10 Oct 12;
    
    select case( Lgeometry )
    case( 2 )    ; hmm = half + im(imn) * half
    case( 3 )    ; hmm = half + im(imn) * half
    case( 5 )    ; hmm =        im(imn) * half
    case( 6 )    ; hmm =        im(imn) * half
    case default ; FATALMESS(co0aaa,.true.,invalid Lgeometry : hmm not set) 
    end select
    
    isshm=interfacelabel(1)**hmm
    
    lRmn(0) = ( iRbc(1,imn) / isshm ) * lss**hmm
    lZmn(0) = ( iZbs(1,imn) / isshm ) * lss**hmm
    
    FATALMESS(co00aa,lss.lt.vsmall .and. hmm-one.lt.zero,error in dx1**dx2 where dx1=0 and dx2 < 0)
    
    lRmn(1) = ( iRbc(1,imn) / isshm ) * lss**(hmm-one) * hmm
    lZmn(1) = ( iZbs(1,imn) / isshm ) * lss**(hmm-one) * hmm
    
   endif ! end of if( Lcoordinatesingularity );
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   dR(0) = dR(0) + lRmn(0) * carg                !   R
   dR(1) = dR(1) + lRmn(1) * carg                ! d R / d s
   dR(2) = dR(2) + lRmn(0) * sarg * ( -im(imn) ) ! d R / d t
   dR(3) = dR(3) + lRmn(0) * sarg * ( +in(imn) ) ! d R / d z
   
   dZ(0) = dZ(0) + lZmn(0) * sarg                !   Z
   dZ(1) = dZ(1) + lZmn(1) * sarg                ! d Z / d s
   dZ(2) = dZ(2) + lZmn(0) * carg * ( +im(imn) ) ! d Z / d t
   dZ(3) = dZ(3) + lZmn(0) * carg * ( -in(imn) ) ! d Z / d z
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  enddo ! end of do imn = 1, mn ; Fourier summation loop;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RpZ(1:3) = (/ dR(0) ,  stz(3) , dZ(0) /) ! return coordinate functions;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! coordinate transformation ; needs checking;

!latex \item The jacobian is 
!latex \begin{enumerate}
!latex \item \verb+Lgeometry.eq.1+ : Cartesian   : $\sqrt g = R_s$.
!latex \item \verb+Lgeometry.eq.2+ : cylindrical : $\sqrt g = R R_s$.
!latex \item \verb+Lgeometry.eq.3+ : toroidal    : under construction;
!latex \item \verb+Lgeometry.eq.4+ : Cartesian   : under construction;
!latex \item \verb+Lgeometry.eq.5+ : cylindrical : $\sqrt g = R_s Z_\theta - R_\theta Z_s$.
!latex \item \verb+Lgeometry.eq.6+ : toroidal    : $\sqrt g = R ( R_s Z_\theta - R_\theta Z_s )$.
!latex \end{enumerate}

  select case( Lgeometry )
  case( 1 ) ; jacobian =         dR(1)                                       ! Cartesian;
  case( 2 ) ; jacobian = dR(0) * dR(1)                                       ! cylindrical;
  case( 3 ) ; jacobian = dR(0) * dR(1) * ( iRbc(0,1) + dR(0) * cos(stz(2)) ) ! toroidal;
! case( 4 ) ;                                                                ! Cartesian;
  case( 5 ) ; jacobian =                       dR(1)*dZ(2) - dR(2)*dZ(1)     ! cylindrical;
  case( 6 ) ; jacobian = Itoroidal * dR(0) * ( dR(2)*dZ(1) - dR(1)*dZ(2) )   ! toroidal; toroidal angle \zeta \equiv cylindrical angle \phi;
  case default
   FATALMESS(co00aa,.true.,invalid Lgeometry)
  end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  if( Wco00aa ) then ! What's the Jacobian, and what's the position? ! 10 Oct 12; to be deleted;
!   write(ounit,'("co00aa : jacobian(lvol="i3", s="es15.5", theta="es15.5", zeta="es15.5") = "es23.15" ;")')lvol,stz(1),stz(2),stz(3),jacobian
!   write(ounit,'("co00aa : dR = "4es15.5" ; dZ = "5es15.5" ;")')dR,dZ
!  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(co00aa,abs(jacobian).lt.vsmall,it seems an error has occured constructing the jacobian)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(co00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine co00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
