!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Inverts coordinates.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module rzinverse

  REAL :: ll
  REAL :: toroidalangle, RZ(1:2)
  
end module rzinverse

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine co02aa( RpZ, stz, ifail )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only :

  use numerical, only : vsmall

  use fileunits, only : ounit

  use inputlist, only : Wco02aa

  use cputiming, only : Tco02aa

  use allglobal, only : myid, cpus
  
  use rzinverse

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS   

  REAL, intent(in)  :: RpZ(1:3)
  REAL              :: stz(1:3) ! on entry: user supplied guess; on exit: coordinates that map to given (R,\phi,Z);
  INTEGER           :: ifail

  INTEGER           :: NN, LDFJAC, LWA, ic05pbf
  REAL              :: ST(1:2), FVEC(1:2), FJAC(1:2,1:2), xtol, WA(1:15)
  EXTERNAL          :: co02ab

  BEGIN(co02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  toroidalangle = RpZ(2) ; RZ(1:2) = (/ RpZ(1) , RpZ(3) /) ! this information must be passed through to below;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  NN = 2 ; LDFJAC = NN ; LWA = NN * ( NN + 13 ) / 2 ; xtol = vsmall
  
  FATALMESS(co02aa, LWA.ne.15, error )
  
  ST(1:2) = (/ stz(1) , stz(2) /) ! initial guess;
  
  ic05pbf = 1
  call C05PBF(co02ab, NN, ST, FVEC, FJAC, LDFJAC, xtol, WA(1:LWA), LWA, ic05pbf )

  stz(1) = ST(1) ; stz(2) = ST(2) ; stz(3) = toroidalangle

  select case( ic05pbf )
  case(   0 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; success ;                ")')ic05pbf, stz(1:3), RpZ(1:3)
  case( :-1 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; user termination ;       ")')ic05pbf, stz(1:3), RpZ(1:3)
  case(   1 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; input error ;            ")')ic05pbf, stz(1:3), RpZ(1:3)
  case(   2 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; 100 N calcuations ;      ")')ic05pbf, stz(1:3), RpZ(1:3)
  case(   3 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; no further improvement ; ")')ic05pbf, stz(1:3), RpZ(1:3)
  case(   4 )   ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; bad progress ;           ")')ic05pbf, stz(1:3), RpZ(1:3)
  case default  ; write(ounit,'("co02aa : " 10x " : ic05pbf="i3" ; stz="3f15.10" ; RpZ="3f15.10" ; illegal ifail ;          ")')ic05pbf, stz(1:3), RpZ(1:3)
  end select

  ifail = ic05pbf
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! pressure(ll)
!
! call bf00aa( arblabel, st, Bst )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(co02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine co02aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine co02ab( N, ST, FVEC, FJAC, LDFJAC, IFLAG ) ! need toroidal angle;
  
  use constants, only : zero, half, one
  
  use numerical, only : vsmall
  
  use fileunits, only : ounit
  
  use inputlist, only : Itoroidal, Lgeometry, Nvol
  
  use cputiming, only :
  
  use allglobal, only : myid, cpus, mn, im, in, iRbc, iZbs, interfacelabel
  
  use rzinverse

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER           :: N, LDFJAC, IFLAG
  REAL              :: ST(1:N), FVEC(1:N), FJAC(1:LDFJAC,1:N)
  
  INTEGER           :: imn, ivol
  REAL              :: dR(0:3), dZ(0:3), lRmn(0:1), lZmn(0:1), arg, carg, sarg, lss, hmm, isshm
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(co02aa,N.ne.2,inconsistent)
  
  FVEC(1:2) = zero
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  dR(0:3) = zero ; dZ(0:3) = zero ! function values and derivatives; initialize summation quantities to zero;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! need to identify volume;
  
  lss = ST(1) ! shorthand;

  ll = 0 ! default;
  
  if    ( lss.lt.interfacelabel(     1)                                     ) then ; ll =    1
  elseif( lss.ge.interfacelabel(Nvol-1)                                     ) then ; ll = Nvol
  elseif( lss.ge.interfacelabel(     1) .and. lss.lt.interfacelabel(Nvol-1) ) then ;
   do ivol = 2, Nvol-1
    if  ( lss.ge.interfacelabel(ivol-1) .and. lss.lt.interfacelabel(ivol  ) ) then ; ll = ivol ; exit
    endif
   enddo
  else
   FATALMESS(co02aa,.true.,failed to identify volume)
  endif

  FATALMESS(co02aa,ll.lt.1.or.ll.gt.Nvol,invalid volume)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do imn = 1, mn ! loop over Fourier modes;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   lRmn(0:1) = zero ; lZmn(0:1) = zero ; arg = im(imn)*ST(2) - in(imn)*toroidalangle ; carg = cos(arg) ; sarg = sin(arg)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   lRmn(0) = iRbc(ll-1,imn) + ( iRbc(ll,imn) - iRbc(ll-1,imn) ) * ( lss - interfacelabel(ll-1) ) / ( interfacelabel(ll)-interfacelabel(ll-1) ) 
   lRmn(1) =                  ( iRbc(ll,imn) - iRbc(ll-1,imn) )                                  / ( interfacelabel(ll)-interfacelabel(ll-1) ) 
   
   lZmn(0) = iZbs(ll-1,imn) + ( iZbs(ll,imn) - iZbs(ll-1,imn) ) * ( lss - interfacelabel(ll-1) ) / ( interfacelabel(ll)-interfacelabel(ll-1) ) 
   lZmn(1) =                  ( iZbs(ll,imn) - iZbs(ll-1,imn) )                                  / ( interfacelabel(ll)-interfacelabel(ll-1) ) 
   
   if( ll.eq.1 .and. ( Lgeometry.eq.2 .or. Lgeometry.eq.3 .or. Lgeometry.eq.5 .or. Lgeometry.eq.6 ) ) then ! include regularization factor on geometry;
    
    select case( Lgeometry )
    case( 2 )    ; hmm = half + im(imn) * half
    case( 3 )    ; hmm = half + im(imn) * half
    case( 5 )    ; hmm =        im(imn) * half
    case( 6 )    ; hmm =        im(imn) * half
    case default ; FATALMESS(co0aaa,.true.,invalid Lgeometry : hmm not set) 
    end select
    
    isshm = interfacelabel(1)**hmm
    
    lRmn(0) = ( iRbc(1,imn) / isshm ) * lss**hmm
    lZmn(0) = ( iZbs(1,imn) / isshm ) * lss**hmm
    
    FATALMESS(co02aa,lss.lt.vsmall .and. hmm-one.lt.zero,error in dx1**dx2 where dx1=0 and dx2 < 0)
    
    lRmn(1) = ( iRbc(1,imn) / isshm ) * lss**(hmm-one) * hmm
    lZmn(1) = ( iZbs(1,imn) / isshm ) * lss**(hmm-one) * hmm
    
   endif ! end of if( ll.eq.1 .and. ( Lgeometry.eq.2 .or. Lgeometry.eq.3 .or. Lgeometry.eq.5 .or. Lgeometry.eq.6 ) ) then;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   dR(0) = dR(0) + lRmn(0) * carg                !   R
   dR(1) = dR(1) + lRmn(1) * carg                ! d R / d s
   dR(2) = dR(2) + lRmn(0) * sarg * ( -im(imn) ) ! d R / d t
   dR(3) = dR(3) + lRmn(0) * sarg * ( +in(imn) ) ! d R / d z
   
   dZ(0) = dZ(0) + lZmn(0) * sarg                !   Z
   dZ(1) = dZ(1) + lZmn(1) * sarg                ! d Z / d s
   dZ(2) = dZ(2) + lZmn(0) * carg * ( +im(imn) ) ! d Z / d t
   dZ(3) = dZ(3) + lZmn(0) * carg * ( -in(imn) ) ! d Z / d z
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  enddo ! end of Fourier summation loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  select case( IFLAG )
   
  case( 1 ) ! FVEC must contain function values; FJAC must not be changed;
   
   FVEC(1:2    ) = (/ dR(0), dZ(0) /) - RZ(1:2)
   
  case( 2 ) ! FJAC must contain derivatives    ; FVEC must not be changed;
   
   FJAC(1  ,1:2) = (/ dR(1), dR(2) /)
   FJAC(2  ,1:2) = (/ dZ(1), dZ(2) /)
 
  end select    
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine co02ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
