!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Evaluates volume integrals and their derivatives.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{notation} \begin{enumerate}

!latex \item Beginning from the representation for the vector potential, 
!latex \be A_{\t}(\s,\t,\z) &=& \sum_{j,p,l} A_{\t,j,p,i-1+l} \;\;  \varphi_{l,p}(s) \;\; \cos(m_j \t -n_j \z),\\
!latex     A_{\z}(\s,\t,\z) &=& \sum_{j,p,l} A_{\z,j,p,i-1+l} \;\;  \varphi_{l,p}(s) \;\; \cos(m_j \t -n_j \z),
!latex \ee
!latex we may derive the expressions for the energy and helicity integrals.
!latex \item The following shorthand notation is employed:
!latex \be b^\s & \equiv & \sqrt g B^\s = + \partial_\t A_\z  - \partial_\z A_\t
!latex = \sum_{j,p,l} ( - m_j \; A_{\z,j,p,i-1+l} - n_j \; A_{\t,j,p,i-1+l} ) \; \varphi_{l,p} (s) \; \sin\alpha_j,\\
!latex     b^\t & \equiv & \sqrt g B^\t = \;\;\;\;\;\;\;\;\;\;\;\;- \partial_\s A_\z
!latex = \sum_{j,p,l} ( -        A_{\z,j,p,i-1+l}                           ) \; \varphi_{l,p}'(s) \; \cos\alpha_j,\\
!latex     b^\z & \equiv & \sqrt g B^\z = + \partial_\s A_\t\;\;\;\;\;\;\;\;\;\;\;\;   
!latex = \sum_{j,p,l} ( +        A_{\t,j,p,i-1+l}                           ) \; \varphi_{l,p}'(s) \; \cos\alpha_j,
!latex \ee
!latex where $\alpha_j \equiv m_j \t -n_j \z$,

!latex \end{enumerate} \subsubsection{energy integral} \begin{enumerate}

!latex \item The energy integral is $F = \frac{1}{2} \int_{\cal V} B^2 dv = \sum_i F_{i}$, where
!latex \be
!latex F_i & = & \intdsl \ooint \left(
!latex \frac{1}{2} b^\s b^\s \bar g_{\s\s} +             b^\s b^\t \bar g_{\s\t} +             b^\s b^\z \bar g_{\s\z} 
!latex                                     + \frac{1}{2} b^\t b^\t \bar g_{\t\t} +             b^\t b^\z \bar g_{\t\z}
!latex                                                                           + \frac{1}{2} b^\z b^\z \bar g_{\s\s}
!latex \right),
!latex \ee
!latex where $\bar g_{\mu\nu}=g_{\mu\nu} / \sqrt g$.

!latex \end{enumerate} \subsubsection{first derivatives of energy integral with respect to vector potential} \begin{enumerate}

!latex \item The first derivative of $F_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ is
!latex \be \frac{\partial F_i}{\partial a} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex -n_j \varphi_{l,p}  s_j b^\s \bar g_{\s\s}
!latex -n_j \varphi_{l,p}  s_j b^\t \bar g_{\s\t}
!latex -n_j \varphi_{l,p}  s_j b^\z \bar g_{\s\z}
!latex +    \varphi_{l,p}' c_j b^\s \bar g_{\s\z}
!latex +    \varphi_{l,p}' c_j b^\t \bar g_{\t\z}
!latex +    \varphi_{l,p}' c_j b^\z \bar g_{\z\z}
!latex \right), \nonumber
!latex \ee
!latex where $s_j=\sin\alpha_j$ and $c_j=\cos\alpha_j$.
!latex \item The first derivative of $F_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ is
!latex \be \frac{\partial F_i}{\partial a} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex -m_j \varphi_{l,p}  s_j b^\s \bar g_{\s\s}
!latex -m_j \varphi_{l,p}  s_j b^\t \bar g_{\s\t}
!latex -    \varphi_{l,p}' c_j b^\s \bar g_{\s\t}
!latex -m_j \varphi_{l,p}  s_j b^\z \bar g_{\s\z}
!latex -    \varphi_{l,p}' c_j b^\t \bar g_{\t\z}
!latex -    \varphi_{l,p}' c_j b^\z \bar g_{\z\z}
!latex \right). \nonumber
!latex \ee

!latex \end{enumerate} \subsubsection{second derivatives of energy integral with respect to vector potential} \begin{enumerate}

!latex \item The second derivative of $F_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ and $b \equiv A_{\t,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 F_i}{\partial a \partial b} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex +n_j \varphi_{l,p}  s_j n_k \varphi_{r,q}  s_k \bar g_{\s\s}
!latex -n_j \varphi_{l,p}  s_j     \varphi_{r,q}' c_k \bar g_{\s\z}
!latex -    \varphi_{l,p}' c_j n_k \varphi_{r,q}  s_k \bar g_{\s\z}
!latex +    \varphi_{l,p}' c_j     \varphi_{r,q}' c_k \bar g_{\z\z}
!latex \right). \nonumber
!latex \ee

!latex \item The second derivative of $F_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ and $b \equiv A_{\z,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 F_i}{\partial a \partial b} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex +n_j \varphi_{l,p}  s_j m_k \varphi_{r,q}  s_k \bar g_{\s\s}
!latex +n_j \varphi_{l,p}  s_j     \varphi_{r,q}' c_k \bar g_{\s\t}
!latex -    \varphi_{l,p}' c_j m_k \varphi_{r,q}  s_k \bar g_{\s\z}
!latex -    \varphi_{l,p}' c_j     \varphi_{r,q}' c_k \bar g_{\t\z}
!latex \right). \nonumber
!latex \ee

!latex \item The second derivative of $F_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ and $b \equiv A_{\t,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 F_i}{\partial a \partial b} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex +m_j \varphi_{l,p}  s_j n_k \varphi_{r,q}  s_k \bar g_{\s\s}
!latex +    \varphi_{l,p}' c_j n_k \varphi_{r,q}  s_k \bar g_{\s\t}
!latex -m_j \varphi_{l,p}  s_j     \varphi_{r,q}' c_k \bar g_{\s\z}
!latex -    \varphi_{l,p}' c_j     \varphi_{r,q}' c_k \bar g_{\z\z}
!latex \right). \nonumber
!latex \ee

!latex \item The second derivative of $F_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ and $b \equiv A_{\z,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 F_i}{\partial a \partial b} \!\!\! & \!\!\! = \!\!\! & \!\!\! \intdsl \!\! \ooint \!\!\! \left(
!latex +m_j \varphi_{l,p}  s_j m_k \varphi_{r,q}  s_k \bar g_{\s\s}
!latex +m_j \varphi_{l,p}  s_j     \varphi_{r,q}' c_k \bar g_{\s\t}
!latex +    \varphi_{l,p}' c_j m_k \varphi_{r,q}  s_k \bar g_{\s\t}
!latex +    \varphi_{l,p}' c_j     \varphi_{r,q}' c_k \bar g_{\t\z}
!latex \right). \nonumber
!latex \ee

!latex \end{enumerate} \subsubsection{helicity integral} \begin{enumerate}

!latex \item The helicity integral is $G = \int_{\cal V} {\bf A}\cdot{\bf B} dv = \sum_i G_{i}$, where
!latex \be
!latex G_i & = & \intdsl \ooint \left( A_\t b^\t               + A_\z b^\z
!latex \right)
!latex \ee

!latex \end{enumerate} \subsubsection{first derivatives of helicity integral with respect to vector potential} \begin{enumerate}

!latex \item The first derivative of $G_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ is
!latex \be \frac{\partial G_i}{\partial a} & = & \intdsl \ooint \left(  \varphi_{l,p}  c_j b^\t + \varphi_{l,p}' c_j A_\z \right). \ee
!latex \item The first derivative of $G_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ is
!latex \be \frac{\partial G_i}{\partial a} & = & \intdsl \ooint \left( -\varphi_{l,p}' c_j A_\t + \varphi_{l,p}  c_j b^\z \right). \ee

!latex \end{enumerate} \subsubsection{second derivatives of helicity integral with respect to vector potential} \begin{enumerate}

!latex \item The seond derivative of $G_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ and $b \equiv A_{\t,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 G_i}{\partial a \partial b} & = & 0. \ee
!latex \item The seond derivative of $G_i$ with respect to $a \equiv A_{\t,j,p,i-1+l}$ and $b \equiv A_{\z,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 G_i}{\partial a \partial b} & = & -\varphi_{l,p}  c_j \varphi_{r,q}' c_k + \varphi_{l,p}' c_j \varphi_{r,q}  c_k. \ee
!latex \item The seond derivative of $G_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ and $b \equiv A_{\t,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 G_i}{\partial a \partial b} & = & -\varphi_{l,p}' c_j \varphi_{r,q}  c_k + \varphi_{l,p}  c_j \varphi_{r,q}' c_k. \ee
!latex \item The seond derivative of $G_i$ with respect to $a \equiv A_{\z,j,p,i-1+l}$ and $b \equiv A_{\z,k,q,i-1+r}$ is
!latex \be \frac{\partial^2 G_i}{\partial a \partial b} & = & 0. \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine df00aa( pNBdof , Xmuaa , Fmuaa , DFmuaa , Ldfmuaa , iflag )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one, two
  use numerical, only : small
  use fileunits, only : ounit
  use inputlist, only : Wdf00aa, Nvol, Ni, Nofe, helicity
  use cputiming
  use allglobal, only : myid, cpus, mn, in, im,                        &
                        doAt, doAz,                                    &
                        igss, igst, igsz, igtt, igtz, igzz, igoo, ijk, &
                        ivol, dpflux
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER, intent(in) :: pNBdof, Ldfmuaa
  INTEGER             :: iflag
  REAL   , intent(in) :: Xmuaa(0:pNBdof-1)                                                      ! degrees of freedom: helicity multiplier and vector potential; in packed format;
  REAL                :: Fmuaa(0:pNBdof-1), DFmuaa(0:Ldfmuaa-1,0:pNBdof-1)                      ! first and second derivatives of constrained energy functional;
  

  INTEGER             :: NBdof                                                                  ! degrees of freedom in vector potential;

  INTEGER             :: Ldo                                                                    ! for unpacking;
  CHARACTER           :: packorunpack

  LOGICAL             :: Lintegral, Lfirstderiv, Lsecondderiv
  
  INTEGER             :: ii, jj, kk, pp, qq, ll, rr                                             ! loop variables;

  INTEGER             :: jk, kj                                                                 ! index;
  
  INTEGER             :: mj  , mk  , nj  , nk                                                   ! shorthand; for energy integral and first derivatives;
  INTEGER             :: njnk, njmk, mjnk, mjmk                                                 ! shorthand; for second derivatives;
  
  REAL                :: Atjpl, Azjpl, Bsjpl, Btjpl, Bzjpl                                      ! shorthand;
  REAL                :: Atkqr, Azkqr, Bskqr, Btkqr, Bzkqr                                      ! shorthand;
  
  REAL                :: BB, AB, halfmu                                                         ! energy and helicity integral;
  
  REAL                :: dBBdAtjpl, dBBdAzjpl                                                   ! first  derivatives of energy   integral wrt vector potential;
  REAL                :: dABdAtjpl, dABdAzjpl                                                   ! first  derivatives of helicity integral wrt vector potential;
  
  REAL                :: ddBBdAtjpldAtkqr, ddBBdAtjpldAzkqr, ddBBdAzjpldAtkqr, ddBBdAzjpldAzkqr ! second derivatives of energy   integral wrt vector potential;
  REAL                :: ddABdAtjpldAtkqr, ddABdAtjpldAzkqr, ddABdAzjpldAtkqr, ddABdAzjpldAzkqr ! second derivatives of helicity integral wrt vector potential;

  INTEGER             :: ix, jx                                                                 ! labels independent degree of freedom in Beltrami field;

  LOGICAL             :: Lifmn, Ljfmn                                                           ! logical flags indicating if boundary flux-surface constraint is encountered;
  INTEGER             :: ifmn, jfmn                                                             ! to accomodate the effect of the surface potential at the outer boundary;

  REAL                :: dBBdx(1:pNBdof-1), dABdx(1:pNBdof-1)                                   ! first  derivatives of \int B.B dv and \int A.B dv;
  REAL                :: ddFddx(1:Ldfmuaa-1,1:pNBdof-1)                                         ! second derivatives of constrained energy functional;

  REAL                :: symerr                                                                 ! debugging;
  
  BEGIN(df00aa)
  
  FATALMESS(df00aa,ivol.lt.1 .or. ivol.gt.Nvol,ivol invalid)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case( iflag )
  case( -6 ) ; Lintegral = .true.  ; Lfirstderiv = .true.  ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return \int A.B dv and d \int A.B dv / da;
  case( -5 ) ; Lintegral = .false. ; Lfirstderiv = .true.  ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return                 d \int A.B dv / da;
  case( -4 ) ; Lintegral = .true.  ; Lfirstderiv = .false. ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return \int A.B dv                       ;
  case( -3 ) ; Lintegral = .true.  ; Lfirstderiv = .true.  ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return \int B.B dv and d \int B.B dv / da;
  case( -2 ) ; Lintegral = .false. ; Lfirstderiv = .true.  ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return                 d \int B.B dv / da;
  case( -1 ) ; Lintegral = .true.  ; Lfirstderiv = .false. ; Lsecondderiv = .false. ! ma02aa: LbeltramiSeQuad; return \int B.B dv                       ;
  case(  1 ) ; Lintegral = .true.  ; Lfirstderiv = .true.  ; Lsecondderiv = .false. ! ma02aa: LbeltramiNewton; return d  F / d  mu,a; F = \int B.B dv - mu ( \int A.B dv - K );
  case(  2 ) ; Lintegral = .false. ; Lfirstderiv = .true.  ; Lsecondderiv = .true.  ! ma02aa: LbeltramiNewton; return dd F / dd mu,a; F = \int B.B dv - mu ( \int A.B dv - K );
  case default
   FATALMESS(df00aa,.true.,invalid iflag)
  end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  NBdof = pNBdof - 1 ; halfmu = half * Xmuaa(0) ! helicity multiplier divided by two;   
  
  Ldo = 0 ; packorunpack = 'U'
  WCALL(df00aa,up00aa,( packorunpack , ivol , NBdof , Xmuaa(1:NBdof) , dpflux(ivol) , Ldo )) ! unpack solution;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Lintegral     ) then ;  BB                     = zero ;  AB            = zero ! initialize summation; energy & helicity integrals;
  endif
  if( Lfirstderiv   ) then ; dBBdx(1:NBdof)          = zero ; dABdx(1:NBdof) = zero ! initialize summation; first derivatives;
  endif
  if( Lsecondderiv  ) then ; ddFddx(1:NBdof,1:NBdof) = zero                         ! initialize summation; second derivatives;
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ii = 1 , Ni(ivol) ! loop over sub-grid;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   do jj = 1 , mn ! loop over Fourier modes;
    do pp = 0 , Nofe ! loop over derivatives;
     do ll = 0 , 1     ! loop over ``left-right-basis-elements''
      
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
      
      Lifmn = .false.
      if( jj.gt.1 .and. pp.eq.0 .and. ii-1+ll.eq.Ni(ivol) ) Lifmn = .true. ! used below to identify outer boundary constraint; required only for derivatives;
      
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
      
      mj = im(jj) ; nj = in(jj)
      
      Atjpl = doAt(0,ivol,jj,pp)%s(ii-1+ll)
      Azjpl = doAz(0,ivol,jj,pp)%s(ii-1+ll)
      
      Bsjpl = - mj * Azjpl - nj * Atjpl 
      Btjpl = -      Azjpl
      Bzjpl = +      Atjpl
      
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
      
      do kk = 1 , mn ! loop over Fourier modes;
       do qq = 0 , Nofe ! loop over derivatives;
        do rr = 0 , 1     ! loop over ``left-right-basis-elements''
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         jk = ijk(jj,kk) ; kj = ijk(kk,jj) 
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         Ljfmn = .false.
         if( kk.gt.1 .and. qq.eq.0 .and. ii-1+rr.eq.Ni(ivol) ) Ljfmn = .true. ! used below to identify outer boundary constraint; required only for derivatives;
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         mk = im(kk) ; nk = in(kk)
         
         Atkqr = doAt(0,ivol,kk,qq)%s(ii-1+rr)
         Azkqr = doAz(0,ivol,kk,qq)%s(ii-1+rr)
         
         Bskqr = - mk * Azkqr - nk * Atkqr  
         Btkqr = -      Azkqr
         Bzkqr = +      Atkqr
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         if( Lintegral ) then
          
          BB = BB &
        + half * Bsjpl * Bskqr * igss(ll,pp,rr,qq,jk)%s(ii) &
        +        Bsjpl * Btkqr * igst(ll,pp,rr,qq,jk)%s(ii) &
        +        Bsjpl * Bzkqr * igsz(ll,pp,rr,qq,jk)%s(ii) &
        + half * Btjpl * Btkqr * igtt(ll,pp,rr,qq,jk)%s(ii) &
        +        Btjpl * Bzkqr * igtz(ll,pp,rr,qq,jk)%s(ii) &
        + half * Bzjpl * Bzkqr * igzz(ll,pp,rr,qq,jk)%s(ii)
          
          
          AB = AB &
        +        Atjpl * Btkqr * igoo(ll,pp,rr,qq,jk)%s(ii) &
        +        Azjpl * Bzkqr * igoo(ll,pp,rr,qq,jk)%s(ii)
          
         endif ! end of if( Lintegral ) then;
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         if( Lfirstderiv ) then
          
          dBBdAtjpl = &
        - nj * Bskqr * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        - nj * Btkqr * igst(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\t};
        - nj * Bzkqr * igsz(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\z};
        +      Bskqr * igsz(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\t\t};
        +      Btkqr * igtz(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\t\z};
        +      Bzkqr * igzz(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}' c_j \bar g_{\z\z};
          
          dBBdAzjpl = &
        - mj * Bskqr * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        - mj * Btkqr * igst(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\t};
        -      Bskqr * igst(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\s\z};
        - mj * Bzkqr * igsz(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  c_j \bar g_{\t\t};
        -      Btkqr * igtt(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\t\z}; ??
        -      Bzkqr * igtz(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}' c_j \bar g_{\z\z};
          
          
          dABdAtjpl = &
        +      Btkqr * igoo(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  c_j              ;
        +      Azkqr * igoo(rr,qq,ll,pp,kj)%s(ii)   ! varphi_{l,p}' c_j              ;
          
          dABdAzjpl = &
        -      Atkqr * igoo(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j              ;
        +      Bzkqr * igoo(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}  c_j              ;
          
          
          ix = doAt(0,ivol,jj,pp)%i(ii-1+ll) ! this labels the degree of freedom;
          
          if( ix.gt.0 ) then 
           ifmn = 1
           if( Lifmn ) ifmn =  mj ! on outer boundary, Atmn =  m fmn, where fmn is the surface potential;
           dBBdx(ix) = dBBdx(ix) + ( dBBdAtjpl                      ) * ifmn
           dABdx(ix) = dABdx(ix) + (                      dABdAtjpl ) * ifmn
          endif
          
          ix = doAz(0,ivol,jj,pp)%i(ii-1+ll) ! this labels the degree of freedom;
          
          if( ix.gt.0 ) then 
           ifmn = 1
           if( Lifmn ) ifmn = -nj ! on outer boundary, Azmn = -n fmn, where fmn is the surface potential;
           dBBdx(ix) = dBBdx(ix) + ( dBBdAzjpl                      ) * ifmn
           dABdx(ix) = dABdx(ix) + (                      dABdAzjpl ) * ifmn
          endif
          
          
         endif ! end of if( Lfirstderiv ) then;
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
         if( Lsecondderiv ) then
          
          ddBBdAtjpldAtkqr = &
        + nj * nk * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        - nj      * igsz(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\z};
        -      nk * igsz(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\t\t};
        +           igzz(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}' c_j \bar g_{\z\z};
          
          ddBBdAtjpldAzkqr = &
        + nj * mk * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        + nj      * igst(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\t};
        -      mk * igsz(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\t\t};
        -           igtz(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}  s_j \bar g_{\t\z};
          
          ddBBdAzjpldAtkqr = &
        + mj * nk * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        +      nk * igst(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\s\z};
        - mj      * igsz(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  c_j \bar g_{\t\t};
        -           igtz(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}' c_j \bar g_{\z\z};
          
          ddBBdAzjpldAzkqr = &
        + mj * mk * igss(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\s};
        + mj      * igst(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  s_j \bar g_{\s\t};
        +      mk * igst(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j \bar g_{\s\z};
        +           igtt(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}' c_j \bar g_{\t\z};
          
         !ddABdAtjpldAtkqr = zero
          
          ddABdAtjpldAzkqr = &
        -           igoo(ll,pp,rr,qq,jk)%s(ii) & ! varphi_{l,p}  c_j              ;
        +           igoo(rr,qq,ll,pp,kj)%s(ii)   ! varphi_{l,p}' c_j              ;
          
          ddABdAzjpldAtkqr = &
        -           igoo(rr,qq,ll,pp,kj)%s(ii) & ! varphi_{l,p}' c_j              ;
        +           igoo(ll,pp,rr,qq,jk)%s(ii)   ! varphi_{l,p}  c_j              ;
          
         !ddABdAzjpldAzkqr = zero
          
          
          ix = doAt(0,ivol,jj,pp)%i(ii-1+ll) ; jx = doAt(0,ivol,kk,qq)%i(ii-1+rr) ! this labels the degree of freedom;
          
          if( ix.gt.0 .and. jx.gt.0 ) then
           ifmn = 1 ; jfmn = 1
           if( Lifmn ) ifmn =  mj ! on outer boundary, Atmn =  m fmn, where fmn is the surface potential;
           if( Ljfmn ) jfmn =  mk ! on outer boundary, Atmn =  m fmn, where fmn is the surface potential;
           ddFddx(ix,jx) = ddFddx(ix,jx) + ( ddBBdAtjpldAtkqr                             ) * ifmn * jfmn
          endif
          
          ix = doAt(0,ivol,jj,pp)%i(ii-1+ll) ; jx = doAz(0,ivol,kk,qq)%i(ii-1+rr) ! this labels the degree of freedom;
          
          if( ix.gt.0 .and. jx.gt.0 ) then 
           ifmn = 1 ; jfmn = 1
           if( Lifmn ) ifmn =  mj ! on outer boundary, Atmn =  m fmn, where fmn is the surface potential;
           if( Ljfmn ) jfmn = -nk ! on outer boundary, Azmn = -n fmn, where fmn is the surface potential;
           ddFddx(ix,jx) = ddFddx(ix,jx) + ( ddBBdAtjpldAzkqr - halfmu * ddABdAtjpldAzkqr ) * ifmn * jfmn
          endif
          
          ix = doAz(0,ivol,jj,pp)%i(ii-1+ll) ; jx = doAt(0,ivol,kk,qq)%i(ii-1+rr) ! this labels the degree of freedom;
          
          if( ix.gt.0 .and. jx.gt.0 ) then 
           ifmn = 1 ; jfmn = 1
           if( Lifmn ) ifmn = -nj ! on outer boundary, Azmn = -n fmn, where fmn is the surface potential;
           if( Ljfmn ) jfmn =  mk ! on outer boundary, Atmn =  m fmn, where fmn is the surface potential;
           ddFddx(ix,jx) = ddFddx(ix,jx) + ( ddBBdAzjpldAtkqr - halfmu * ddABdAzjpldAtkqr ) * ifmn * jfmn
          endif
          
          ix = doAz(0,ivol,jj,pp)%i(ii-1+ll) ; jx = doAz(0,ivol,kk,qq)%i(ii-1+rr) ! this labels the degree of freedom;
          
          if( ix.gt.0 .and. jx.gt.0 ) then 
           ifmn = 1 ; jfmn = 1
           if( Lifmn ) ifmn = -nj ! on outer boundary, Azmn = -n fmn, where fmn is the surface potential;
           if( Ljfmn ) jfmn = -nk ! on outer boundary, Azmn = -n fmn, where fmn is the surface potential;
           ddFddx(ix,jx) = ddFddx(ix,jx) + ( ddBBdAzjpldAzkqr                             ) * ifmn * jfmn
          endif
          
          
         endif ! end of if( Lsecondderiv ) then;
         
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
         
        enddo ! end of do rr;
       enddo ! end of do qq;
      enddo ! end of do kk;
      
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
      
     enddo ! end of do ll;
    enddo ! end of do pp;
   enddo ! end of do jj;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do ii = 1 , Ni(ivol);
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! now collect the above integrals and derivatives to return the required information; this routine is primarily called by ma02aa;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case( iflag )
   
  case( -6 ) ; Fmuaa( 0 ) = AB   ; Fmuaa( 1:NBdof ) = dABdx(1:NBdof) ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return \int A.B dv and d \int A.B dv / da;
  case( -5 ) ; Fmuaa( 0 ) = zero ; Fmuaa( 1:NBdof ) = dABdx(1:NBdof) ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return                 d \int A.B dv / da;
  case( -4 ) ; Fmuaa( 0 ) = AB   ; Fmuaa( 1:NBdof ) = zero           ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return \int A.B dv                       ;
  case( -3 ) ; Fmuaa( 0 ) = BB   ; Fmuaa( 1:NBdof ) = dBBdx(1:NBdof) ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return \int B.B dv and d \int B.B dv / da;
  case( -2 ) ; Fmuaa( 0 ) = zero ; Fmuaa( 1:NBdof ) = dBBdx(1:NBdof) ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return                 d \int B.B dv / da;
  case( -1 ) ; Fmuaa( 0 ) = BB   ; Fmuaa( 1:NBdof ) = zero           ; DFmuaa(0:NBdof,0:NBdof) = zero ! ma02aa: LbeltramiSeQuad; return \int B.B dv                       ;
   
  case(  1 ) ! ma02aa: LbeltramiNewton; return first  derivatives, wrt \mu and {\bf A}, of constrained energy functional, F = \int B.B dv - \mu ( \int A.B dv - K );
   
   Fmuaa( 0       ) =                - half   * (  AB            - helicity(ivol) ) ! NEED TO INCLUDE CORRECTIONS FOR GAUGE INVARIANCE HERE; see fu00aa;
   Fmuaa( 1:NBdof ) = dBBdx(1:NBdof) - halfmu *   dABdx(1:NBdof)
   
   if( Wdf00aa ) then
    cput = MPI_WTIME() ; write(ounit,'("df00aa : "f10.2" : ivol="i3" ; |dF|="2es23.15" ;")')cput-cpus,ivol,sqrt(sum(Fmuaa(0:NBdof)**2)/pNBdof)
   endif
   
  case(  2 ) ! ma02aa: LbeltramiNewton; return second derivatives, wrt \mu and {\bf A}, of constrained energy functional, F = \int B.B dv - \mu ( \int A.B dv - K );
   
   DFmuaa( 0       , 0       ) =   zero
   DFmuaa( 0       , 1:NBdof ) = - half * dABdx(1:NBdof)
   DFmuaa( 1:NBdof , 0       ) = - half * dABdx(1:NBdof)
   DFmuaa( 1:NBdof , 1:NBdof ) = ddFddx(1:NBdof,1:NBdof)
   
  case default
   FATALMESS(df00aa,.true.,invalid iflag)
   
  end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(df00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine df00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


module quadratic_forms ! Cached hessians to speed up computation of Newton and SQP.
  REAL, allocatable :: energy_matrix(:,:)  , energy_rhs(:)
  REAL              :: energy_offset
  REAL, allocatable :: helicity_matrix(:,:), helicity_rhs(:)
  REAL              :: helicity_offset
  
  INTEGER           :: current_quadratic_form_lvol
end module

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! This subroutine allocates and initialises the quadratic forms, which will be used by dfcalc
subroutine dfalloc( pNBdof , Xmuaa , Fmuaa , DFmuaa , Ldfmuaa )
  
  use constants, only : zero, one, two
  use allglobal, only : myid, cpus, ivol
  use quadratic_forms
  use fileunits, only : ounit
  use inputlist, only : Wdf00aa, Nvol, Ni, Nofe, helicity
  use cputiming
  
  LOCALS
  
  INTEGER, intent(in) :: pNBdof
  INTEGER             :: Ldfmuaa, iflag
  REAL                :: Xmuaa(0:pNBdof-1)                                                      ! degrees of freedom: helicity multiplier and vector potential; in packed format;
  REAL                :: Fmuaa(0:pNBdof-1), DFmuaa(0:Ldfmuaa-1,0:pNBdof-1)                      ! first and second derivatives of constrained energy functional;
  
  
  INTEGER             :: NBdof                                                                  ! degrees of freedom in vector potential;
  
  BEGIN(df00aa)
  
  FATALMESS(df00aa,ivol.lt.1 .or. ivol.gt.Nvol,ivol invalid)
  
  current_quadratic_form_lvol = ivol ! Save which volume we are calculating the quadratic forms for
  
  NBdof = pNBdof - 1 ;
  
  RALLOCATE(energy_matrix,  (1:NBdof,1:NBdof))
  RALLOCATE(energy_rhs,     (1:NBdof))
  
  RALLOCATE(helicity_matrix,(1:NBdof,1:NBdof))
  RALLOCATE(helicity_rhs,   (1:NBdof))
  
  ! The Lagrangian is F = \int B.B dv - mu ( \int A.B dv - K );
  ! Both the \int B.B dv and \int A.B dv terms can be written in the form
  !     f(x) = 1/2 x^T G x + x^T b + c
  ! for some matrix G, vector b and constant c.  We want to extract the matrix into the _matrix variable, the vector into the _rhs vector, and the constant into _offset
  
  ! The energy terms can be simply extracted by setting \mu = 0, A = 0 (i.e. Xmuaa = 0) and calculating the F, its hessian and gradient.
  Xmuaa(0:NBdof) = zero
  
  ! Calculate the value of F
  WCALL(df00aa,df00aa,( pNBdof, Xmuaa , Fmuaa , DFmuaa , Ldfmuaa ,-1 ))
  energy_offset = Fmuaa(0)
  
  ! Calculate the gradient of F
  WCALL(df00aa,df00aa,( pNBdof, Xmuaa , Fmuaa , DFmuaa , Ldfmuaa , 1 ))
  energy_rhs    = Fmuaa(1:NBdof)

  ! Calculate the hessian of F
  WCALL(df00aa,df00aa,( pNBdof, Xmuaa , Fmuaa , DFmuaa , Ldfmuaa , 2 ))
  energy_matrix = DFmuaa(1:NBdof, 1:NBdof)
  
  ! The helicity terms need to be extracted by choosing a value for \mu, and subtracting the energy terms from the hessian and gradient of F.
  Xmuaa(0)  = -two ! Set \mu = -2, this is because the Newton method uses - 1/2 \mu ( \int A.B dv - K)

  ! Calculate the value of F, and its gradient
  WCALL(df00aa,df00aa,( pNBdof, Xmuaa , Fmuaa , DFmuaa , Ldfmuaa ,-6 ))
  helicity_offset = Fmuaa(0)
  helicity_rhs    = Fmuaa(1:NBdof)
  
  ! Calculate the hessian of F
  WCALL(df00aa,df00aa,( pNBdof, Xmuaa , Fmuaa , DFmuaa , Ldfmuaa , 2 ))
  helicity_matrix = DFmuaa(1:NBdof, 1:NBdof) - energy_matrix
  
  
  RETURN(df00aa)

end subroutine dfalloc


subroutine dfstop ()

  use quadratic_forms
  use fileunits, only : ounit
  use inputlist, only : Wdf00aa, Nvol, Ni, Nofe, helicity
  use cputiming
  use allglobal, only : myid, cpus

  LOCALS
  
  DEALLOCATE(energy_matrix)
  DEALLOCATE(energy_rhs)
  
  DEALLOCATE(helicity_matrix)
  DEALLOCATE(helicity_rhs)
  

end subroutine dfstop


subroutine dfcalc( pNBdof , Xmuaa , Fmuaa , DFmuaa , Ldfmuaa , iflag )

  use quadratic_forms
  use constants, only : zero, half, one, two
  use fileunits, only : ounit
  use inputlist, only : Wdf00aa, Nvol, Ni, Nofe, helicity
  use cputiming
  use allglobal, only : ivol, myid, cpus
  
  LOCALS
  
  INTEGER, intent(in) :: pNBdof, Ldfmuaa
  INTEGER             :: iflag
  REAL   , intent(in) :: Xmuaa(0:pNBdof-1)                                                      ! degrees of freedom: helicity multiplier and vector potential; in packed format;
  REAL                :: Fmuaa(0:pNBdof-1), DFmuaa(0:Ldfmuaa-1,0:pNBdof-1)                      ! first and second derivatives of constrained energy functional;
  
  INTEGER             :: NBdof                                                                  ! degrees of freedom in vector potential;
  REAL                :: energy_matrix_times_x(1:pNBdof-1)
  REAL                :: helicity_matrix_times_x(1:pNBdof-1)
  REAL                :: BB, AB, halfmu                                                             ! energy and helicity integral;
  
  LOGICAL             :: LIntegral, LGradient, LHessian
  
  
  BEGIN(df00aa)
  
  FATALMESS(dfcalc,ivol.lt.1 .or. ivol.gt.Nvol,ivol invalid)
  FATALMESS(dfcalc,ivol.ne.current_quadratic_form_lvol, quadratic forms calculated for a different volume)
  
  NBdof = pNBdof - 1
  
  select case( iflag )
  case( -6 ) ; LIntegral = .true.  ; LGradient = .true.  ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return \int A.B dv and d \int A.B dv / da;
  case( -5 ) ; LIntegral = .false. ; LGradient = .true.  ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return                 d \int A.B dv / da;
  case( -4 ) ; LIntegral = .true.  ; LGradient = .false. ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return \int A.B dv                       ;
  case( -3 ) ; LIntegral = .true.  ; LGradient = .true.  ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return \int B.B dv and d \int B.B dv / da;
  case( -2 ) ; LIntegral = .false. ; LGradient = .true.  ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return                 d \int B.B dv / da;
  case( -1 ) ; LIntegral = .true.  ; LGradient = .false. ; LHessian = .false. ! ma02aa: LbeltramiSeQuad; return \int B.B dv                       ;
  case(  1 ) ; LIntegral = .true.  ; LGradient = .true.  ; LHessian = .false. ! ma02aa: LbeltramiNewton; return d  F / d  mu,a; F = \int B.B dv - mu ( \int A.B dv - K );
  case(  2 ) ; LIntegral = .false. ; LGradient = .true. ; LHessian = .true.  ! ma02aa: LbeltramiNewton; return dd F / dd mu,a; F = \int B.B dv - mu ( \int A.B dv - K );
  case default
   FATALMESS(dfcalc,.true.,invalid iflag)
  end select
  
  halfmu = half * Xmuaa(0)
  
  if ( LIntegral .or. LGradient ) then ! To calculate the integral quantities, we need G . x
    energy_matrix_times_x   = matmul(energy_matrix,   Xmuaa(1:NBdof))
    helicity_matrix_times_x = matmul(helicity_matrix, Xmuaa(1:NBdof))
  endif
  
  if ( LIntegral ) then
    ! Both the \int B.B dv and \int A.B dv terms can be written in the form
    !     f(x) = 1/2 x^T G x + x^T b
    ! for some matrix G and vector b.
    BB = half * dot_product(Xmuaa(1:NBdof), energy_matrix_times_x  ) + dot_product(Xmuaa(1:NBdof), energy_rhs) + energy_offset
    AB = half * dot_product(Xmuaa(1:NBdof), helicity_matrix_times_x) + dot_product(Xmuaa(1:NBdof), helicity_rhs) + helicity_offset
  endif
  
  if ( LGradient ) then
    ! If f(x) is as above, then
    ! \nabla f(x) = G x + b
    ! if G is symmetric (which it is in this case due to how it is calculated as a Hessian)
    energy_matrix_times_x   = energy_matrix_times_x   + energy_rhs
    helicity_matrix_times_x = helicity_matrix_times_x + helicity_rhs
  endif
  
  !-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ! now collect the above integrals and derivatives to return the required information; 
  
  !-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case( iflag )
   
  case( -6 ) ; Fmuaa( 0 ) = AB   ; Fmuaa( 1:NBdof ) = helicity_matrix_times_x ; ! ma02aa: LbeltramiSeQuad; return \int A.B dv and d \int A.B dv / da;
  case( -5 ) ; Fmuaa( 0 ) = zero ; Fmuaa( 1:NBdof ) = helicity_matrix_times_x ; ! ma02aa: LbeltramiSeQuad; return                 d \int A.B dv / da;
  case( -4 ) ; Fmuaa( 0 ) = AB   ; Fmuaa( 1:NBdof ) = zero                    ; ! ma02aa: LbeltramiSeQuad; return \int A.B dv                       ;
  case( -3 ) ; Fmuaa( 0 ) = BB   ; Fmuaa( 1:NBdof ) = energy_matrix_times_x   ; ! ma02aa: LbeltramiSeQuad; return \int B.B dv and d \int B.B dv / da;
  case( -2 ) ; Fmuaa( 0 ) = zero ; Fmuaa( 1:NBdof ) = energy_matrix_times_x   ; ! ma02aa: LbeltramiSeQuad; return                 d \int B.B dv / da;
  case( -1 ) ; Fmuaa( 0 ) = BB   ; Fmuaa( 1:NBdof ) = zero                    ; ! ma02aa: LbeltramiSeQuad; return \int B.B dv                       ;
   
  case(  1 ) ! ma02aa: LbeltramiNewton; return first  derivatives, wrt \mu and {\bf A}, of constrained energy functional, F = \int B.B dv - 1/2 \mu ( \int A.B dv - K );
   
   Fmuaa( 0       ) =                - half * (  AB            - helicity(ivol) )
   Fmuaa( 1:NBdof ) = energy_matrix_times_x - halfmu *   helicity_matrix_times_x
   
   if( Wdf00aa ) then
    cput = MPI_WTIME() ; write(ounit,'("df00aa : "f10.2" : ivol="i3" ; |dF|="2es23.15" ;")')cput-cpus,ivol,sqrt(sum(Fmuaa(0:NBdof)**2)/pNBdof)
   endif
   
  case(  2 ) ! ma02aa: LbeltramiNewton; return second derivatives, wrt \mu and {\bf A}, of constrained energy functional, F = \int B.B dv - \mu ( \int A.B dv - K );
   
   DFmuaa( 0       , 0       ) =   zero
   DFmuaa( 0       , 1:NBdof ) = - half * helicity_matrix_times_x
   DFmuaa( 1:NBdof , 0       ) = - half * helicity_matrix_times_x
   DFmuaa( 1:NBdof , 1:NBdof ) = energy_matrix - halfmu * helicity_matrix
   
  case default
   FATALMESS(df00aa,.true.,invalid iflag)
   
  end select
  
  
  RETURN(df00aa)

end subroutine dfcalc