!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs tangential field on each boundary.

!latex \end{enumerate} \subsubsection{tangential field on interfaces boundary} \begin{enumerate}

!latex \item The tangential field on each boundary is constructed in a format suitable for use in the virtual casing . . 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine fb00aa
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, ten, pi2, goldmean

  use numerical, only : vsmall, small

  use fileunits, only : ounit, punit

  use inputlist, only : Wfb00aa, ext, Lgeometry, Nvol, Nfp, Ni, phiedge, Lvacuum

  use cputiming, only : Tfb00aa

  use allglobal, only : myid, ncpu, cpus, pi2nfp, interfacelabel,          &
                        efmn, ofmn, cfmn, sfmn, isr, trigm, trign, trigwk, &
                        Rij, Zij, sg, gij, mn, im, in, ijreal, jireal,     &
                        doAtmn, doAzmn, doAt, doAz,                        &
                        Nt, Nz, Ntz, Bsupumn, Bsupvmn,                     &
                        Lcoordinatesingularity, Louterboundarynormal,      &
                        iexvol
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER              :: lvol, innout, Lcurv, ifail, llmodnp, Ldo, imn
  REAL                 :: lss

  BEGIN(fb00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do lvol = 1, Nvol
   
   if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! only this node knows about the Beltrami field in each volume;

   if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
   else                                                         ; Lcoordinatesingularity = .true.
   endif

   if( Lvacuum.ne.0 .and. lvol.eq.Nvol                   ) then ; Louterboundarynormal   = .true.
   else                                                         ; Louterboundarynormal   = .false.
   endif
   
   do innout = 0, 1 ! loop over inner and outer adjacent interfaces;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    if( Lcoordinatesingularity .and. innout.eq.0 ) cycle ! avoid coordinate singularity;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    lss = interfacelabel(lvol-1+innout) ; Lcurv = 1 ! extract geometry and metric elements of selected interface; probably ok to set Lcurv = 0;
    
    WCALL(fb00aa,co01aa,( lvol, lss, Lcurv, Ntz )) ! will need Rij(0:3,:) & Zij(0:3), sg(0,:) and gij(1:6,0,:);
    
    Ldo = 0
    WCALL(fb00aa,sa00aa,( lvol, lss, Ldo )) ! returns radially interpolated Fourier harmonics of vector potential through global doAtmn(0,1,1:mn) & doAzmn(0,1,1:mn);
    
    efmn(1:mn) = - doAzmn(0,1,1:mn) ! doAzmn(1,1:mn) = \partial_s A_z; efmn(1:mn) = -doAz(0,lvol,1:mn,1)%s(Nvol(lvol)) ;
    cfmn(1:mn) =   doAtmn(0,1,1:mn) ! doAtmn(1,1:mn) = \partial_s A_z; cfmn(1:mn) =  doAt(0,lvol,1:mn,1)%s(Nvol(lvol)) ;
    
    ofmn(1:mn) = zero
    sfmn(1:mn) = zero
    
    call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, gij(2,1,:), gij(3,1,:), isr, trigm, trign, trigwk )
    
    gij(2,1,:) = gij(2,1,:) / sg(0,:) ! B^t;
    gij(3,1,:) = gij(3,1,:) / sg(0,:) ! B^z;
    
    ijreal(1:Ntz) = gij(2,1,:) ! it seems that tfft corrupts; save tangential field for EZspline; this information must be broadcast;
    jireal(1:Ntz) = gij(3,1,:) ! it seems that tfft corrupts; save tangential field for EZspline;
    
    ifail=0
    call tfft( Nt,Nz, gij(2,1,1:Ntz), gij(3,1,1:Ntz), isr,trigm,trign,trigwk, mn, im, in, Bsupumn(lvol,innout,1:mn), ofmn(1:mn), Bsupvmn(lvol,innout,1:mn), sfmn(1:mn), ifail )
    
    Bsupumn(lvol,innout,1:mn) = Bsupumn(lvol,innout,1:mn) * phiedge ! this information is required for vc00aa;
    Bsupvmn(lvol,innout,1:mn) = Bsupvmn(lvol,innout,1:mn) * phiedge ! and is broadcast below;
    
!   Lvmectangentialfield = .false. ! 10 Oct 12; do not delete; this gives example of how to use VMEC tangential for code comparison / debugging;
!   
!   inquire(file=".BuBvmn."//trim(ext),exist=exist)
!   
!   if( exist ) then ! the Fourier harmonics of the VMEC magnetic field on the plasma boundary have been extracted (prior to execution of SPEC) for comparison/debugging;
!    
!    Lvmectangentialfield = .true.
!    
!    open(punit+myid,file=".BuBvmn."//trim(ext),status="old")
!    imn = 0
!    do ! will read file until error (end of file) is encountered;
!     read(punit+myid,*,iostat=ios)mm,nn,lBsupumn,lBsupvmn
!     if( ios.ne.0 ) exit
!     imn = imn + 1
!     FATALMESS(fb00aa,mm.ne.im(imn).or.nn.ne.in(imn),inconsistent Fourier resolution) ! could easily implement mode identication, but this is just debugging;
!     Bsupumn(lvol,imn) = lBsupumn ! VMEC poloidal harmonics;
!     Bsupvmn(lvol,imn) = lBsupvmn ! VMEC toroidal harmonics;
!    enddo
!    close(punit+myid)
!    
!   endif ! end of if( tangential.field exists ) ; ! 10 Oct 12; do not delete;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
   enddo ! end of do innout = 0, 1
   
  enddo ! end of do lvol = 1, Nvol
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do lvol = 1, Nvol
   
   llmodnp = modulo(lvol-1,ncpu)
   
   RlBCAST(Bsupumn(lvol,0:1,1:mn),2*mn,llmodnp) ! broadcast the tangential field;
   RlBCAST(Bsupvmn(lvol,0:1,1:mn),2*mn,llmodnp) ! broadcast the tangential field;
   
  enddo
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 ) then
   
   open(punit+myid,file="."//trim(ext)//".bubvmn",status="unknown") ! 10 Oct 12;
   write(punit+myid,'(i9)')mn                                       ! 10 Oct 12;
   write(punit+myid,'(999es23.15)')Bsupumn(Nvol,1-iexvol,1:mn)      ! 10 Oct 12; these can be compared to VMEC harmonics;
   write(punit+myid,'(999es23.15)')Bsupvmn(Nvol,1-iexvol,1:mn)      ! 10 Oct 12;
   close(punit+myid)
   
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(fb00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine fb00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
