!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Writes ext.h5 file.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!subroutine h5fcreate_f(name, access_flags, file_id, hdferr)              ! creates an HDF5 file.;
!  CHARACTER(LEN=*), INTENT(IN)  :: name                                  ! name of the file;
!  INTEGER         , INTENT(IN)  :: access_flag                           ! file access flags: H5F_ACC_RDWR_F, H5F_ACC_RDONLY_F, H5F_ACC_TRUNC_F, H5F_ACC_EXCL_F, H5F_ACC_DEBUG_F;
!  INTEGER(HID_T)  , INTENT(OUT) :: file_id                               ! file identifier;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!subroutine h5screate_simple_f(rank, dims, space_id, hdferr)              ! creates a new simple dataspace and opens it for access;
!  INTEGER         , INTENT(IN)  :: rank                                  ! number of dataspace dimensions;
!  INTEGER(HSIZE_T), INTENT(IN)  :: dims(*)                               ! array with current dimension sizes;
!  INTEGER(HID_T)  , INTENT(OUT) :: space_id                              ! dataspace identifier;

!subroutine h5dcreate_f(loc_id, name, type_id, space_id, dset_id, hdferr) ! creates a new dataset and links it to a location in the file;
!  INTEGER(HID_T)  , INTENT(IN)  :: loc_id                                ! file or group identifier 
!  CHARACTER(LEN=*), INTENT(IN)  :: name                                  ! name of the dataset 
!  INTEGER(HID_T)  , INTENT(IN)  :: type_id                               ! datatype identifier 
!  INTEGER(HID_T)  , INTENT(IN)  :: space_id                              ! dataspace identifier 
!  INTEGER(HID_T)  , INTENT(OUT) :: dset_id                               ! dataset identifier 

!subroutine h5dwrite_f(dset_id, mem_type_id, buf, dims, hdferr )          ! writes raw data from a buffer to a dataset;
!  INTEGER(HID_T)  , INTENT(IN)  :: dset_id                               ! dataset identifier
!  INTEGER(HID_T)  , INTENT(IN)  :: mem_type_id                           ! memory datatype identifier
!  TYPE            , INTENT(IN)  :: buf                                   ! data buffer; may be a scalar or an array
!  INTEGER(HSIZE_T), INTENT(IN)  :: dims(*)                               ! array to hold corresponding dimension sizes of data buffer buf;
!                                                                           dim(k) has value of the k-th dimension of buffer buf; values are ignored if buf is a scalar

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine hdfint( mn , Nvol )
  
  use constants, only : goldmean
  use numerical, only : 
  use fileunits, only : ounit
  use inputlist, only : Whdfint, version, compilationdate, ext, tflux, pressure, iota, forceerr
  use cputiming, only : Thdfint
  use allglobal, only : myid, ncpu, cpus, interfacelabel, &
                        im, in, iRbc, iZbs,               & ! 10 Oct 12; 
                        Bsupumn, Bsupvmn,                 & ! 10 Oct 12; 
                        iexvol,                           & ! 10 Oct 12; 
                        lvolume,                          & ! 21 Oct 12;
                        looperr                             ! 21 Oct 12;
  
  use HDF5
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in)            :: mn, Nvol
  
! the following are used by the macros HWRITE below; do not alter/remove;
  INTEGER                        :: hdfier, rank
  integer(HID_T)                 :: file_id, space_id, dset_id ! warning: the string "INTEGER" is a macro; to avoid macro conversion use lower case;
  integer(HSIZE_T)               :: onedims(1), twodims(2)     ! warning: the string "INTEGER" is a macro; to avoid macro conversion use lower case;

  INTEGER                        :: imn
  
  BEGIN(hdfint)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  call h5open_f( hdfier ) ! initialize Fortran interface;

  FATALMESS(hdfint,hdfier.ne.0,error calling h5open_f)


  call h5fcreate_f( trim(ext)//".h5" , H5F_ACC_TRUNC_F , file_id , hdfier ) ! create new file;

  FATALMESS(hdfint,hdfier.ne.0,error calling h5fcreate_f)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The following quantities are written to \verb+ext.h5+ :

!latex \begin{itemize}

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+version+; real; identifies executable \verb+xspec+;

  HWRITEIV(1,"version",version)                          

!latex \item \verb+mn+; integer;

  HWRITEIV(1,"mn",mn)                                    

!latex \item \verb+im(1:mn)+; integer; poloidal mode numbers;

  HWRITEIV(mn,"im",im(1:mn))                             

!latex \item \verb+in(1:mn)+; integer; toroidal mode numbers;

  HWRITEIV(mn,"in",in(1:mn))                             

!latex \item \verb+Nvol+; integer; number of interfaces = number of volumes;

  HWRITEIV(1,"Nvol",Nvol)                                

!latex \item \verb+iRbc(1:Nvol,1:mn)+; real; Fourier harmonics, $R_{m,n}$, of interfaces;

  HWRITERA(Nvol,mn,"Rbc",iRbc(1:Nvol,1:mn))             

!latex \item \verb+iZbs(1:Nvol,1:mn)+; real; Fourier harmonics, $Z_{m,n}$, of interfaces;

  HWRITERA(Nvol,mn,"Zbs",iZbs(1:Nvol,1:mn))             

!latex \item \verb+volume+; real; volume;

  HWRITERV(1,"volume",sum(lvolume(1:Nvol-iexvol)))

!latex \item \verb+interfacelabel(1:Nvol)+; real; interface coordinate label;

  HWRITERV(Nvol,"interfacelabel",interfacelabel(1:Nvol)) 

!latex \item \verb+tflux(1:Nvol)+; real; toroidal flux enclosed by each interface;

  HWRITERV(Nvol,"tflux",tflux(1:Nvol))                   

!latex \item \verb+pressure(1:Nvol)+; real; pressure in each volume;

  HWRITERV(Nvol,"pressure",pressure(1:Nvol))             

!latex \item \verb+iota(1:Nvol)+; real; rotational-transform on each interface;

  HWRITERV(Nvol,"iota",iota(1:Nvol))                     

!latex \item \verb+forceerr+; real; force-balance error across interfaces;

  HWRITERV(1,"forceerr",forceerr)                      

!latex \item \verb+looperr+; real; force-balance error across interfaces;

  HWRITERV(1,"looperr",looperr)                        

!latex \item \verb+Bsupumn(Nvol,1:mn)+; real; tangential field : $({\bf B}\cdot\nabla \t)_{m,n}$ on plasma boundary;

  HWRITERV(mn,"Bsupumn",Bsupumn(Nvol,1-iexvol,1:mn)) ! 10 Oct 12; added iexvol;

!latex \item \verb+Bsupvmn(Nvol,1:mn)+; real; tangential field : $({\bf B}\cdot\nabla \z)_{m,n}$ on plasma boundary;

  HWRITERV(mn,"Bsupvmn",Bsupvmn(Nvol,1-iexvol,1:mn)) ! 10 Oct 12; added iexvol;
      
  if( Whdfint ) then
   cput = MPI_WTIME()
   do imn = 1, mn ; write(ounit,1000) cput-cpus, im(imn), in(imn), iRbc(Nvol,imn), iZbs(Nvol,imn), Bsupumn(Nvol,1,imn), Bsupvmn(Nvol,1,imn)
   enddo
  endif
  
1000 format("hdfint : "f10.2" : (m,n)=("i4" ,"i4" ) ; iRbc(Nvol,.)="es13.5" ; iZbs(Nvol,.)="es13.5" ; Bsupumn(.)="es13.5" ; Bsupvmn(.)="es13.5" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{itemize}

!latex \item Note that all quantities marked as real should be treated as double precision.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  call h5fclose_f( file_id , hdfier ) ! terminate access;

  FATALMESS(hdfint,hdfier.ne.0,error calling h5fclose_f)


  call h5close_f( hdfier ) ! close Fortran interface;

  FATALMESS(hdfint,hdfier.ne.0,error calling h5close_f)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(hdfint)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine hdfint

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
