!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs derivatives of energy integral with respect to vector potential.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma01ah(  lvol , multiplier , mu , NBdof , dFdx )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one
  use numerical, only : vsmall, small
  use fileunits, only : ounit
  use inputlist, only : Wma01ah, Ni, Nofe
  use cputiming, only : Tma01ah
  use allglobal, only : myid, cpus, &
                        mn, im, in, doAt, doAz, &                              ! Fourier resolution, field variables = degrees of freedom;
                        igss, igst, igsz, igtt, igtz, igzz, igoo, ijk,&          ! metric integrals;
                        ivol, dpflux
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in)  :: lvol, NBdof ! this is really global, but included in argument list to simplify allocation of dtkqdtjp, etc.
  REAL,    intent(in)  :: multiplier, mu ! helicity multiplier;
  REAL,    intent(out) :: dFdx(0:NBdof) ! derivatives of energy functional wrt degrees of freedom in vector potential;

  INTEGER              :: ij, ik, ip, iq, il, ir, ii, ix, jx ! loop control; matrix element identification;

  INTEGER              :: pNBdof, Ldfmuaa, iflag, Ldo, ifb
  REAL                 :: Xmuaa(0:NBdof), dGdx(0:NBdof) , FJAC(0:NBdof,0:NBdof)
  
  INTEGER              :: jk, kj, mj, mk, nj, nk, njnk, njmk, mjnk, mjmk, coefficient ! shorthand;

  REAL                 :: hmul, addterm

  BEGIN(ma01ah)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  hmul = half * mu ! shorthand;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  dFdx(0:NBdof) = zero ! initialize summation;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ij = 1 , mn
   do ii = 0 , Ni(lvol)
    do ip = 0 , Nofe
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
     do ik = 1 , mn
      do iq = 0 , Nofe
       
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
       
       jk = ijk(ij,ik) ; kj = ijk(ik,ij) ! shorthand;
       
       mj = im(ij) ; mk = im(ik) ; nj = in(ij) ; nk = in(ik) ; njnk = nj*nk ; njmk = nj*mk ; mjnk = mj*nk ; mjmk = mj*mk ! shorthand;
       
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
       
       do il = 0 , 1
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
        if( ii  .gt. 0       .and. ii-1+il.ge. 0       ) then 
         
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 

         ix = doAt(0,lvol,ij,ip)%i(ii) ! labels degree of freedom;

         if( ix.gt.0 ) then 
          
          if( ij.gt.1 .and. ii.eq.Ni(lvol) .and. ip.eq.0 ) then ; coefficient =  im(ij)
          else                                                  ; coefficient =   1
          endif
          
          FATALMESS(ma01aa,ii.le.0,out-of-range)
          
          addterm = multiplier * ( &
        + njmk * doAz(0,lvol,ik,iq)%s(ii-1+il) * igss( 1,ip,il,iq,jk)%s(ii  )   &
        + njnk * doAt(0,lvol,ik,iq)%s(ii-1+il) * igss( 1,ip,il,iq,jk)%s(ii  )   &
        + nj   * doAz(0,lvol,ik,iq)%s(ii-1+il) * igst( 1,ip,il,iq,jk)%s(ii  )   &
        -   mk * doAz(0,lvol,ik,iq)%s(ii-1+il) * igsz(il,iq, 1,ip,kj)%s(ii  )   &
        - nj   * doAt(0,lvol,ik,iq)%s(ii-1+il) * igsz( 1,ip,il,iq,jk)%s(ii  )   &
        -   nk * doAt(0,lvol,ik,iq)%s(ii-1+il) * igsz(il,iq, 1,ip,kj)%s(ii  )   &
        -        doAz(0,lvol,ik,iq)%s(ii-1+il) * igtz( 1,ip,il,iq,jk)%s(ii  )   &
        +        doAt(0,lvol,ik,iq)%s(ii-1+il) * igzz( 1,ip,il,iq,jk)%s(ii  ) ) &
        + hmul * doAz(0,lvol,ik,iq)%s(ii-1+il) * igoo( 1,ip,il,iq,jk)%s(ii  )   &
        - hmul * doAz(0,lvol,ik,iq)%s(ii-1+il) * igoo(il,iq, 1,ip,jk)%s(ii  )
          
          FATALMESS(ma01ah,ix.gt.NBdof,out-of-range)
          
          dFdx(ix) = dFdx(ix) + addterm * coefficient
          
         endif ! end of if( ix.gt.0 );
                  
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 

         ix = doAz(0,lvol,ij,ip)%i(ii) ! labels degree of freedom;

         if( ix.gt.0 ) then 
         
          if( ij.gt.1 .and. ii.eq.Ni(lvol) .and. ip.eq.0 ) then ; coefficient = -in(ij)
          else                                                  ; coefficient =   1
          endif
         
          FATALMESS(ma01aa,ii.le.0,out-of-range)
          
          addterm = multiplier * ( &
        + mjmk * doAz(0,lvol,ik,iq)%s(ii-1+il) * igss( 1,ip,il,iq,jk)%s(ii  )   &
        + mjnk * doAt(0,lvol,ik,iq)%s(ii-1+il) * igss( 1,ip,il,iq,jk)%s(ii  )   &
        + mj   * doAz(0,lvol,ik,iq)%s(ii-1+il) * igst( 1,ip,il,iq,jk)%s(ii  )   &
        +   mk * doAz(0,lvol,ik,iq)%s(ii-1+il) * igst(il,iq, 1,ip,kj)%s(ii  )   &
        +   nk * doAt(0,lvol,ik,iq)%s(ii-1+il) * igst(il,iq, 1,ip,kj)%s(ii  )   &
        - mj   * doAt(0,lvol,ik,iq)%s(ii-1+il) * igsz( 1,ip,il,iq,jk)%s(ii  )   &
        +        doAz(0,lvol,ik,iq)%s(ii-1+il) * igtt( 1,ip,il,iq,jk)%s(ii  )   &
        -        doAt(0,lvol,ik,iq)%s(ii-1+il) * igtz( 1,ip,il,iq,jk)%s(ii  ) ) &
        + hmul * doAt(0,lvol,ik,iq)%s(ii-1+il) * igoo(il,iq, 1,ip,jk)%s(ii  )   &
        - hmul * doAt(0,lvol,ik,iq)%s(ii-1+il) * igoo( 1,ip,il,iq,jk)%s(ii  )
          
          FATALMESS(ma01ah,ix.gt.NBdof,out-of-range)
          
          dFdx(ix) = dFdx(ix) + addterm * coefficient
          
         endif ! end of if( ix.gt.0 );
         
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 

        endif ! end of if( ii-1+il.ge. 0       );

!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 

!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
        
        if( ii+1.le.Ni(lvol) .and. ii  +il.le.Ni(lvol) ) then 

!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
          
         ix = doAt(0,lvol,ij,ip)%i(ii) ! labels degree of freedom;
         
         if( ix.gt.0 ) then 

          if( ij.gt.1 .and. ii.eq.Ni(lvol) .and. ip.eq.0 ) then ; coefficient =  im(ij)
          else                                                  ; coefficient =   1
          endif
          
          FATALMESS(ma01ah,ii+1.gt.Ni(lvol),out-of-range)
          
          addterm = multiplier * ( &
        + njmk * doAz(0,lvol,ik,iq)%s(ii  +il) * igss( 0,ip,il,iq,jk)%s(ii+1)   &
        + njnk * doAt(0,lvol,ik,iq)%s(ii  +il) * igss( 0,ip,il,iq,jk)%s(ii+1)   &
        + nj   * doAz(0,lvol,ik,iq)%s(ii  +il) * igst( 0,ip,il,iq,jk)%s(ii+1)   &
        -   mk * doAz(0,lvol,ik,iq)%s(ii  +il) * igsz(il,iq, 0,ip,kj)%s(ii+1)   &
        - nj   * doAt(0,lvol,ik,iq)%s(ii  +il) * igsz( 0,ip,il,iq,jk)%s(ii+1)   &
        -   nk * doAt(0,lvol,ik,iq)%s(ii  +il) * igsz(il,iq, 0,ip,kj)%s(ii+1)   &
        -        doAz(0,lvol,ik,iq)%s(ii  +il) * igtz( 0,ip,il,iq,jk)%s(ii+1)   &
        +        doAt(0,lvol,ik,iq)%s(ii  +il) * igzz( 0,ip,il,iq,jk)%s(ii+1) ) &
        + hmul * doAz(0,lvol,ik,iq)%s(ii  +il) * igoo( 0,ip,il,iq,jk)%s(ii+1)   &
        - hmul * doAz(0,lvol,ik,iq)%s(ii  +il) * igoo(il,iq, 0,ip,jk)%s(ii+1)
          
          FATALMESS(ma01ah,ix.gt.NBdof,out-of-range)
          
          dFdx(ix) = dFdx(ix) + addterm * coefficient
          
         endif ! end of if( ix.gt.0 );
         
!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
         
         ix = doAz(0,lvol,ij,ip)%i(ii) ! labels degree of freedom;

         if( ix.gt.0 ) then 
                   
          if( ij.gt.1 .and. ii.eq.Ni(lvol) .and. ip.eq.0 ) then ; coefficient = -in(ij)
          else                                                  ; coefficient =   1
          endif
          
          FATALMESS(ma01ah,ii+1.gt.Ni(lvol),out-of-range)
          
          addterm = multiplier * ( &
        + mjmk * doAz(0,lvol,ik,iq)%s(ii  +il) * igss( 0,ip,il,iq,jk)%s(ii+1)   &
        + mjnk * doAt(0,lvol,ik,iq)%s(ii  +il) * igss( 0,ip,il,iq,jk)%s(ii+1)   &
        + mj   * doAz(0,lvol,ik,iq)%s(ii  +il) * igst( 0,ip,il,iq,jk)%s(ii+1)   &
        +   mk * doAz(0,lvol,ik,iq)%s(ii  +il) * igst(il,iq, 0,ip,kj)%s(ii+1)   &
        +   nk * doAt(0,lvol,ik,iq)%s(ii  +il) * igst(il,iq, 0,ip,kj)%s(ii+1)   &
        - mj   * doAt(0,lvol,ik,iq)%s(ii  +il) * igsz( 0,ip,il,iq,jk)%s(ii+1)   &
        +        doAz(0,lvol,ik,iq)%s(ii  +il) * igtt( 0,ip,il,iq,jk)%s(ii+1)   &
        -        doAt(0,lvol,ik,iq)%s(ii  +il) * igtz( 0,ip,il,iq,jk)%s(ii+1) ) &
        + hmul * doAt(0,lvol,ik,iq)%s(ii  +il) * igoo(il,iq, 0,ip,jk)%s(ii+1)   &
        - hmul * doAt(0,lvol,ik,iq)%s(ii  +il) * igoo( 0,ip,il,iq,jk)%s(ii+1)
          
          FATALMESS(ma01ah,ix.gt.NBdof,out-of-range)
          
          dFdx(ix) = dFdx(ix) + addterm * coefficient
          
         endif ! end of if( ix.gt.0 );

!  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
         
        endif ! end of if( ii  +il.le.Ni(lvol) );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

       enddo ! end of do il;
       
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

      enddo ! end of do iq;
     enddo ! end of do ik;
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
    enddo ! end of do ip;
   enddo ! end of do ii;
  enddo ! end of do ij;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ma01ah)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ma01ah

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
