!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Calculates averaged (over angles) metric quantities at arbitrary radial location.

!latex \item The relevant information is stored in 
!latex
!latex \verb+agss(1:mn*mn)+,
!latex  
!latex \verb+agst(1:mn*mn)+,
!latex  
!latex \verb+agsz(1:mn*mn)+,
!latex  
!latex \verb+agtt(1:mn*mn)+,
!latex  
!latex \verb+agtz(1:mn*mn)+,
!latex  
!latex \verb+agzz(1:mn*mn)+,
!latex
!latex which are passed through global.  

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine me00ab( lvol, lss, ii ) 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, quarter, half, pi2
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wme00ab, Nvol, Ni, Lgeometry
  use cputiming, only : Tme00ab
  use allglobal, only : myid, cpus, interfacelabel, pi2nfp, pi2pi2nfpquarter, dAd,      &
                        mn, im, in, mne, ime, ine,                                      &
                        isr, Nt, Nz, Ntz, trigm, trign, trigwk, efmn, ofmn, cfmn, sfmn, &
                        sg, ijreal, ijimag,                                             &
                           gij,  glmn,                                                  &
                        dxgij, dxglmn,                                                  &
                        tripleipp, tripleipm, tripleimp, tripleimm,                     &
                          agss,   agst,   agsz,   agtt,   agtz,   agzz,                 &
                        dxagss, dxagst, dxagsz, dxagtt, dxagtz, dxagzz


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lvol, ii
  REAL   , intent(in) :: lss 
  
  INTEGER             :: ifail, Lcurv, ij, ik, jk, kj, imn, innout, igij
  INTEGER             :: tipp, tipm, timp, timm

  BEGIN(me00ab)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(me00ab,lvol-1.lt.0 .or. lvol.gt.Nvol,invalid lvol)

  FATALMESS(me00ab,lss.lt.interfacelabel(lvol-1) .or. lss.gt.interfacelabel(lvol),invalid)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

              Lcurv = 1
  if( dAd%L ) Lcurv = 3

  WCALL(me00ab,co01aa,( lvol, lss, Lcurv, Ntz )) !latex \item The routine \verb+co01aa+ is called to provide \verb+sg(:)+ and \verb+gij(1:6,0,:)+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item A fast Fourier transform is constructed, with an enhanced resolution (compared to the Fourier description of the coordinates),
!latex of the following metric quantities.
!latex An enhanced Fourier resolution is required as these metric elements involve products and division by the Jacobian,
!latex and this will generally result in a broadened Fourier spectrum.
  
  do ij = 1,6 ; gij(ij,0,:) = gij(ij,0,:) / sg(0,:)
  enddo

  if( dAd%L ) then ; dxglmn(1:6,0:mne) = zero ! I THINK THIS IS WASTEFUL ON MEMORY;
  else             ;   glmn(1:6,0:mne) = zero ! I THINK THIS IS WASTEFUL ON MEMORY;
  endif

!latex \be \bar g_{\s\s} & \equiv & \sqrt g^{-1} g_{\s\s} = \sum_i (\sqrt g^{-1} g_{\s\s})_i \cos(\alpha_i), \\
!latex     \bar g_{\s\t} & \equiv & \sqrt g^{-1} g_{\s\t} = \sum_i (\sqrt g^{-1} g_{\s\t})_i \sin(\alpha_i), \\
!latex     \bar g_{\s\z} & \equiv & \sqrt g^{-1} g_{\s\z} = \sum_i (\sqrt g^{-1} g_{\s\z})_i \sin(\alpha_i), \\
!latex     \bar g_{\t\t} & \equiv & \sqrt g^{-1} g_{\t\t} = \sum_i (\sqrt g^{-1} g_{\t\t})_i \cos(\alpha_i), \\
!latex     \bar g_{\t\z} & \equiv & \sqrt g^{-1} g_{\t\z} = \sum_i (\sqrt g^{-1} g_{\t\z})_i \cos(\alpha_i), \\
!latex     \bar g_{\z\z} & \equiv & \sqrt g^{-1} g_{\z\z} = \sum_i (\sqrt g^{-1} g_{\z\z})_i \cos(\alpha_i),
!latex \ee
!latex where $\alpha_i\equiv m_i\t-n_i\z$.
  
  if( dAd%L ) then
   
   do igij = 1, 5, 2 ! loop over metrics;
    
    ijreal(1:Ntz) = dxgij(igij  ,1:Ntz)
    ijimag(1:Ntz) = dxgij(igij+1,1:Ntz)
    
    ifail = 0 ; call tfft( Nt,Nz, ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk, mne,ime,ine, efmn(1:mne),ofmn(1:mne),cfmn(1:mne),sfmn(1:mne), ifail )
    
    if    ( igij.eq.1 ) then ; dxglmn(igij  ,1:mne) = efmn(1:mne) ; dxglmn(igij+1,1:mne) = sfmn(1:mne)
    elseif( igij.eq.3 ) then ; dxglmn(igij  ,1:mne) = ofmn(1:mne) ; dxglmn(igij+1,1:mne) = cfmn(1:mne)
    elseif( igij.eq.5 ) then ; dxglmn(igij  ,1:mne) = efmn(1:mne) ; dxglmn(igij+1,1:mne) = cfmn(1:mne)
    else                     ; FATALMESS(me00ab,.true.,error identifying igij)
    endif
    
   enddo ! end of do igij;

  else
  
  ifail = 0 ; call tfft( Nt,Nz, gij(1,0,1:Ntz),gij(2,0,1:Ntz),isr,trigm,trign,trigwk, mne,ime,ine, glmn(1,1:mne),   ofmn(1:mne),   cfmn(1:mne), glmn(2,1:mne), ifail )
  ifail = 0 ; call tfft( Nt,Nz, gij(3,0,1:Ntz),gij(4,0,1:Ntz),isr,trigm,trign,trigwk, mne,ime,ine,   efmn(1:mne), glmn(3,1:mne), glmn(4,1:mne),   sfmn(1:mne), ifail )
  ifail = 0 ; call tfft( Nt,Nz, gij(5,0,1:Ntz),gij(6,0,1:Ntz),isr,trigm,trign,trigwk, mne,ime,ine, glmn(5,1:mne),   ofmn(1:mne), glmn(6,1:mne),   sfmn(1:mne), ifail ) 
   
  endif ! end of if( dAd%L )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  glmn(1:6,0) = zero ! not all of the tripleipp, tripleipm, tripleimp and tripleimm are assigned: i.e. some default to 0, so dummy workspace is included in glmn's;
  
  do ij = 1, mn
   do ik = 1, mn ; jk = ik + (ij-1) * mn
    
    tipp = tripleipp(ij,ik) ; tipm = tripleipm(ij,ik) ; timp = tripleimp(ij,ik) ; timm = tripleimm(ij,ik) ! these are assigned in al00aa;
    
    if( dAd%L ) then
     dxagss(jk) = ( - dxglmn(1,tipp) + dxglmn(1,tipm) + dxglmn(1,timp) - dxglmn(1,timm) ) * pi2pi2nfpquarter
     dxagst(jk) = ( - dxglmn(2,tipp) - dxglmn(2,tipm) + dxglmn(2,timp) + dxglmn(2,timm) ) * pi2pi2nfpquarter
     dxagsz(jk) = ( - dxglmn(3,tipp) - dxglmn(3,tipm) + dxglmn(3,timp) + dxglmn(3,timm) ) * pi2pi2nfpquarter
     dxagtt(jk) = ( + dxglmn(4,tipp) + dxglmn(4,tipm) + dxglmn(4,timp) + dxglmn(4,timm) ) * pi2pi2nfpquarter
     dxagtz(jk) = ( + dxglmn(5,tipp) + dxglmn(5,tipm) + dxglmn(5,timp) + dxglmn(5,timm) ) * pi2pi2nfpquarter
     dxagzz(jk) = ( + dxglmn(6,tipp) + dxglmn(6,tipm) + dxglmn(6,timp) + dxglmn(6,timm) ) * pi2pi2nfpquarter
    else
       agss(jk) = ( -   glmn(1,tipp) +   glmn(1,tipm) +   glmn(1,timp) -   glmn(1,timm) ) * pi2pi2nfpquarter
       agst(jk) = ( -   glmn(2,tipp) -   glmn(2,tipm) +   glmn(2,timp) +   glmn(2,timm) ) * pi2pi2nfpquarter
       agsz(jk) = ( -   glmn(3,tipp) -   glmn(3,tipm) +   glmn(3,timp) +   glmn(3,timm) ) * pi2pi2nfpquarter
       agtt(jk) = ( +   glmn(4,tipp) +   glmn(4,tipm) +   glmn(4,timp) +   glmn(4,timm) ) * pi2pi2nfpquarter
       agtz(jk) = ( +   glmn(5,tipp) +   glmn(5,tipm) +   glmn(5,timp) +   glmn(5,timm) ) * pi2pi2nfpquarter
       agzz(jk) = ( +   glmn(6,tipp) +   glmn(6,tipm) +   glmn(6,timp) +   glmn(6,timm) ) * pi2pi2nfpquarter
    endif
    
   enddo ! end of do ik;
  enddo ! end of do ij;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(me00ab)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item The following quantities are returned :
!latex \be \mbox{\type{agss(j,k)}}&=&
!latex \mbox{$\braket{s_j}{\bar g_{\s\s}}{s_k}$} = 
!latex \int_0^{2\pi} \!\!\!\!\!\!\! d\theta \int_0^{2\pi/N} \!\!\!\!\!\!\!\!\!\!\!\! d\zeta \; \; \sin(\alpha_j)  \; \; \bar g_{\s\s} \; \; \sin(\alpha_k) , \\
!latex     \mbox{\type{agst(j,k)}}&=&\mbox{$\braket{s_j}{\bar g_{\s\t}}{c_k}$}, \\
!latex     \mbox{\type{agsz(j,k)}}&=&\mbox{$\braket{s_j}{\bar g_{\s\z}}{c_k}$}, \\
!latex     \mbox{\type{agtt(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\t\t}}{c_k}$}, \\
!latex     \mbox{\type{agtz(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\t\z}}{c_k}$}, \\
!latex     \mbox{\type{agzz(j,k)}}&=&\mbox{$\braket{c_j}{\bar g_{\z\z}}{c_k}$}, \\
!latex     \mbox{\type{agoo(j,k)}}&=&\mbox{$\braket{c_j}{\;   1 \; }{c_k}$}. 
!latex \ee

!latex \item The following are manifestly symmetric
!latex \be \mbox{\type{agss(j,k)}}=\mbox{\type{agss(k,j)}}, \\
!latex     \mbox{\type{agtt(j,k)}}=\mbox{\type{agtt(k,j)}}, \\
!latex     \mbox{\type{agtz(j,k)}}=\mbox{\type{agtz(k,j)}}, \\
!latex     \mbox{\type{agzz(j,k)}}=\mbox{\type{agzz(k,j)}}. \ee
!latex The remaining terms may be represented as a sum of symmetric and asymmetric terms.
!latex It should be possible to exploit this symmetry to reduce the computation.

!latex \item Having a Fourier representation of $\bar g_{ss}=\sum_p (\bar g_{ss})_p \cos(m_p\theta-n_p\zeta)$ etc.
!latex triple-angle formulae are used to calculate $\braket{s_j}{\bar g_{\s\s}}{s_k}$ etc.
  
!latex \item For convenience, the double angle formulae are
!latex \be \sin \alpha \cos \beta &=& \frac{1}{2}\left[\sin(\alpha-\beta)+\sin(\alpha+\beta)\right],\\
!latex     \sin \alpha \sin \beta &=& \frac{1}{2}\left[\cos(\alpha-\beta)-\cos(\alpha+\beta)\right],\ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine me00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
