!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Confirms force balance using surface potential and constructs \Poincare plot for pressure-jump Hamiltonian.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ph01aa( lvol ) 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2, quarter
  use fileunits, only : ounit, wunit
  use inputlist, only : Wph01aa, ext, Nvol, Ni, odetol, nPtrj, nPpts, pressure, pscale
  use cputiming, only : Tph01aa
  use allglobal, only : cpus, myid, ncpu, pi2nfp, mn, im, in, iRbc, iZbs
  
  use pjhamilto, only : io, Itor, Gpol, spmn
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: lvol
  
  INTEGER   :: Node, itrj, jpts, id02bjf, lli, oio, ioi, imn, lnPtrj
  REAL      :: phi, ptt(6), dptt(6), wk(20*6), tol, zst, zend, pto, sumerr(2), presi, preso
  CHARACTER :: RA, suff*6
  
  external  :: ph00aa, ph00aa_out, ph00aa_end
  
  BEGIN(ph01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( nPtrj(lvol).ge.0 ) then ; lnPtrj = nPtrj(lvol) ! selected Poincare resolution;
  else                      ; lnPtrj = Ni(lvol)    ! adapted  Poincare resolution;
  endif

  if( lnPtrj.le.0 ) goto 9999 ! return;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do io = 0 , 1 ! loop over inner and outer interface for each volume; needs to be passed through to ph00aa (via pjhamilto module);
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   if( lvol.eq.  1  .and. io.eq.0 ) cycle ! no need to examine force-balance on lower boundary / coordinate axis;
   if( lvol.eq.Nvol .and. io.eq.1 ) cycle ! no need to examine force-balance on outer boundary;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   lli = lvol-1 + 2*io ; oio = 1-io ; ioi = lvol + io-1 ! shorthand; 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   presi = pressure(lvol) * pscale ; preso = pressure(lli) * pscale

   call pj00aa(mn,iRbc(ioi,1:mn),iZbs(ioi,1:mn),Itor(lvol,io),Gpol(lvol,io),spmn(lvol,io,1:mn),presi,Itor(lli,oio),Gpol(lli,oio),spmn(lli,oio,1:mn),preso,sumerr(1:2))

   if( Wph01aa ) then ; cput = MPI_WTIME()
    write(ounit,'("ph01aa : "f10.2" :  "3x"  "2x"   Itor="2es23.15" ; "2es23.15" ;")')cput-cpus,Itor(lvol,io),Itor(lli,oio),Itor(lvol,io)-Itor(lli,oio),Itor(lvol,io)+Itor(lli,oio)
    write(ounit,'("ph01aa : "f10.2" :  "3x"  "2x"   Gpol="2es23.15" ; "2es23.15" ;")')cput-cpus,Gpol(lvol,io),Gpol(lli,oio),Gpol(lvol,io)-Gpol(lli,oio),Itor(lvol,io)+Itor(lli,oio)
    do imn = 1 , mn
    write(ounit,'("ph01aa : "f10.2" : ("i3" ,"i2" ) spmn="2es23.15" ; "2es23.15" ;")')&
  cput-cpus,im(imn),in(imn),spmn(lvol,io,imn),spmn(lli,oio,imn),spmn(lvol,io,imn)-spmn(lli,oio,imn),spmn(lvol,io,imn)+spmn(lli,oio,imn)
    enddo
   endif

   cput = MPI_WTIME() ; write(ounit,1001)cput-cpus,myid,lvol,io,sumerr(1:2),lnPtrj
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( lnPtrj.le.0 .or. nPpts.le.0 ) cycle ! don't construct Poincare plot;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( nPtrj(lvol).ge.0 ) then ; lnPtrj = nPtrj(lvol) ! selected Poincare resolution;
   else                      ; lnPtrj = Ni(lvol)    ! adapted  Poincare resolution;
   endif
  
   Node = 6 ; tol = odetol ; RA='D' ! set parameters for o.d.e. integration;

   pto = Itor(lli,oio)
   do imn = 1,mn ; pto = pto + spmn(lli,oio,imn) * im(imn) ! * cos( im(imn)*zero -in(imn)*zero )
   enddo
   
   write(suff,'(i4.4":"i1)')lvol,io    

   open(wunit+myid,file="."//trim(ext)//".pjh:"//suff//".dat",status="unknown")
!   open(wunit+myid,file="."//trim(ext)//".pjh:"//suff,status="unknown",form="unformatted")
   
   write(wunit+myid,'(i9,3es23.15)')mn,Itor(lli,oio),Gpol(lli,oio),pto
   write(wunit+myid,'(2i9,es23.15)')(im(imn),in(imn),spmn(lli,oio,imn),imn=1,mn)
!   write(wunit+myid)mn,Itor(lli,oio),Gpol(lli,oio),pto
!   write(wunit+myid)im(1:mn)
!   write(wunit+myid)in(1:mn)
!   write(wunit+myid)spmn(lli,oio,1:mn)

   do itrj = -lnPtrj , lnPtrj

    ptt = (/ pto + itrj * pto * quarter / lnPtrj, zero , one , zero , zero , one /)
    
    do jpts = 1 , nPpts
     
     zst=zero ; zend=zst + pi2nfp ; id02bjf=1
     call D02BJF( zst , zend , Node , ptt , ph00aa , tol , RA , ph00aa_out , ph00aa_end , wk , id02bjf )
     
     ptt = (/ ptt(1) , mod(ptt(2),pi2) , one , zero , zero , one /)
     
     write(wunit+myid,'(2es23.15,i9)')ptt(1:2),itrj
!     write(wunit+myid)ptt(1:2),itrj
     
     FATALMESS(ph01aa,id02bjf.eq.1,input error)
     FATALMESS(ph01aa,id02bjf.eq.2,error integrating field)
     FATALMESS(ph01aa,id02bjf.eq.3,tol is too small)
     FATALMESS(ph01aa,id02bjf.eq.4,xsol not reset)
     FATALMESS(ph01aa,id02bjf.eq.5,xsol lies past xend)
     FATALMESS(ph01aa,id02bjf.eq.6,did not change sign)
     FATALMESS(ph01aa,id02bjf.eq.7,serious error)
     FATALMESS(ph01aa,id02bjf.ne.0,fail)
     
    enddo ! end of do jpts
    
   enddo ! end of do itrj
   
   close(wunit+myid)
   
  enddo ! end of do io = 0,1;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ph01aa)

1001 format("ph01aa : "f10.2" : myid="i3" ; lvol="i3" ; io="i2" ; <<2p+BB>>, [[2p+BB]]="2es13.5" ; lnPtrj="i4" ;")
  
end subroutine ph01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
