!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs \Poincare plot and `approximate' rotational-transform. ! 14 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pp00aa( lvol ) 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one

  use numerical, only : ! 14 Oct 12;

  use fileunits, only : ounit, punit

  use inputlist, only : Wpp00aa, Lgeometry, Nvol, Ni, ext, odetol, Lpoincare, nPpts, nPtrj, npq, Nghd, Lpqsym, pqs, pqt, Nunstable, dunstable, Munstable

  use cputiming, only : Tpp00aa

  use allglobal, only : myid, ncpu, cpus, Nz, interfacelabel, ss, pi2nfp, diota, pqorbit, qfms, ivol, Ltangent, svol, Lfb, Louterboundarynormal
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lvol

  INTEGER             :: id02bjf, ii, lnPtrj, ioff, nc, pp, qq, iev, linnout, iupdown !nc, nqfmsok
  REAL                :: sti(2), stis(2), stie(2), wr(2), wi(2)
  REAL, allocatable   :: poincaredata(:,:,:,:), fittedtransform(:,:) !, qfmsst(:,:) ! for writing blocks to poincare unit;

  BEGIN(pp00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ivol = lvol ; Ltangent = 0 ! required to pass these logical control flags through to bf00aa; tangent map is not required for Poincare plot;

  FATALMESS(pp00aa,lvol.lt.1.or.lvol.gt.Nvol,invalid volume)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{relevant input variables} \begin{enumerate}

!latex \item The resolution of \Poincare plot is controlled by 
!latex       \begin{itemize} 
!latex       \item \verb+nPtraj+ trajectories will be located in each volume;
!latex       \item \verb+nPpts+ iterations per trajectory;
!latex       \item \verb+odetol+ o.d.e. integration tolerance;
!latex       \end{itemize}
!latex       The magnetic field (and tangent field) is given by \verb+bf00aa+.

!latex \item Additional trajectories are followed inside the islands; only if the quadratic-flux minimizing surfaces have been constructed.

  if( nPtrj(lvol).ge.0 ) then ; lnPtrj = nPtrj(lvol) ! selected Poincare resolution;
  else                        ; lnPtrj = Ni(lvol)    ! adapted  Poincare resolution;
  endif
  
! if( lnPtrj.le.0 ) goto 9999 ! return;

  if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; ioff = 0 ! Cartesian or annulus; no coordinate singularity; should use Lcoordinatesingularity;
  else                                                         ; ioff = 1 ! keep away from coordinate axis;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The approximate rotational transform is determined (in \verb+pq00aa+) by field line integration.

  RALLOCATE(fittedtransform,(0:lnPtrj,1:2)) ! will always need fittedtransform(0,1:2);

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! RALLOCATE(qfmsst,(0:Nghd*npq(lvol)-1,1:2))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{format of output: \Poincare}
!latex \item The \Poincare data is written to \verb+.ext.poincare:xxxx+, where \verb+xxxx+ is an integer indicating the volume.
!latex       The format of this file is as follows:
!latex \begin{verbatim}
!latex  write(svol,'(i4.4)')lvol ! lvol labels volume;
!latex  open(punit+myid,file="."//trim(ext)//".poincare."//svol,status="unknown",form="unformatted")
!latex  write(punit+myid) interfacelabel(lvol-1), interfacelabel(lvol) ! doubles
!latex  do until end of file
!latex   write(punit+myid) Nz, nPpts                                   ! integers
!latex   write(punit+myid) poincaredata(1:5,0:Nz-1,1:nPpts)            ! doubles
!latex  enddo
!latex  close(punit+myid)
!latex \end{verbatim}
!latex       where \begin{itemize}
!latex       \item $\t \equiv$ \verb+poincaredata(1,k,j)+ is the poloidal angle,
!latex       \item $\s \equiv$ \verb+poincaredata(2,k,j)+ is the radial coordinate, 
!latex       \item $ R \equiv$ \verb+poincaredata(3,k,j)+ is the cylindrical $R$, 
!latex       \item $ Z \equiv$ \verb+poincaredata(4,k,j)+ is the cylindrical $Z$, and 
!latex       \item $ i \equiv$ \verb+poincaredata(5,k,j)+ labels field line, and is constant along a field line.
!latex       \end{itemize}
!latex \item The integer \verb+k=0,Nz-1+ labels toroidal planes, so that $\phi = ( 2 \pi / $\verb+Nfp+$ ) ( k / $\verb+Nz+$)$,
!latex \item The integer \verb+j=1,nPpts+ labels toroidal iterations.
!latex \item Usually (if no field line integration errors are encountered) the number of field lines followed in volume \verb+lvol+
!latex       is given by $N+1$, where the radial resolution, $N\equiv$\verb+Ni(lvol)+, is given on input.
!latex       This will be over-ruled by if \verb+nPtrj(lvol)+, given on input, is non-negative.
!latex       The starting location for the field line integrations are equally spaced in the radial coordinate $s_i=s_{l-1}+ i (s_{l}-s_{l-1})/N$ for $i=0,N$,
!latex       along the line $\t=0$, $\z=0$.
!latex \item Additional field lines inside islands may be followed if quadratic-flux minimizing surfaces have been constructed, and for these field lines $i_{k,j}$ is negative.

  write(svol,'(i4.4)')lvol

  open(punit+myid,file="."//trim(ext)//".poincare."//svol,status="unknown",form="unformatted")
  write(punit+myid) interfacelabel(lvol-1), interfacelabel(lvol) ! reals   : interface label;
  
  if( Wpp00aa ) then ; cput = MPI_WTIME() ; write(ounit,1001)cput-cpus, myid, lvol, lnPtrj, nPpts, odetol, Lpoincare, Nunstable, dunstable, Munstable
  endif

1001 format("pp00aa : "f10.2" : myid="i3" ; lvol="i3" ; lnPtrj="i3" ; nPpts="i5" ; odetol="es8.1" ; Lpoincare="i2" ; Nunstable="i6" ; dunstable="es8.1" ; Munstable="i3" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! latex \item \verb+if(Nghd.eq.0)+, then quadratic-flux minimizing surfaces (should) have been constructed.
  
! nqfmsok = 0
! if( Nghd.gt.0 ) then
!  do nc = 1,npq(lvol)
!   if( qfms(lvol,1)%i.eq.1 ) then
!    nqfmsok = nqfmsok + qfms(lvol,1)%i ! count how many qfms surfaces successfully constructed;
!   !if( Wpp00aa ) then
!   ! cput = MPI_WTIME()
!   ! write(ounit,'("pp00aa : "f10.2" : myid="i3" ; Nghd, nqfmsok="2i3" ; shape conformance : "3i9)')cput-cpus,myid,Nghd,nqfmsok,Nghd*nqfmsok-Nghd,Nghd*nqfmsok-1
!   !endif
!    qfmsst( Nghd*nqfmsok-Nghd:Nghd*nqfmsok-1,1 ) = qfms(lvol,nc)%trvs(2,0:4*Nghd-1:4,0)
!    qfmsst( Nghd*nqfmsok-Nghd:Nghd*nqfmsok-1,2 ) = qfms(lvol,nc)%trvs(1,0:4*Nghd-1:4,0)
!   endif
!  enddo
! endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{construction of unstable manifold} \begin{enumerate}

!latex \item The unstable manifold is illustrated by mapping a short line segment emanating from the unstable periodic orbit in the unstable direction.

  if( npq(lvol).gt.0 .and. Munstable.gt.0 ) then ! could also include a check on Mpqits;
   
   RALLOCATE(poincaredata,(1:5,0:Nz-1,1:Nunstable,1:Munstable)) ! for block writing to file (allows faster reading of output data files for post-processing plotting routines);
   
   do nc = 1, npq(lvol) ! loop over convergents;
    
    cput = MPI_WTIME()
    
    pp = pqorbit(lvol,nc)%pq(1) ; qq = pqorbit(lvol,nc)%pq(2) ! identify periodicity; shorthand;
    
    if( Wpp00aa ) then 
     write(ounit,1000)cput-cpus, myid, lvol, pp, qq, pqorbit(lvol,nc)%ok
    endif
    
    if( pqorbit(lvol,nc)%ok.eq.1 ) then ! periodic orbit has been successfully located;
     
     wr(1:2) = pqorbit(lvol,nc)%wr(1:2) ; wi(1:2) = pqorbit(lvol,nc)%wi(1:2) ! eigenvalues: real and imaginary; shorthand;
     
1000 format("pp00aa : ":,f10.2" : myid="i3" ; lvol="i3" ; ("i3" ,"i3" ) ; ok="i2" ;":" (s,t)=("es23.15" ,"es23.15" ) ; residue="es13.5" ; eval="2(f9.5" +"f9.5" i ,"))
     
!    if( pqorbit(lvol,nc)%residue.gt.zero ) then ! periodic orbit is   stable;                                      ; ! 15 Oct 12;
!    endif
     if( pqorbit(lvol,nc)%residue.lt.zero ) then ! periodic orbit is unstable; eigenvalue/eigenvector should be real;
      
     !write(ounit,1000) ! 14 Nov 12;
      write(ounit,1000)cput-cpus, myid, lvol, pp, qq, pqorbit(lvol,nc)%ok, pqorbit(lvol,nc)%so, pqorbit(lvol,nc)%to, pqorbit(lvol,nc)%residue, ( wr(iev), wi(iev), iev=1,2 )
      
      do iev = 1, 2 ! loop over stable and unstable directions;
       
       if( pqorbit(lvol,nc)%wr(iev).gt.one ) Lfb = +1 ! this direction is un-stable; follow field lines  forwards; Lfb is used elsewhere;
       if( pqorbit(lvol,nc)%wr(iev).lt.one ) Lfb = -1 ! this direction is    stable; follow field lines backwards; Lfb is used elsewhere;

       if( Lfb.lt.0 ) cycle    ! this direction is    stable; follow field lines backwards; Lfb is used elsewhere; ! there seems to be an error; 15 Oct 12;
       
       do linnout = -1, 1, 2 ! follow in both directions along eigenvector;
        
        do iupdown = -1, 1, 2 ! follow stellarator symmetric pair;

         if( Lpqsym.eq.1 .and. iupdown.ne.1 ) cycle ! Lpqsym=1 enforces stellarator symmetry, so \t = 0; ! 15 Oct 12;

         do ii = 1, Nunstable 
    
!latex \item It would be better, perhaps, to distribute the starting points along the line segment in some exponential fashion . . .
      
          sti(1:2) = (/ pqorbit(lvol,nc)%so , iupdown * pqorbit(lvol,nc)%to /) + ii * linnout * pqorbit(lvol,nc)%vr(1:2,iev) * dunstable / Nunstable
          
          call pp00ab( lvol, sti(1:2), Nz, Munstable, poincaredata(1:4,0:Nz-1,ii,1:Munstable), fittedtransform(0,1:2), id02bjf ) ! 15 Oct 12;
          
          poincaredata(5,0:Nz-1,ii,1:Munstable) = -one ! labels field line; e.g. can be used to color trajectories separately in external plotting diagnostic;
          
!         if( id02bjf.eq.0 ) then ! to be deleted; 15 Oct 12;
!          write(punit+myid) Nz, Munstable ! to be deleted; 15 Oct 12;
!          write(punit+myid) poincaredata(1:5,0:Nz-1,ii,1:Munstable) ! write field line trajectory to file; ! to be deleted; 15 Oct 12;
!         endif ! to be deleted; 15 Oct 12; 
          
         enddo ! end of do ii;
         
         do ii = 1, Munstable ! loop over short loop;
          write(punit+myid) Nz, Nunstable
          write(punit+myid) poincaredata(1:5,0:Nz-1,1:Nunstable,ii) ! write field line trajectory to file; block data over long loop;
         enddo
         
        enddo ! end of do iupdown;
        
       enddo ! end of do linnout;
       
      enddo ! end of do iev;
      
     endif ! end of if( pqorbit(lvol,nc)%residue.lt.zero );
     
    endif ! end of if( pqorbit(lvol,nc)%ok.eq.1 );
    
   enddo ! end of do nc;
   
   DEALLOCATE(poincaredata)
   
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Lfb = +1 ! hereafter follow field lines forwards;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( nPpts.gt.0 ) then
   
   RALLOCATE(poincaredata,(1:5,0:Nz-1,1:1,1:nPpts)) ! for block writing to file (allows faster reading of output data files for post-processing plotting routines);
   
   if( lnPtrj.gt.0 ) then
    
    ;                                     stis(1:2) = (/ interfacelabel(lvol-1), zero               /)
    ;                                     stie(1:2) = (/ interfacelabel(lvol  ), zero               /)
    
    if( Louterboundarynormal .and. npq(lvol).ge.1 ) then
     if( pqorbit(lvol,1)%ok.eq.1 ) then ; stis(1:2) = (/ interfacelabel(lvol-1), pqorbit(lvol,1)%to /)
      ;                                   stie(1:2) = (/ pqorbit(lvol,1)%so    , pqorbit(lvol,1)%to /) ! go through separatrix;
     endif
    endif

    do ii = ioff, lnPtrj ! initialize Poincare plot with trajectories regularly spaced between interfaces along \t=0;
     
     sti(1:2) = stis(1:2) + ii * ( stie(1:2)-stis(1:2) ) / lnPtrj

     if( Wpp00aa ) then ; cput = MPI_WTIME() ; write(ounit,1002)cput-cpus,myid,lvol,sti(1:2)
     endif
     
     call pp00ab( lvol, sti(1:2), Nz, nPpts, poincaredata(1:4,0:Nz-1,1,1:nPpts), fittedtransform(ii,1:2), id02bjf ) 
     
     poincaredata(5,0:Nz-1,1,1:nPpts) = ii*one
     
     if( id02bjf.eq.0 ) then
      write(punit+myid) Nz, nPpts                          ! integers:
      write(punit+myid) poincaredata(1:5,0:Nz-1,1,1:nPpts) ! write field line trajectory to file;
     endif
     
     if( Wpp00aa ) then ; cput = MPI_WTIME() ; write(ounit,1002) cput-cpus, myid, lvol, sti(1:2), id02bjf, fittedtransform(ii,2)
     endif
     
1002 format("pp00aa : "f10.2" : myid="i3" ; lvol="i3" ; st="2es23.15" ;":" id02bjf="i3" ; transform="es23.15" ;")
     
    enddo
    
   endif
   
   DEALLOCATE(poincaredata)

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  close(punit+myid) ! Poincare plot is finished; will re-use punit to write rotational transform data;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{format of output: rotational-transform}

!latex \item The rotational-transform data is written to \verb+.exttransform:xxxx+, where \verb+xxxx+ is an integer indicating the volume.
  
  if( lnPtrj.gt.0 ) then 
   
   open(punit+myid,file="."//trim(ext)//".transform."//svol,status="unknown",form="unformatted") ! rotational transform data;
   
   if( lvol.eq.1 ) write(punit+myid)lnPtrj-ioff+1
   if( lvol.gt.1 ) write(punit+myid)lnPtrj+1
   
   write(punit+myid) Ni(lvol), diota(lvol,0,0:1)
   write(punit+myid) ss(lvol)%s(0:Ni(lvol))
   
   if( lvol.eq.1 ) write(punit+myid)(fittedtransform(ii,1:2),ii=ioff,lnPtrj)
   if( lvol.gt.1 ) write(punit+myid)(fittedtransform(ii,1:2),ii=   0,lnPtrj)
   
   close(punit+myid)
   
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE(fittedtransform)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! do ii = 1 + lnPtrj, - Nghd*nqfmsok, -1 ; iigh = ii + Nghd*nqfmsok ! begin loop over trajectories;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  Node = 6 ; RA = 'D' ; tol = odetol
   
!  if( Lpoincare.eq.2 ) Node = Node + 2 ! two extra o.d.e.s in this case
   
!  if( ii.lt.0 ) then ; st(1:6) = (/ qfmsst(iigh,1), qfmsst(iigh,2), one, zero, zero, one /) ! first quadratic-flux minimizing surface;
!  endif
   
!  if( ii.ge.0 ) then ! equally spaced (in surface label, along \t=0 \z=0) starting point for field line integrations;


!   if( Lpqsym.eq.0 .and. pqs(lvol).gt.zero ) lss = interfacelabel(lvol-1) + ii * (            pqs(lvol) - interfacelabel(lvol-1) ) / lnPtrj

!                     st(1:8) = (/ lss, zero     , one, zero, zero, one, zero, zero /) ! default is to go along \t = 0 line;
!   if( Lpqsym.eq.0 ) st(1:8) = (/ lss, pqt(lvol), one, zero, zero, one, zero, zero /)

!  endif

!  if( ii.eq.1+lnPtrj ) then ! include periodic orbit
!   st(1:8) = (/ pqorbit(lvol,1)%so, pqorbit(lvol,1)%to, one, zero, zero, one, zero, zero /)
!   st(1:2) = st(1:2) + pqorbit(lvol,1)%umanifold(1:2) * small ! perturb away from periodic orbit in direction of unstable manifold;
!  endif

!  if( ii.eq.1+lnPtrj .and. pqorbit(lvol,1)%ok.eq.0 ) cycle

!  if( lvol.eq.1 .and. ii.ge.0 .and. ii.lt.ioff ) cycle ! dont follow field lines on/near coordinate axis;
   
!  sti(1:2) = st(1:2)
   
!  ppt(1:2) = (/ st(2), st(1) /) ! seems redundant;
   
!  leastsqfit(1:5) = (/ zero, zero, zero, ppt(1), one /) ! initialize summations for least squares fit;
   
!  lerror = 0 ! used to exit loop over iterations, do jj and do kk loops, if an integration error is encountered;

!  poincaredata(1:5,0:Nz-1,1:nPpts) = zero

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  do jj = 1, nPpts ! loop over iterations;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!   zst = zero ! starting Poincare plane;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!   do kk = 0, Nz-1 ! loop over toroidal Poincare cross sections;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
!    stz(1:3) = (/ ppt(2), mod(ppt(1),pi2), zst /) ! toroidal coordinates;

!    if( Lpoincare.eq.2 ) stz(3) = st(7) ! zeta is not our integration coordinate, but one of the ODE variables

!    call co00aa( lvol, stz(1:3), RpZ(1:3), dR(0:3), dZ(0:3), jacobian )

!    ppt(3:4)=(/ RpZ(1), RpZ(3) /) ! cylindrical coordinates;

! ii labels field line; if ii lt 0 then island chain (as calculated by quadratic-flux min surface);
!    poincaredata(1:5,kk,jj) = (/ mod(ppt(1),pi2), ppt(2), ppt(3), ppt(4), ii*one /) ! save Poincare information to array;
        
!    zend = zst + pi2nfp/Nz

!    if( Lpoincare.eq.2 ) then
!     if( zst .le. 0 ) then
!      zend = 1.0/small ! choose a large number so that the first zero crossing is certain to be found
!     else
!      zend = zst + st(8)* 10 ! chose a more sensible value to save integration time
!     endif
!     st(8) = 0 ! Reset the \zeta distance from our starting position back to zero
!    endif
    
!    id02bjf = 1
!    if( Lpoincare.eq.2 ) then ; CALL(D02BJF,( zst, zend, Node, st, bf00aa, tol, RA, D02BJX    , bf00aa_end, realwork, id02bjf )) ! integrate to next toroidal subdivision;
!    else                      ; CALL(D02BJF,( zst, zend, Node, st, bf00aa, tol, RA, D02BJX    , D02BJW    , realwork, id02bjf )) ! integrate to next toroidal subdivision;
!    endif

!    cput = MPI_WTIME()
!    select case(id02bjf)                                                      !         1         2         3         4         5         6
!    case(0) ; ! will only give screen output if an error is encountered;      !123456789012345678901234567890123456789012345678901234567890123
!    case(1) ; lerror=1 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"input error                                                    "
!    case(2) ; lerror=2 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"error integrating field                                        "
!    case(3) ; lerror=3 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"tol is too small to take initial step                          "
!    case(4) ; lerror=4 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"xsol not reset or xsol is behind x after initial call to output"
!    case(5) ; lerror=5 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"xsol not reset or xsol is behind last xsol                     "
!    case(6) ; lerror=6 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"termination function did not change sign                       "
!    case(7) ; lerror=7 ; write(ounit,2001)cput-cpus,myid,lvol,ii,jj,kk,id02bjf,"serious error                                                  "
!   !case default
!    end select
!2001 format("pp00aa : "f10.2" : myid="i3" ; lvol="i3" ; (ii,jj,kk)=("i4" ,"i4" ,"i4" ); ifail="i2" ; "a63)
 
!    if( lerror.ne.0 ) exit ! an integration error was encountered; exit do kk loop;

!    ppt(1:2) = (/ st(2), st(1) /) ! again, seems redundant;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
!   enddo ! end of do kk;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!   if( lerror.ne.0 ) exit ! an integration error was encountered; exit do jj loop;
    
!   leastsqfit(1:5) = leastsqfit(1:5) + (/ (jj*pi2nfp)**2, jj*pi2nfp, jj*pi2nfp*ppt(1), ppt(1), one /) ! least squares fit summation;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  enddo ! end of do jj = 1,nPpts

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  if( lerror.eq.0 ) then 
    
!   write(punit+myid)poincaredata(1:5,0:Nz-1,1:nPpts) ! write field line trajectory to file;
    
!   if( ii.ge.0 ) then ! fit straight line, least squares fit to trajectory;
!    fittedtransform(ii,1:2) = (/ sti(1), ( leastsqfit(5)*leastsqfit(3)-leastsqfit(2)*leastsqfit(4) ) / ( leastsqfit(5)*leastsqfit(1)-leastsqfit(2)*leastsqfit(2) ) /)
!   endif

!  endif

!  if( Wpp00aa ) then
!   cput = MPI_WTIME()
!   if( ii.eq.0                  ) write(ounit,1000)cput-cpus,myid,lvol,ii,lerror,sti,fittedtransform(ii,2),diota(lvol,0,0),fittedtransform(ii,2)-diota(lvol,0,0)
!   if( ii.gt.0.and.ii.lt.lnPtrj ) write(ounit,1000)cput-cpus,myid,lvol,ii,lerror,sti,fittedtransform(ii,2)
!   if(             ii.eq.lnPtrj ) write(ounit,1000)cput-cpus,myid,lvol,ii,lerror,sti,fittedtransform(ii,2),diota(lvol,0,1),fittedtransform(ii,2)-diota(lvol,0,1)
!  endif

!1000 format("pp00aa : "f10.2" : myid="i3" ; lvol="i3" , ii="i4" ; lerror="i1" ; (s,t)= ("2f9.5" ) ; iota="2es23.15" ("es10.2") ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! enddo ! end of do ii = - qfms(lvol,1)%i * ( Nghd*2 + 1 ), lnPtrj ; iigh = ii + ( Nghd*2 + 1 )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  



! DEALLOCATE(qfmsst)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Ltangent = 1

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pp00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pp00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
