!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs (and fits smooth curve to) periodic orbits.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item This routine prepares initial guesses for the location of the periodic orbits, which are found using \verb+pq00aa+ by field line following.
!latex \item Periodicities are selected in then input file, $(p_1,q_1,p_2,q_2)=$\verb!pqirr(1:4,:)!.
!latex       Beginning from these rationals (which should be neighboring), \verb!pqirr(5,:)! mediants will also be located ;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pq01aa( lvol )

  use constants, only : zero, quarter, half, one, two, pi2, goldmean

  use fileunits, only : ounit, munit

  use inputlist, only : Wpq01aa,  Nfp,  Nvol, iota, Lpqsym, p1, q1, p2, q2, pqs, pqt, npq, Ni, irrMpol, ext, Mirrits

  use cputiming, only : Tpq01aa

  use allglobal, only : cpus, interfacelabel, mn, Ntz, irrsurf, pqorbit, myid, irrmn, irrim, irrin, Louterboundarynormal

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS 

  INTEGER, intent(in) :: lvol

  INTEGER              :: ii, kk, mm, nc, ncok, ifail, ipqfail, pp, qq, M1, M2, imn
  REAL                 :: err, Tsti(6), low, upp, lowupp(2), iotal, iotau, liota, stz(3), RpZ(3), dR(0:3), dZ(0:3), jacobian

  INTEGER, allocatable :: ik(:) ! ranking;
  REAL   , allocatable :: lds(:), ldt(:), aa(:), ss(:), tt(:)

  CHARACTER            :: ascend, suff*15
  
  BEGIN(pq01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(pq01aa,lvol.lt.1.or.lvol.gt.Nvol,invalid volume)
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  low   = interfacelabel(lvol-1)
  upp   = interfacelabel(lvol  ) ; lowupp = (/ low, upp /) ! this will set search region;

  iotal = iota(lvol-1)
  iotau = iota(lvol  )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ncok = 0 ! this will count how many selected rationals are within transform range;
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do nc = 1, npq(lvol) ! loop over convergents;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   pp = pqorbit(lvol,nc)%pq(1)
   qq = pqorbit(lvol,nc)%pq(2)! * Nfp
   
   liota =  ( pp * Nfp ) * one / qq ! shorthand;
   
   if( .not.Louterboundarynormal .and. ( liota - iotal ) * ( liota - iotau ) .ge. zero ) then ; write(ounit,1001) myid, lvol, pp, qq, pp*one/qq ; cycle ! not within range;
   else                                                                                       ; ncok = ncok+1
   endif
   
1001 format("pq01aa : "10x  " : myid="i3" ; lvol="i3" ; "i3" /"i4" ="f9.6" ; not in range ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( ncok.gt.2 ) then
    if( abs(pqorbit(lvol,nc-1)%residue).gt.one ) exit ! residues are getting too large; irrational surface unlikely to exist;
   endif
   
   if( ncok.gt.2 ) then ; low = minval(lowupp) ; upp = maxval(lowupp) ; pqorbit(lvol,nc)%so = half * ( low + upp ) ! update search bound and initial guess; 14 Nov 12;
   endif
   
   if( Wpq01aa ) write(ounit,1002) myid, lvol, nc, pqorbit(lvol,nc)%pq(1), pqorbit(lvol,nc)%pq(2), pqorbit(lvol,nc)%to, low, pqorbit(lvol,nc)%so, upp
   
   WCALL(pq01aa,pq00aa,( lvol, nc, low, upp, ipqfail ) ) ! locate periodic orbit; before calling pq00aa, need to ensure that to and so are correctly set;
   
   if( Wpq01aa ) write(ounit,1002) myid, lvol, nc, pqorbit(lvol,nc)%pq(1), pqorbit(lvol,nc)%pq(2), pqorbit(lvol,nc)%to, low, pqorbit(lvol,nc)%so, upp, pqorbit(lvol,nc)%ok
   
1002 format("pq01aa : "10x" : myid="i3" ; lvol="i3" ; nc="i3" ; ("i3" ,"i4" ) ; to="f9.6" ; [low,so,upp]=["f9.6" ,"f9.6" ,"f9.6" ] ; calling pq00aa ;":" ok="i2" ;")
   
   if( pqorbit(lvol,nc)%ok.eq.1 .and. nc.eq.1 ) then ; pqs(lvol) = pqorbit(lvol,nc)%so ! update input quantities;
    ;                                                  pqt(lvol) = pqorbit(lvol,nc)%to
   endif
   
   if( ipqfail.ne.0 ) exit ! failed to locate periodic orbit;
   
   lowupp(1:2)=(/ lowupp(2), pqorbit(lvol,nc)%so /) ! bounds for further searches; successive convergents should bound the irrational;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do nc = 1, npq(lvol); 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Mirrits.le.0 ) goto 9999 ! irrational surface is not required;
  if( Lpqsym .ne.1 ) goto 9999 ! irrational surface is not required;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  nc = npq(lvol)

  write(ounit,1000) myid, lvol, pqorbit(lvol,nc)%pq(1:2), pqorbit(lvol,nc)%ok, pqorbit(lvol,nc)%residue
1000 format("pq01aa : "10x" : myid="i3" ; lvol="i3" ; ("i3" ,"i4" ) ; ok="i2" ; residue="f15.9" ;")

  if(     pqorbit(lvol,nc)%ok      .ne.   1    ) goto 9999 ! last convergent not constructed; 26 Nov 12;
  if( abs(pqorbit(lvol,nc)%residue).gt.quarter ) goto 9999 ! irrational surface is not likely to exist; 26 Nov 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(suff,'(i2.2":"i2.2":"i2.2":"i2.2":"i3.3)') p1(lvol), q1(lvol), p2(lvol), q2(lvol), irrMpol ! suffix for irrational surface file; 27 Nov 12;
  
  open(munit+myid,file="."//trim(ext)//"."//suff//".pqirr",status="unknown") ! this file is completed below, after ir00aa is called;

  write(munit+myid,'(4i9)') npq(lvol), irrMpol, irrmn, Nfp

  do nc = 1, npq(lvol) ; qq = pqorbit(lvol,nc)%pq(2)

   write(munit+myid,'(2i6,es23.15)')pqorbit(lvol,nc)%pq(1:2), pqorbit(lvol,nc)%residue
   write(munit+myid,'(2es23.15)')(pqorbit(lvol,nc)%t(ii), pqorbit(lvol,nc)%s(ii), ii = 0, qq )

  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item Approximating periodic orbits provide initial guess for irrational surface.
  
  do nc = npq(lvol), 1, -1 ; pp = pqorbit(lvol,nc)%pq(1) ; qq = pqorbit(lvol,nc)%pq(2)
   
   if( abs(pqorbit(lvol,nc)%residue).lt.one ) then
    
    pqorbit(lvol,nc)%t(0:qq) = pqorbit(lvol,nc)%t(0:qq) - pqorbit(lvol,nc)%a(0:qq) * pp ! lambda;
    
    pqorbit(lvol,nc)%a(0:qq) = modulo(pqorbit(lvol,nc)%a(0:qq),pi2) ; pqorbit(lvol,nc)%a(qq) = pi2 ! mapped back to [0,pi2];
    
    write(ounit,'("pq01aa : a(0:qq)=",99f7.2)')pqorbit(lvol,nc)%a(0:qq)

    M1=1 ; M2=qq+1 ; ascend="A" ; MM=2*irrMpol
    
!latex The periodic orbits are re-ordered,
    
    ALLOCATE(ik,(M2)) ! ranking;
    ifail=0 ; call M01DAF( pqorbit(lvol,nc)%a(0:qq), M1, M2, ascend, ik, ifail ) ! determine ranking;
    ifail=0 ; call M01EAF( pqorbit(lvol,nc)%a(0:qq), M1, M2,         ik, ifail ) ! re-arrange according to rank;
    ifail=0 ; call M01EAF( pqorbit(lvol,nc)%s(0:qq), M1, M2,         ik, ifail ) ! re-arrange according to rank;
    ifail=0 ; call M01EAF( pqorbit(lvol,nc)%t(0:qq), M1, M2,         ik, ifail ) ! re-arrange according to rank;
    DEALLOCATE(ik)
    
    ALLOCATE(lds,(0:qq))
    ALLOCATE(ldt,(0:qq))
    
!latex and a smooth curve (cubic-hermite) is fit,
    
    ifail=1 ; call E01BEF( M2, pqorbit(lvol,nc)%a(0:qq), pqorbit(lvol,nc)%s(0:qq), lds(0:qq), ifail ) ! cubic-interpolation; ! added ifail=1; 27 Nov 12;
    
    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; Xi are not increasing ;")') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; illegal ifail ;"        )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit smooth curve through periodic orbits)

    ifail=1 ; call E01BEF( M2, pqorbit(lvol,nc)%a(0:qq), pqorbit(lvol,nc)%t(0:qq), ldt(0:qq), ifail ) ! cubic-interpolation;
    
    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; Xi are not increasing ;")') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BEF ; ifail="i2" ; illegal ifail ;"        )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit smooth curve through periodic orbits)
    
    ALLOCATE(aa,(0:MM-1))
    ALLOCATE(ss,(0:MM-1))
    ALLOCATE(tt,(0:MM-1))
    
    aa(0:MM-1) = (/ ( kk, kk = 0, MM-1 ) /) * pi2 / MM
    
! cubic-interpolation;

    ifail=1 ; call E01BFF( M2, pqorbit(lvol,nc)%a(0:qq), pqorbit(lvol,nc)%s(0:qq), lds(0:qq), MM, aa(0:MM-1), ss(0:MM-1), ifail )
    
    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Xi are not increasing ;")') myid, lvol, ifail
    case( 3 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; M < 1 ; "               )') myid, lvol, ifail
    case( 4 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Pxi is outside range ; ")') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; illegal ifail ; "       )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit smooth curve through periodic orbits)

    ifail=1 ; call E01BFF( M2, pqorbit(lvol,nc)%a(0:qq), pqorbit(lvol,nc)%t(0:qq), ldt(0:qq), MM, aa(0:MM-1), tt(0:MM-1), ifail )
    
    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Xi are not increasing ;")') myid, lvol, ifail
    case( 3 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; M < 1 ; "               )') myid, lvol, ifail
    case( 4 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Pxi is outside range ; ")') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; illegal ifail ; "       )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit smooth curve through periodic orbits)
    
    DEALLOCATE(aa)
    DEALLOCATE(lds)
    DEALLOCATE(ldt)

    write(ounit,'("pq01aa : "10x" : real space : ss=",99f7.2)')ss(0:MM-1)
    write(ounit,'("pq01aa : "10x" : real space : tt=",99f7.2)')tt(0:MM-1)
    
!latex and a Fourier decomposition is constructed.
    
    ifail=1 ; call C06EAF( ss(0:MM-1), MM, ifail ) ; ss(0:MM-1) = ss(0:MM-1)/sqrt(one*MM) ; ss(1:MM-1) = ss(1:MM-1)*two

    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; prime factor > 19 ; "   )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; #prime factors > 20 ; " )') myid, lvol, ifail
    case( 3 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 4 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; unexpected error ; "    )') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Pxi is outside range ;" )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit Fourier series to smooth curve through periodic orbits)

    ifail=1 ; call C06EAF( tt(0:MM-1), MM, ifail ) ; tt(0:MM-1) = tt(0:MM-1)/sqrt(one*MM) ; tt(1:MM-1) = tt(1:MM-1)*two

    select case(ifail)
    case( 0 )    ; if( Wpq01aa ) write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; success ;"              )') myid, lvol, ifail
    case( 1 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; prime factor > 19 ; "   )') myid, lvol, ifail
    case( 2 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; #prime factors > 20 ; " )') myid, lvol, ifail
    case( 3 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; N < 2 ; "               )') myid, lvol, ifail
    case( 4 )    ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; unexpected error ; "    )') myid, lvol, ifail
    case default ;               write(ounit,'("pq01aa : "10x" : myid="i3" lvol="i3" ; called E01BFF ; ifail="i2" ; Pxi is outside range ;" )') myid, lvol, ifail
    end select

    FATALMESS(pq01aa,ifail.ne.0,failed to fit Fourier series to smooth curve through periodic orbits)
    
    write(ounit,'("pq01aa : "10x" : Four space : ss=",99f7.2)')ss(0:MM-1)
    write(ounit,'("pq01aa : "10x" : Four space : tt=",99f7.2)')tt(0:MM-1)

!latex The Fourier harmonics of the `periodic-{\em curve}' is used as an initial guess 
!latex for the construction of the irrational invariant curves.
    
    irrsurf%sm(0:irrMpol) = zero ; irrsurf%sm(0:irrMpol-1) =  ss(   0:   irrMpol-1   )
    irrsurf%tm(1:irrMpol) = zero ; irrsurf%tm(1:irrMpol-1) = -tt(MM-1:MM-irrMpol+1:-1)
    
    DEALLOCATE(ss)
    DEALLOCATE(tt)
    
    exit ! only need the closest approximation; is it possible to extrapolate to the irrational?;
    
   endif
   
  enddo ! end of nc loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item Irrational surfaces are located via a call to \verb+ir00aa+. The irrationalities are selected in input file, 
!latex \be \iotabar=(p_1+\gamma p_2) / (q_1+\gamma q_2), \ee
!latex with $(p_1,q_1,p_2,q_2)=$\verb!pqirr(1:4,n)!.
!latex \item The variable \verb+irrsurf+ is passed through global memory.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  irrsurf%iota = ( p1(lvol) + goldmean * p2(lvol) ) / ( q1(lvol) + goldmean * q2(lvol) )
  
  WCALL(pq01aa,ir00aa(lvol))! NOTE : irrsurf is passed through via common module;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(munit+myid,'(i6,2es24.16)')( mm, irrsurf%tm(mm), irrsurf%sm(mm), mm = 0, irrMpol ) ! irrational curve; toroidal harmonics;

  do imn = 1, irrmn ; write(munit+myid,'(2i6,2es23.15)')irrim(imn), irrin(imn), irrsurf%Rbc(imn), irrsurf%Zbs(imn) ! irrational surface; cylindrical harmonics;
  enddo

  write(munit+myid,'(es23.15)')irrsurf%tflux
    
  close(munit+myid) ! this file is opened above;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pq01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

1003 format("pq01aa : "9x"  : iv="i3" ; inner transform="f9.5" ="f9.5" +"es10.2" ; outer transform="f9.5" ="f9.5" +"es10.2" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pq01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
