!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Reads/writes vector potential from .AtAz.xxxx files.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ra00aa( lvol, writeorread ) 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2
  use numerical, only : vsmall
  use fileunits, only : ounit, aunit
  use inputlist, only : Wra00aa, ext, Mpol, Ntor, Nofe, Ni
  use cputiming, only : Tra00aa
  use allglobal, only : myid, ncpu, cpus, mn, im, in, ss, doAt, doAz, svol
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER  , intent(in) :: lvol
  CHARACTER, intent(in) :: writeorread
  
  LOGICAL               :: exist                                
  
  INTEGER               :: imp, imn, ip                         ! for writing "new" harmonics;
  INTEGER               :: lmn, lNofe, lNi, jmn, jp, lm, ln, lp ! for reading "old" harmonics;
  INTEGER               :: itz
  
  INTEGER               :: ie01bef, ie01bff, pNi, plNi          ! required for NAG interpolation routines;
  
  REAL, allocatable     :: lss(:), lAt(:), lAz(:), lAd(:)       ! local arrays for reading and interpolating;
  
 !CHARACTER             :: suf*4                                ! output file identification suffix;
  
  BEGIN(ra00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(svol,'(i4.4)')lvol ! labels volume;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case( writeorread )
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  case( 'W' ) ! write vector potential harmonics to file;
   
   if( Wra00aa ) then
    cput = MPI_WTIME() ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; writing vector potential to .ext.AtAz."a4" ;")')cput-cpus,myid,lvol,svol
   endif
   
   open(aunit+myid,file="."//trim(ext)//".AtAz."//svol,status="replace",form="unformatted")
   write(aunit+myid) mn, Nofe, Ni(lvol)
   write(aunit+myid) ss(lvol)%s(0:Ni(lvol))
   do imp = 0, 2
    do imn = 1, mn ! loop over Fourier harmonics;
     do ip = 0, Nofe ! loop over derivatives;
      write(aunit+myid) im(imn), in(imn), ip
      write(aunit+myid) doAt(imp,lvol,imn,ip)%s(0:Ni(lvol))
      write(aunit+myid) doAz(imp,lvol,imn,ip)%s(0:Ni(lvol))
     enddo
    enddo
   enddo
   close(aunit+myid)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  case( 'R' ) ! read potential from file; interpolate onto new radial grid;

   cput = MPI_WTIME()
   
   inquire(file=".AtAz."//svol,exist=exist)   
   if( .not.exist ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; .AtAz.xxxx does not exist ;")')cput-cpus,myid,lvol ; goto 9998
   endif
   
   open(aunit+myid,file=".AtAz."//svol,status="old",form="unformatted",iostat=ios) ! this will contain initial guess for vector potential;
   if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; opening .AtAz.xxxx ;")')cput-cpus,myid,lvol ; goto 9997
   endif
   
   read(aunit+myid,iostat=ios) lmn, lNofe, lNi ! these are the "old" resolution parameters;
   if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; reading lmn, lNofe, lNi ;")')cput-cpus,myid,lvol ; goto 9997
   endif
   
   RALLOCATE(lss,(0:lNi)) ! local, temporary array; for reading radial coordinate;
   
   read(aunit+myid,iostat=ios) lss(0:lNi) ! "old" radial coordinate; required for interpolation;
   if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; reading lss(0:lNi) ;")')cput-cpus,myid,lvol ; goto 9996
   endif

   if( minval(ss(lvol)%s(0:Ni(lvol))).lt.minval(lss(0:lNi))-vsmall .or. maxval(ss(lvol)%s(0:Ni(lvol))).gt.maxval(lss(0:lNi))+vsmall ) then
    write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; new radial coordinate outside old domain ;")')cput-cpus,myid,lvol ; goto 9996
   endif
   
   RALLOCATE(lAt,(0:lNi)) ! local, temporary array; for reading data;
   RALLOCATE(lAz,(0:lNi)) ! local, temporary array; for reading data;   
   
   RALLOCATE(lAd,(0:lNi)) ! local, temporary array; for interpolation;
   
   do imp = 0, 2
    do jmn = 1, lmn ! loop over "old" Fourier harmonics;
     do jp = 0, lNofe ! loop over "old" derivatives;
      
      read(aunit+myid,iostat=ios) lm, ln, lp ! "old" mode & derivative identification;
      if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; reading lm, ln, lp ;")')cput-cpus,myid,lvol ; goto 9995
      endif
      
      read(aunit+myid,iostat=ios) lAt(0:lNi) ! "old" At;
      if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; reading lAt(0:lNi) ;")')cput-cpus,myid,lvol ; goto 9995
      endif
      
      read(aunit+myid,iostat=ios) lAz(0:lNi) ! "old" Az;
      if( ios.ne.0 ) then ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; error ; reading lAz(0:lNi) ;")')cput-cpus,myid,lvol ; goto 9995
      endif
      
      do imn = 1, mn ! loop over "new" Fourier harmonics;
       do ip = 0, Nofe ! loop over "new" derivatives;
        
        if( im(imn).eq.lm .and. in(imn).eq.ln .and. ip.eq.lp ) then ! and "old" Fourier harmonic matches a "new" Fourier harmonic; interpolate onto "new" radial grid;
         
         plNi = lNi + 1 ; pNi = Ni(lvol) + 1
         
         do itz = 1, 2

          ie01bef = 1
          if( itz.eq.1 ) call E01BEF( plNi, lss(0:lNi), lAt(0:lNi), lAd(0:lNi)                                                                  , ie01bef )
          if( itz.eq.2 ) call E01BEF( plNi, lss(0:lNi), lAz(0:lNi), lAd(0:lNi)                                                                  , ie01bef )
          
          cput = MPI_WTIME()
          select case( ie01bef )
          case(0) ; 
          case(1) ; write(ounit,'("ra00aa : "f10.2" : ie01bef="i3" ; on entry to E01BEF, N<2 ;                ")')cput-cpus,ie01bef
          case(2) ; write(ounit,'("ra00aa : "f10.2" : ie01bef="i3" ; on entry to E01BEF, X is not increasing ;")')cput-cpus,ie01bef
          case default ; FATALMESS(ra00aa,.true.,illegal ifail returned by E01BEF)
          end select

          ie01bff = 1
          if( itz.eq.1 ) call E01BFF( plNi, lss(0:lNi), lAt(0:lNi), lAd(0:lNi), pNi, ss(lvol)%s(0:Ni(lvol)), doAt(imp,lvol,imn,ip)%s(0:Ni(lvol)), ie01bff )
          if( itz.eq.2 ) call E01BFF( plNi, lss(0:lNi), lAz(0:lNi), lAd(0:lNi), pNi, ss(lvol)%s(0:Ni(lvol)), doAz(imp,lvol,imn,ip)%s(0:Ni(lvol)), ie01bff )
          
          cput = MPI_WTIME()
          select case( ie01bff )
          case(0) ; 
          case(1) ; write(ounit,'("ra00aa : "f10.2" : ie01bff="i3" ; on entry to E01BFF, N<2 ;                ")')cput-cpus,ie01bff
          case(2) ; write(ounit,'("ra00aa : "f10.2" : ie01bff="i3" ; on entry to E01BFF, X is not increasing ;")')cput-cpus,ie01bff
          case(3) ; write(ounit,'("ra00aa : "f10.2" : ie01bff="i3" ; on entry to E01BFF, M<1 ;                ")')cput-cpus,ie01bff
          case(4) ; write(ounit,'("ra00aa : "f10.2" : ie01bff="i3" ; on entry to E01BFF, X outside range ;    ")')cput-cpus,ie01bff
          case default ; FATALMESS(ra00aa,.true.,illegal ifail returned by E01BFF)
          end select

         enddo ! end of do itz = 1, 2

        endif ! end of if "old" mode matches "new" mode;
        
       enddo ! end of ip loop over "new" derivatives;
      enddo ! end of imn loop over "new" harmonics;
      
      
     enddo ! end of do jp loop over "old" derivatives;
    enddo ! end of do jmn loop over "old" derivatives;
    
   enddo ! end of do imp = 0, 2;
   
   
   if( Wra00aa ) then
    cput = MPI_WTIME() ; write(ounit,'("ra00aa : "f10.2" : myid="i3" ; lvol="i3" ; vector potential read from .AtAz ;")')cput-cpus,myid,lvol
   endif
   
    
9995 continue
    
    DEALLOCATE(lAt)
    DEALLOCATE(lAz)
    DEALLOCATE(lAd)
    
9996 continue
   
   DEALLOCATE(lss)   
   
9997 continue
   
   close(aunit+myid)
   
9998 continue

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
  case default
   
   FATALMESS(ra00aa,.true.,invalid writeorread flag supplied on input)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ra00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ra00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
